Package: rifiComparative
Title: 'rifiComparative' compares the output of rifi from two different
        conditions.
Version: 1.13.0
Authors@R: c(person("Loubna", "Youssar",
      email = "lyoussar@gmail.com",
      role = c("aut", "cre")),
      person("Jens", "Georg",
      email = "jens.georg@biologie.uni-freiburg.de",
      role = "aut", "cre"))
Description: 'rifiComparative' is a continuation of rifi package. It compares two conditions output of rifi using half-life and mRNA at time 0 segments. As an input for the segmentation, the difference between half-life of both condtions and log2FC of the mRNA at time 0 are used. The package provides segmentation, statistics, summary table, fragments visualization and some additional useful plots for further anaylsis. 
Depends: R (>= 4.2)
Imports: cowplot, doMC, parallel, dplyr, egg, foreach, ggplot2,
        ggrepel, graphics, grDevices, grid, methods, nnet, rlang,
        S4Vectors, scales, stats, stringr, tibble, rtracklayer, utils,
        writexl, DTA, LSD, reshape2, devtools, SummarizedExperiment
Suggests: DescTools, knitr, rmarkdown, BiocStyle
VignetteBuilder: knitr
biocViews: RNASeq, DifferentialExpression, GeneRegulation,
        Transcriptomics, Microarray, Software
BugReports: https://github.com/CyanolabFreiburg/rifiComparative
Config/Bioconductor/UnsupportedPlatforms: windows
License: GPL-3 + file LICENSE
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.3
Language: en-US
git_url: https://git.bioconductor.org/packages/rifiComparative
git_branch: devel
git_last_commit: 19caa92
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:46:07 UTC; biocbuild
Author: Loubna Youssar [aut, cre],
  Jens cre Georg [aut]
Maintainer: Loubna Youssar <lyoussar@gmail.com>

# RifiComparative

## About

RifiComparative is a workflow for a comparative data, output of Rifi framework (<https://github.com/CyanolabFreiburg/rifi>). RifiComparative compares two outputs from 2 different conditions of the same organism. The rifi outputs are different from one condition to other depending on the transcriptome regulation. We end up with segments with different length, position and events making a direct comparative of 2 conditions nearly impossible (Figure. 1). To solve this issue, we come up with a strategy (Figure. 2). The data from both conditions are gathered together and a segmentation of half-life and mRNA at time 0 of both conditions is applied. The absolute value of half-life difference at probe level is used as input for half-life segmentation on one hand and the fold-change of mRNA at time 0 is used as input for segmentation of intensity on other hand. Differently to rifi, no hierarchy is applied (Figure. 3). As for rifi, a sub-set of the data is trained preliminary to get the best set of penalties and for segmentation usage. After segmentation, the fragments are statistically tested and a p_value is assigned. To make a consistent comparison the fragments from half-life and mRNA at time 0 are adjusted to each other. We end-up with a single fragment length for both parameters (Figure. 4). Each fragment has the corresponding annotation on the genome. The half-life, intensity fragments, the TUs from each condition, events as termination and iTSS_II and the genome annotation could be plotted (Figure. 5). The package provides a serie of plots to facilitate the analysis. Figure. 6 and 7 show decay rate versus synthesis rate. Some points of interest could be colored or labeled using the segment annotation.


<br/>

<p align="center">

<img src="https://github.com/CyanolabFreiburg/rifiComparative/blob/main/vignettes/rifiComparative_workflow.png"/>

</p>

<sub> <b>Figure 1:</b> rifi Comparative workflow. Four major steps are depicted. 1) Gathering the data from two conditions, 2) penalties set, 3) segmentation, 4) adjusting the fragments to each other, 5) genome visualization together with the fragment. </sub>

<br/>

<p align="center">

<img src="https://github.com/CyanolabFreiburg/rifiComparative/blob/main/vignettes/Half-life_Fragments_two_conditions.png"/>

</p>

<sub> <b>Figure 2:</b> Segments output of Rifi. The segments are very different making the comparison nearly impossible. </sub>

<br/>

<p align="center">

<img src="https://github.com/CyanolabFreiburg/rifiComparative/blob/main/vignettes/Half-life_difference.png"/>

</p>

<sub> <b> Figure 3:</b> Half-life difference. Difference between Half-life from both conditions is calculated by bin or probe (distance = abs(diff(half-life(cdt 1)(Pi) - half-life(cdt 2)(Pi)))). cdt = condition and Pi = position i. </sub>

<br/>

<p align="center">

<img src="https://github.com/CyanolabFreiburg/rifiComparative/blob/main/vignettes/adjusting_fragments.png"/>

</p>

<sub> <b> Figure 4:</b> Adjusting half-life and intensity to each other. The adjustment was applied only if at least one fragment has a significant p_value. Numbers are just fragments indicator.</sub>

<br/>

<p align="center">

<img src="https://github.com/CyanolabFreiburg/rifiComparative/blob/main/vignettes/Decay_rate_vs_Synthesis_rate.png" alt="drawing" width="400"/>

</p>

<sub> <b> Figure 5:</b> Plot changes in RNA decay rates (log fold, x-axis) versus the changes in RNA synthesis rates (log fold, y-axis) in the condition 1 versus condition 2. The black lines horizontal, vertical and diagonal are the median of synthesis_rate, decay_rate and mRNA at time 0 respectively. Dashed gray lines indicate 0.5-fold changes from 0 (gray lines) referring to unchanged fold. The points highlighted with yellow color show a decay rate \>= .5 and synthesis rate \<= -.5. </sub>

<br/>

<p align="center">

<img src="https://github.com/CyanolabFreiburg/rifiComparative/blob/main/vignettes/heatscatter_Decay_rate_vs_Synthesis_rate.png" alt="drawing" width="600"/>

</p>

<sub> <b> Figure 6:</b> Plot of the changes in RNA decay rates (log fold, x-axis) versus the changes in RNA synthesis rates (log fold, y-axis) in the condition 1 versus condition 2. The coloring indicates the local point density. </sub>

# Installation

### Dependencies

RifiComparative package only available for Unix systems and has the following dependencies. Make sure the requirements are satisfied by your system.

[devtools](https://rdocumentation.org/packages/devtools/versions/2.4.3)(\>= 2.4.3)

[roxygen2](https://cran.r-project.org/web/packages/roxygen2/index.html)(\>= 7.1.2)

[SummarizedExperiment](https://bioconductor.org/packages/release/bioc/html/SummarizedExperiment.html)(\>= 1.24.0)

[dplyr](https://rdocumentation.org/packages/dplyr/versions/0.7.8) (\>= 0.7.8)

[LSD](https://www.rdocumentation.org/packages/ScottKnott/versions/1.3-0/) (\>= 1.3.0)

[ggplot2](https://ggplot2.tidyverse.org/) (\>= 3.3.5)

[writexl](https://www.rdocumentation.org/packages/writexl/versions/1.4.0/) (\>= 1.4.0)

[egg](https://www.rdocumentation.org/packages/scales/versions/0.4.1) (\>= 0.4.1)

[data.table](https://www.rdocumentation.org/packages/msSPChelpR/versions/0.8.7/) (\>= 0.8.7)

[ggrepel](https://www.rdocumentation.org/packages/ggrepel/versions/0.9.1/) (\>= 0.9.1)

[stats](https://rdocumentation.org/packages/stats/versions/3.6.2) (\>= 3.6.2)

[grid](https://www.rdocumentation.org/packages/graphics/versions/3.6.2/topics/grid) (\>= 3.6.2)

[rtracklayer](https://www.rdocumentation.org/packages/rtracklayer/versions/1.32.1) (\>= 1.32.1)

[reshape2](https://rdocumentation.org/packages/reshape2/versions/1.4.4) (\>= 1.4.4)

[utils](https://rdocumentation.org/packages/utils/versions/3.6.2) (\>= 3.6.2)

[DTA](https://rdocumentation.org/packages/DTA/versions/2.18.0)(\>= 2.18.0)

[cowplot](https://rdocumentation.org/packages/cowplot/versions/1.1.1)(\>= 1.1.1)

[doMC](https://cran.r-project.org/web/packages/doMC/index.html) (\>= 1.3.7)

[parallel](https://rdocumentation.org/packages/parallel/versions/3.6.2) (\>= 3.6.2)

[graphics](https://rdocumentation.org/packages/graphics/versions/3.6.2) (\>= 3.6.2)

[stats](https://rdocumentation.org/packages/stats/versions/3.6.2) (\>= 3.6.2)

[stringr](https://www.rdocumentation.org/packages/stringr/versions/1.4.0) (\>= 1.4.0)

[grDevices](https://rdocumentation.org/packages/grDevices/versions/3.6.2) (\>= 3.6.2)

[tibble](https://rdocumentation.org/packages/tibble/versions/3.1.6) (\>= 3.1.6)

[methods](https://rdocumentation.org/packages/methods/versions/3.6.2) (\>= 3.6.2)

### To install from Bioconductor, use the following code:

``` html
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
    
BiocManager::install("rifiComparative")
```

### To install directly from github:

``` html
install_github('rifiComparative')
```

# Troubleshooting

contact [lyoussar\@gmail.com](mailto:lyoussar@gmail.com) or create an issue

# =========================================================================
#  penalties           
# -------------------------------------------------------------------------
#' penalties wraps conveniently all penalty steps
#' 
#' penalties finds the best set of penalties for half-life and intensity
#' fragmentation using dynamic programming. The segmentation of the HL uses the
#' difference between 2 conditions and the segmentation of the intensity uses 
#' the log2FC. 
#' 
#' The function uses 4 functions: 
#' 
#' score_fun_ave.r
#' 
#' make_pen.r
#' 
#' fragment_HL_pen.r
#' 
#' fragment_inty_pen.r
#'
#' @param data data frame with the joined columns from differential 
#' expression and output of rifi_stats.
#' @param cores integer: the number of assigned cores for the task. It needs to 
#' be increased in case of big data.
#' 
#' @return A list of data frame and penalties, The first element is data frame
#' with 2 more variables, second and third are HL and intensity penalties
#' respectively.
#'
#' @examples
#' data(df_comb_minimal) 
#' penalties_df <- penalties(df_comb_minimal)[[1]]
#' pen_HL <- penalties(df_comb_minimal)[[2]]
#' pen_int <- penalties(df_comb_minimal)[[3]]
#' @export


penalties <- function(data, cores = 2){
# calculate the difference of half-life from both conditions. 
# difference is referred to distance 

    data[,"distance_HL"] <-
        data[, "half_life.cdt1"] - data[, "half_life.cdt2"]
    
# find the best penalties set for half-life fragmentation using dynamic
# programming on half-life distance 

    pen_HL <- make_pen(
        probe = data,
        FUN = fragment_HL_pen,
        cores = cores,
        logs = as.numeric(rep(NA, 8)),
        dpt = 1,
        smpl_min = 10,
        smpl_max = 50,
        sta_pen = 0.5,
        end_pen = 4.5,
        rez_pen = 9,
        sta_pen_out = 0.5,
        end_pen_out = 3.5,
        rez_pen_out = 7
    )
    
    ##DP for log2FC(intensity) penalties
    #add log2FC(intensity) to the data frame
    data[,"distance_int"] <- data[,"logFC_int"]
    
    # dynamic programming on log2FC(intensity) to find the best penalties
    pen_int <- make_pen(
        probe = data,
        FUN = fragment_inty_pen,
        cores = cores,
        logs = as.numeric(rep(NA, 8)),
        dpt = 1,
        smpl_min = 10,
        smpl_max = 50,
        sta_pen = 0.5,
        end_pen = 4.5,
        rez_pen = 9,
        sta_pen_out = 0.5,
        end_pen_out = 3.5,
        rez_pen_out = 7
    )
    return(list(data, pen_HL, pen_int))
}

#in case the dataframe from the positive strand is empty, a dataframe is
#created to be plotted for the genome annotation.
empty_data_negative <- function(data_n,
                                frag,
                                i,
                                axis_title_y_size = axis_title_y_size,
                                axis_text_y_size = axis_text_y_size,
                                Limit = Limit) {
  message(paste0(i, ": no data on negative strand"))
  df2_f <- data.frame(matrix(NA, nrow = 1, ncol = ncol(data_n)))
  colnames(df2_f) <- colnames(data_n)
  df2_f$ID <- "ID_fake"
  df2_f$position <- frag[i]
  df2_f$strand <- "-"
  df2_f$delay <- .01
  df2_f$half_life <- .01
  df2_f$intensity <- 1000
  Title <- NA

  #generate empty data
  p4 <-
    ggplot(df2_f, aes(x = get('position'), y = get('intensity'))) +
    scale_x_continuous(limits = c(frag[i], frag[i + 1])) +
    scale_y_continuous(
      trans = 'log2',
      labels = label_log2_function,
      limits = c(NA, NA),
      sec.axis = sec_axis( ~ . * 1, name = "Coverage [A.U]")
    ) +
    labs(y = "Intensity [A.U]") +
    theme_bw() +
    background_grid(major = "xy", minor = "none") +
    theme(
      legend.title = element_blank(),
      legend.position = "none",
      axis.title.y = element_text(colour = 5, size = axis_title_y_size),
      axis.text.x = element_blank(),
      axis.text.y = element_text(
        angle = 90,
        hjust = 1,
        size = axis_text_y_size
      ),
      axis.title.x = element_blank(),
      axis.ticks.x = element_blank(),
      panel.grid.major.x = element_blank(),
      panel.grid.minor.x = element_blank(),
      plot.margin = margin(.1, .2, .1, .2, "cm"),
      panel.border = element_blank()
    )
  p5 <-
    ggplot(df2_f, aes(x = get('position'), y = get('half_life'))) +
    scale_x_continuous(limits = c(frag[i], frag[i + 1])) +
    scale_y_continuous(
      limits = c(0, 10),
      breaks = seq(0, 10, by = 2),
      sec.axis = sec_axis( ~ . * 1, name = "Half-life [min]", breaks =
                             seq(0, Limit, by = 2))
    ) +
    labs(y = "Half-life [min]") +
    theme_bw() +
    background_grid(major = "xy", minor = "none") +
    theme(
      legend.title = element_blank(),
      legend.position = "none",
      axis.title.y = element_text(colour = 6, size = axis_title_y_size),
      axis.text.x = element_blank(),
      axis.text.y = element_text(
        angle = 90,
        hjust = 1,
        size = axis_text_y_size
      ),
      axis.title.x = element_blank(),
      axis.ticks.x = element_blank(),
      panel.grid.major.x = element_blank(),
      panel.grid.minor.x = element_blank(),
      plot.margin = margin(.1, .2, .1, .2, "cm"),
      panel.border = element_blank()
    )
    Title <- NA
  p <- list(p5, p4, Title)
  return(p)
}

genomeSize <- function(path){
    inp <- readLines(path)
    #grep the line containing the genome length
    ge_size <- inp[grep("##sequence-region", inp)]
    #replace "\t" in the end of the line
    ge_size <- gsub("\t", "", ge_size)
    #extract the genome size
    ge_size <- as.numeric(last(unlist(strsplit(ge_size, "\\s+"))))
    return(ge_size)
}

# =========================================================================
# joining_data_column          
# -------------------------------------------------------------------------
#' joining_data_column joins two data frames by column
#'
#''joining_data_column': joins two data frames from different conditions by
#' column.
#'
#' @param data data frame with joined columns from both conditions
#'
#' @return The data frame with joined columns from both conditions with the 
#' corresponding columns: strand, position, ID, intensity.cdt1, position_segment,
#' half_life.cdt1, TI_termination_factor.cdt1", HL_fragment.cdt1, 
#' intensity_fragment.cdt1, TI_termination_fragment.cdt1, logFC_int, P.Value, 
#' intensity.cdt2, half_life.cdt2, TI_termination_factor.cdt2, HL_fragment.cdt2,
#' intensity_fragment.cdt2, TI_termination_fragment.cdt2.
#' 
#' cdt1: first condition, cdt2: second condition.
#'
#' @examples
#' data(data_combined_minimal)
#' df_comb_minimal <- joining_data_column(data = data_combined_minimal)
#' 
#' @export

joining_data_column <- function(data){
    sta_cdt1 <- data %>%
        filter(cdt == "cdt1")
    sta_cdt1 <- sta_cdt1[, -c(4, 6, 7, 9, 12:15, 17, 19:20, 22:47)]
    sta_cdt2 <- data %>%
        filter(cdt == "cdt2")
    sta_cdt2 <- sta_cdt2[, -c(4, 6, 7, 9, 12:15, 17, 19:20, 22:49)]
    df_comb <- full_join(
        sta_cdt1,
        sta_cdt2,
        by = c("position", "strand",
               "ID", "position_segment"),
        suffix = c(".cdt1", ".cdt2")
    )
    return(df_comb)
} 

#' =============================================================================
#' rifiComparative
#' -----------------------------------------------------------------------------
#' rifiComparative a successor package of rifi. It compares 2 rifi outputs from 
#' 2 different conditions of the same organism.
#'
#' rifiComparative was developed to compare 2 rifi outputs from 2 conditions. 
#' The rifi output may differ significantly from 2 conditions. The complexity of
#' the segments number, position, length and the events make the comparison 
#' between 2 conditions nearly impossible. rifiComparative uses a simple strategy 
#' to generate single segments for both conditions, extract the features and 
#' make them comparable.
#' 
#' Five major steps ate described in rifiComparative:
#' 
#' 1. Joining data
#' 2. penalties
#' 3. fragmentation
#' 4. statistics
#' 5. visualization
#'
#' @import dplyr
#' @import ggplot2
#' @import SummarizedExperiment
#' @import scales
#' @import writexl
#' @import DTA
#' @import ggrepel
#' @import LSD
#' @author Loubna Youssar \email{lyoussar@@gmail.com}
#' @author Jens Georg \email{jens.georg@@biologie.uni-freiburg.de}
#' @name rifiComparative
#' @docType package
#' 
#' 
NULL

plot_heatscatter <- function(data) {
    
    colnames(data)[11:13] <- c("fc_dr", "ratio_dr_ss", "fc_sr")
    
    png("mRNA_Synthesis-Decay_Compensation.png", 1200, 900, res = 200)
    
    h <- heatscatter(
        data$fc_dr,
        data$fc_sr,
        ylab = "log2 (Synthesis rate fold Fe-/Fe+)",
        xlab = "log2 (Decay rate fold Fe-/Fe+)",
        xlim = c(-3, 3),
        ylim = c(-3, 3),
        add.contour = TRUE,
        cor = TRUE,
        daltonize = TRUE,
        cvd = "d",
        size = TRUE,
        separate = TRUE,
        add.quartiles = TRUE,
        simulate = FALSE,
        colpal = "spectral",
        color.contour = "black",
        main = "Fe- versus Fe+"
    )
    print(h)
    dev.off()
}

# ==============================================================================
# rifi_visualization_comparison      
# ------------------------------------------------------------------------------
# 
#' rifi_visualization_comparison plots the segments and genome annotation
#' 
#' rifi_visualization_comparison plots the genome annotation, half-life 
#' difference (HL), log2FC(intensity) fragments. It uses several functions to
#' plot TUs and genes including small-RNAs. Additionally it plots the
#' statistical t-test between the neighboring fragment, significant p-values
#' from t-test are assigned with '*'.
#' 
#' The functions used are:
#' 
#' strand_selection: plots HL, intensity fragments from both strands.
#' 
#' splitGenome_function: splits the genome into fragments.
#' 
#' annotation_plot_comp: plots the corresponding annotation.
#' 
#' indice_function: assign a new column to the data to distinguish between
#' fragments, outliers from delay or HL or intensity.
#' 
#' empty_data_positive: plots empty boxes in case no data is available for
#' positive strand
#' 
#' empty_data_negative: plots empty boxes in case no data is available for
#' negative strand
#' 
#' TU_annotation: designs the segments border for the genes and TUs annotation.
#' 
#' gene_annot_function: it requires gff3 file, returns a dataframe adjusting
#' each fragment according to its annotation. It allows as well the plot of
#' genes and TUs shared into two pages.
#' 
#' secondaryAxis: adjusts the half-life or delay to 20 in case of the dataframe
#' row numbers is equal to 1 and the half-life or delay exceed the limit, 
#' they are plotted with different shape and color.
#' 
#' my_arrow: creates an arrow for the annotation.
#' 
#' arrange_byGroup: selects the last row for each segment and add 40 nucleotides
#' in case of negative strand for a nice plot.
#' 
#'  my_segment_T: plots terminals and pausing sites labels.
#'
#' @param data dataframe: the probe based dataframe with joined columns.
#' @param data_c dataframe: the probe based dataframe with joined rows.
#' @param condition string: assigned as cdt1 (condition 1) and cdt2 
#' (condition2), it could be adapted to any name.
#' @param Strand string: either ("+" or "-").
#' @param scaling_TU vector: values to adjusted termination and iTSSs to TUs.
#' @param iTSS_threshold integer: threshold for iTSS_II selected to plot,
#' default 1.2.
#' @param termination_threshold integer: threshold for termination to plot,
#' default .8.
#' @param genomeLength integer: genome length output of gff3_preprocess
#' function.
#' @param annot dataframe: the annotation file.
#' @param region dataframe: gff3 features of the genome.
#' @param color_region string vector: vector of colors.
#' @param color_TU string: TU colors
#' @param fontface integer: value assigning labels font
#' @param color_text.1 string: TU color text
#' @param color_text.2 string: genes color text
#' @param size_tu integer: TU size
#' @param size_locusTag integer: locus_tag size
#' @param Limit integer: value for y-axis limit.
#' @param shape integer: value for shape.
#' @param color_TU string. TU color
#' @param face string: label font.
#' @param tick_length integer: value for ticks.
#' @param arrow.color string: arrows color.
#' @param col_above20 string: color for probes/bin above value 20.
#' @param fontface integer: font type
#' @param shape_above20 integer: shape for probes/bins above value 20.
#' @param axis_text_y_size integer: text size for y-axis.
#' @param axis_title_y_size integer: title size for y-axis.
#' @param Alpha integer: color transparency degree.
#' @param size_gene integer: font size for gene annotation.
#' @param p_value_manova integer: p_value of manova test fragments to plot,
#' default 0.05.
#'
#' @return The plot.
#'
#' @examples
#' data(data_combined_minimal)
#' data(stats_df_comb_minimal)
#' data(annot_g)
#' rifi_visualization_comparison(
#'     data = data_combined_minimal,
#'     data_c = stats_df_comb_minimal,
#'     genomeLength = annot_g[[2]],
#'     annot = annot_g[[1]]
#'     ) 
#'     
#' @export


rifi_visualization_comparison <-
    function(data,
             data_c,
             genomeLength = annot_g[[2]],
             annot = annot_g[[1]],
             condition = c("cdt1", "cdt2"),
             Strand = c("+", "-"),
             region = c("CDS", "asRNA", "5'UTR", "ncRNA", "3'UTR", "tRNA"),
             color_region = c(
                 "grey0",
                 "red",
                 "blue",
                 "orange",
                 "yellow",
                 "green",
                 "white",
                 "darkseagreen1",
                 "grey50",
                 "black"
             ),
             color_TU = c("cyan", "yellow", "orange"),
             scaling_TU = c(0, 3.4, 6.6),
             color_text.1 = "grey0",
             color_text.2 = "black",
             Alpha = 0.5,
             size_tu = 1.6,
             size_locusTag = 1.6,
             size_gene = 1.6,
             Limit = 10,
             shape = 22,
             face = "bold",
             tick_length = .3,
             arrow.color = "darkseagreen1",
             col_above20 = "#00FFFF",
             fontface = "plain",
             shape_above20 = 14,
             axis_text_y_size = 3,
             axis_title_y_size = 6,
             iTSS_threshold = 1.2,
             p_value_manova = 0.05,
             termination_threshold = 0.8
    ) {
        
        ##########################data preparation#############################
        #II. input for the main features split into 2 data frames according to
        #strand orientation
        tmp.1 <- strand_selection(data, "+")
        tmp.2 <- strand_selection(data, "-")
        tmp.3 <- strand_selection(data_c, "+")
        tmp.4 <- strand_selection(data_c, "-")  
        #split the genome into fragments
        gLength <- seq_len(genomeLength)
        names(gLength) <- seq_along(gLength)
        fl <- floor(gLength / 10000)
        frag <- splitGenome_function(x = fl, gLength = gLength)
        
        #################################plot###############################
        #IV. the general plot
        pdf.options(
            onefile = TRUE,
            width = 8,
            height = 5.3
        )
        pdf("genome_fragments_comparison.pdf")
        suppressWarnings(message(for (i in seq_len(length(frag) - 1)) {
            p <- list()
            p.1 <- list()
            print(i)
            if (i == 1) {
                frag[i] <- 0
            } else if (i == (length(frag) - 1)) {
                #to have homogeneous annotation scaling, 10000 is added to the last frag vector
                frag[i + 1] <- frag[i] + 10000
            }
            #adjust position for genes split on two pages
            pos.1 <- frag[i] - 2000
            pos.2 <- frag[c(i + 1)] + 2000
            ###########################data adjustment###########################
            #define the main dataframe with segments positive strand df1, negative
            #strand df2
            df1 <-
                tmp.1[between(tmp.1$position, frag[i], frag[c(i + 1)]),]
            df2 <-
                tmp.2[between(tmp.2$position, frag[i], frag[c(i + 1)]),]
            df3 <-
                tmp.3[between(tmp.3$position, frag[i], frag[c(i + 1)]),]
            df4 <-
                tmp.4[between(tmp.4$position, frag[i], frag[c(i + 1)]),]
            
            df1_1 <- df1[!is.na(df1$ID),]
            #avoid plot empty pages in case of small data
            if (nrow(df1) == 0 &
                nrow(df2) == 0 & nrow(data) < 10000) {
                next ()
            }
            ##########################annotation section#########################
            # an is the annotation dataframe upon the position on the plot, its 
            # used to loop into exactly the number of region contained in the gff3
            an.1 <-
                annot[between(annot$start, frag[i], frag[c(i + 1)]), ]
            an <- annot[between(annot$start, pos.1, pos.2), ]
            an <- an[!duplicated(an), ]
            #in case of no data nor annotation are available
            if (nrow(an.1) == 0 & nrow(df1) == 0 & nrow(df2) == 0) {
                next ()
            }
         
            p7 <-
                annotation_plot(
                    data_p=df1,
                    data_n=df2,
                    condition = condition,
                    tmp.1,
                    tmp.2,
                    frag,
                    i,
                    an = an,
                    region = region,
                    color_region = color_region,
                    fontface = fontface,
                    color_text.1 = color_text.1,
                    color_TU = color_TU,
                    scaling_TU = scaling_TU,
                    Alpha = Alpha,
                    size_tu = size_tu,
                    termination_threshold =
                        termination_threshold,
                    iTSS_threshold =
                        iTSS_threshold,
                    p_value_manova =
                        p_value_manova,
                    pos.1 = pos.1,
                    pos.2 = pos.2
                )
            
            #########################empty data positive strand#################
            
            if (nrow(df1) == 0) {
                p_positive <- empty_data_positive(
                    data_p = df1,
                    data_n = df2,
                    frag = frag,
                    i = i,
                    axis_title_y_size = axis_title_y_size,
                    axis_text_y_size = axis_text_y_size,
                    Limit = Limit
                )
                p1 <- p_positive[[1]]
                p2 <- p_positive[[2]]
            }
            
            ############################positive_strand_plot####################
            if (nrow(df1) != 0 | nrow(df2) != 0) {
                p_positive <- strand_function(
                    data = data,
                    data_p = df1,
                    data_n = df2,
                    data_p_c = df3,
                    data_n_c = df4,
                    Strand = Strand,
                    condition = condition,
                    frag,
                    i,
                    fontface = fontface,
                    axis_title_y_size = axis_title_y_size,
                    axis_text_y_size = axis_text_y_size
                )
                p1 <- p_positive[[1]]
                p2 <- p_positive[[2]]
                if (nrow(df2) != 0){
                p4 <- p_positive[[3]]
                p5 <- p_positive[[4]]
                }
            }
            #########################empty data reverse strand##################
            if (nrow(df2) == 0) {
                p_negative <- empty_data_negative(
                    data_n = df2,
                    frag = frag,
                    i = i,
                    axis_title_y_size = axis_title_y_size,
                    axis_text_y_size = axis_text_y_size,
                    Limit = Limit
                )
                p5 <- p_negative[[1]]
                p4 <- p_negative[[2]]
            }
            ############################Title and plot##########################
            p <- list(p1, p2, p7, p5, p4)
            egg::ggarrange(
                plots = p,
                ncol = 1,
                nrow = 5,
                heights = c(5, 5, 6, 5, 5)
            )
        }))
        dev.off()
    }

# =========================================================================
#  make_pen                   
# -------------------------------------------------------------------------
#' make_pen assigns automatically penalties
#'
#' make_pen calls one of four available penalty functions to automatically
#' assign penalties for the dynamic programming.
#' The two functions to be called are:  
#' 1. fragment_HL_pen
#' 2. fragment_inty_pen 
#' 
#' The two functions called return the amount of statistically correct and
#' statistically wrong splits at a specific pair of penalties.
#' 'make_pen' iterates over many penalty pairs and picks the most suitable pair
#' based on the difference between wrong and correct splits.
#' The sample size, penalty range and resolution as well as the number of cycles
#' can be customized.
#' The primary start parameters create a matrix with n = rez_pen rows and
#' n = rez_pen_out columns with values between sta_pen/sta_pen_out
#' and end_pen/end_pen_out. The best penalty pair is picked. If dept is bigger
#' than 1 the same process is repeated with a new matrix of the same size
#' based on the result of the previous cycle. Only position segments with length
#' within the sample size range are considered for the penalties to increase
#' run time.
#' 
#'
#' @param probe data frame: data frame combined data by column
#' @param FUN function: one of the four bottom level functions (see details)
#' @param cores integer: the number of assigned cores for the task
#' @param logs numeric vector: the logbook vector.
#' @param dpt integer: the number of times a full iteration cycle is repeated
#' with a more narrow range based on the previous cycle.
#' @param smpl_min integer: the smaller end of the sampling size. 
#' @param smpl_max integer: the larger end of the sampling size. 
#' @param sta_pen numeric: the lower starting penalty. 
#' @param end_pen numeric: the higher starting penalty. 
#' @param rez_pen numeric: the number of penalties iterated within the penalty
#' range. 
#' @param sta_pen_out numeric: the lower starting outlier penalty. 
#' @param end_pen_out numeric: the higher starting outlier penalty. 
#' @param rez_pen_out numeric: the number of outlier penalties iterated within
#' the outlier penalty range. 
#'
#' @return A list with 4 items:
#'     \describe{
#'       \item{logbook:}{The logbook vector containing all penalty information}
#'       \item{penalties:}{a vector with the respective penalty and outlier
#'       penalty}
#'       \item{correct:}{a matrix of the correct splits}
#'       \item{wrong:}{a matrix of the incorrect splits}
#'     }
#'     
#' @examples
#' data(df_comb_minimal)
#' 
#' df_comb_minimal$distance_HL <- df_comb_minimal$half_life.cdt1 -
#' df_comb_minimal$half_life.cdt2
#' 
#' df_comb_minimal$distance_int <- df_comb_minimal$logFC_int
#' 
#' pen_HL <- make_pen(
#'   probe = df_comb_minimal, FUN = rifiComparative:::fragment_HL_pen, 
#'   cores = 2, logs = as.numeric(rep(NA, 8)), dpt = 1, smpl_min = 10, 
#'   smpl_max = 50, sta_pen = 0.5, end_pen = 4.5, rez_pen = 9, sta_pen_out = 0.5,
#'   end_pen_out = 3.5, rez_pen_out = 7
#' )
#' 
#' pen_int <- make_pen(
#'   probe = df_comb_minimal, FUN = rifiComparative:::fragment_inty_pen, 
#'   cores = 2, logs = as.numeric(rep(NA, 8)), dpt = 1, smpl_min = 10, 
#'   smpl_max = 50, sta_pen = 0.5, end_pen = 4.5, rez_pen = 9, sta_pen_out = 0.5,
#'   end_pen_out = 3.5, rez_pen_out = 7
#' )
#' 
#' @export

make_pen <- function(probe,
                     FUN,
                     cores = 1,
                     logs,
                     dpt = 1,
                     smpl_min = 10,
                     smpl_max = 100,
                     sta_pen = 0.5,
                     end_pen = 4.5,
                     rez_pen = 9,
                     sta_pen_out = 0.5,
                     end_pen_out = 3.5,
                     rez_pen_out = 7) {
  num_args <-
    list(
      cores,
      dpt,
      smpl_min,
      smpl_max,
      sta_pen,
      end_pen,
      rez_pen,
      sta_pen_out,
      end_pen_out,
      rez_pen_out
    )
  names(num_args) <-
    c(
      "cores",
      "dpt",
      "smpl_min",
      "smpl_max",
      "sta_pen",
      "end_pen",
      "rez_pen",
      "sta_pen_out",
      "end_pen_out",
      "rez_pen_out"
    )
  res2 <- vector("list", dpt)
  res3 <- vector("list", dpt)
  step_pen <- (end_pen - sta_pen) / (rez_pen - 1)
  step_pen_out <- (end_pen_out - sta_pen_out) / (rez_pen_out - 1)
  pen <- seq(sta_pen, end_pen, step_pen)
  pen_out <- seq(sta_pen_out, end_pen_out, step_pen_out)
  for (i in seq_len(dpt)) {
    correct <- matrix(, length(pen), length(pen_out))
    wrong <- matrix(, length(pen), length(pen_out))
    rownames(correct) <- pen
    colnames(correct) <- pen_out
    rownames(wrong) <- pen
    colnames(wrong) <- pen_out
    for (j in seq_along(pen)) {
      tmp_pen_out <- pen_out[pen_out >= 0.4 * pen[j]]
      for (k in seq_along(tmp_pen_out)) {
        tmp <-
          FUN(probe, pen[j], tmp_pen_out[k], smpl_min, smpl_max, cores = cores)
        correct[j, as.character(tmp_pen_out[k])] <- tmp[[1]]
        wrong[j, as.character(tmp_pen_out[k])] <- tmp[[2]]
      }
    }
    res2[[i]] <- correct
    res3[[i]] <- wrong
    dif <- correct - wrong
    if (any(dif >= wrong, na.rm = TRUE)) {
      ind <-
        which(dif == max(dif[dif >= wrong], na.rm = TRUE), arr.ind = TRUE)[1, ]
    } else {
      ind <- which(dif == max(dif, na.rm = TRUE), arr.ind = TRUE)[1, ]
      warning("no set of penalties suits the criteria, continued with next best
              option")
    }
    sta_pen <- as.numeric(rownames(dif)[ind[1]]) - step_pen
    end_pen <- as.numeric(rownames(dif)[ind[1]]) + step_pen
    sta_pen_out <- as.numeric(colnames(dif)[ind[2]]) - step_pen_out
    end_pen_out <- as.numeric(colnames(dif)[ind[2]]) + step_pen_out
    step_pen <- (end_pen - sta_pen) / (rez_pen - 1)
    step_pen_out <- (end_pen_out - sta_pen_out) / (rez_pen_out - 1)
    pen <- seq(sta_pen, end_pen, step_pen)
    pen_out <- seq(sta_pen_out, end_pen_out, step_pen_out)
    res1 <-
      c(as.numeric(rownames(dif)[ind[1]]), as.numeric(colnames(dif)[ind[2]]))
  }
  logs[c(
    paste0(names(tmp)[1], "_penalty"),
    paste0(names(tmp)[1], "_outlier_penalty")
  )] <- c(res1[1], res1[2])
  names(res1) <- names(tmp)
  res <- list(logs, res1, res2, res3)
  res
}

plot_decay_synt <- function(data) {
    
    colnames(data)[11:13] <- c("fc_dr", "ratio_dr_ss", "fc_sr")
    
    #plot log2FC decay rate vs log2FC synthesis rate highlight some genes of
    #interest.
    png("Decay_rate_vs_Synthesis_rate.png", 900, 900, res = 200)
    
    ds <- data %>%
        ggplot(aes(x = fc_dr, y = fc_sr)) +
        geom_point(col = "magenta", size = .5) +
        geom_point(
            data = . %>% filter(fc_dr >= .5 & fc_sr <= -.5),
            color = "yellow",
            size = .5
        ) +
        
        #synthesis rate
        geom_hline(yintercept = median(na.omit(data$fc_sr)), show.legend = TRUE) +
        geom_hline(
            colour = "grey60",
            linetype = "dashed",
            size = 1,
            yintercept = .5,
            show.legend = TRUE
        ) +
        geom_hline(
            colour = "grey60",
            linetype = "dashed",
            size = 1,
            yintercept = -.5,
            show.legend = TRUE
        ) +
        geom_hline(colour = "grey60",
                   yintercept = 0,
                   show.legend = TRUE) +
        
        #decay rate
        geom_vline(xintercept = median(na.omit(data$fc_dr)), show.legend = TRUE) +
        geom_vline(
            colour = "grey80",
            linetype = "dashed",
            size = 1,
            xintercept = -.5,
            show.legend = TRUE
        ) +
        geom_vline(
            colour = "grey80",
            linetype = "dashed",
            size = 1,
            xintercept = +.5,
            show.legend = TRUE
        ) +
        geom_vline(colour = "grey80",
                   xintercept = 0,
                   show.legend = TRUE) +
        
        #mRNA
        geom_abline(
            intercept = 0.7,
            slope = median(na.omit(data$intensity_FC)),
            show.legend = TRUE
        ) +
        geom_abline(
            colour = "grey70",
            linetype = "dashed",
            size = 1,
            slope = 1,
            intercept = .7,
            show.legend = TRUE
        ) +
        geom_abline(
            colour = "grey70",
            linetype = "dashed",
            size = 1,
            slope = 1,
            intercept = -.7,
            show.legend = TRUE
        ) +
        geom_abline(colour = "grey70", slope = 1) +
        
        scale_y_continuous(breaks = seq(-5, 5, by = 1), limits = c(-5, 5)) +
        scale_x_continuous(breaks = seq(-5, 5, by = 1), limits = c(-5, 5)) +
        labs(x = "log2FC(Decay rate)", y = "log2FC(Synthesis rate)") +
        # geom_text_repel(data = . %>% filter(fc_dr >= .5 & fc_sr <= -.5),
        #                 aes(label=gene), size=4, cex=3,
        #                 arrow = arrow(length = unit(0.01, "npc"),
        #                               type = "closed", ends = "first"),
        #                 colour="blue", segment.colour="blue")+
        theme(panel.background = element_blank())
    print(ds)
    dev.off()
}

# =========================================================================
# loading_fun           
# -------------------------------------------------------------------------
#' loading_fun loads the data of all conditions
#'
#' loading_fun extract outputs from rifi_stats of all conditions and join
#' each data to the differential expression table. The differential gene
#' expression at time 0 needs to be run separately.
#' The columns log2FC, p_value adjusted, position and strand are extracted and
#' saved to a data frame. loading_fun joins the differential gene expression
#' table and the output from rifi statistics into one data frame.
#'
#' @param data1 data frame from rifi_stats of one condition
#' @param data2 data frame from rifi_stats of other condition
#' @param data3 data frame from differential gene expression at time 0
#'
#' @return A list of two data frames with joined columns from differential
#' expression and output of rifi_stats with the corresponding columns: ID with
#' position, strand, intensity, probe_TI, flag, position_segment, delay,
#' half_life, TI_termination_factor, delay_fragment, velocity_fragment,
#' intercept, slope, HL_fragment, HL_mean_fragment, intensity_fragment,
#' intensity_mean_fragment, TU, TI_termination_fragment,
#' TI_mean_termination_factor, seg_ID, pausing_site, iTSS_I, ps_ts_fragment,
#' event_ps_itss_p_value_Ttest, p_value_slope, delay_frg_slope, velocity_ratio,
#' event_duration, event_position, FC_HL, FC_fragment_HL, p_value_HL,
#' FC_intensity, FC_fragment_intensity, p_value_intensity, FC_HL_intensity,
#' FC_HL_intensity_fragment, FC_HL_adapted, synthesis_ratio,
#' synthesis_ratio_event, p_value_Manova, p_value_TI, cdt (condition),
#' logFC_int (log2FC(intensity)), P.Value of log2FC(intensity).
#'
#' @examples
#' data(stats_se_cdt1)
#' data(stats_se_cdt2)
#' data(differential_expression)
#' inp_s <-
#' loading_fun(stats_se_cdt1, stats_se_cdt2, differential_expression)[[1]]
#' inp_f <-
#' loading_fun(stats_se_cdt1, stats_se_cdt2, differential_expression)[[2]]
#' 
#' @export

loading_fun <- function(data1, data2, data3) {
    inp_s <- as.data.frame(rowRanges(data1))
    
    #extract output from rifi_statistics (second condition)
    #set the correct path: setwd("path to the second data")
    inp_f <- as.data.frame(rowRanges(data2))
    
    #set the correct path for the analysis
    #add condition to both dataframes
    inp_s$cdt <- "cdt1"
    inp_f$cdt <- "cdt2"
    
    # Important: intensity of both conditions should be normalized together
    # prior to comparison
    # Run the differential expression at probe or bin level of
    # intensity at time 0. The result is log2FC of both condition
    # Pick-up the columns:  log2FC, p_value adjusted, position and strand
    # call the first 2 columns: logFC_int and P.Value and save the object as dc
    
    # get the differential expression object
    inp_s <-
        left_join(inp_s[, -c(1:4)], data3, by = c("position", "strand"))
    inp_f <-
        left_join(inp_f[, -c(1:4)], data3, by = c("position", "strand"))
    
    return(list(inp_s, inp_f))
}

#' File for imported functions
#' 
#' 
#' @importFrom SummarizedExperiment rowRanges 
#' @importFrom scales alpha
#' @importFrom dplyr filter summarise mutate between full_join left_join
#' @importFrom ggrepel geom_text_repel
#' @importFrom LSD heatscatter
#' @importFrom ggplot2 ggplot
#' @importFrom cowplot background_grid
#' @importFrom reshape2 melt
#' @importFrom doMC registerDoMC
#' @importFrom foreach %dopar% foreach
#' @importFrom graphics abline axis curve legend par points text plot
#' @importFrom grDevices adjustcolor dev.off pdf pdf.options
#' @importFrom utils data
#' @importFrom grid arrow unit textGrob gpar
#' @importFrom stats na.omit nls p.adjust quantile residuals
#' @importFrom stats deviance t.test sd var
#' @importFrom parallel mclapply
#' @importFrom methods is
#' @importFrom rlang is_empty .data
#' @importFrom rtracklayer readGFF
#' @importFrom S4Vectors decode metadata
#' @importFrom stringr str_extract str_split
#' @importFrom tibble add_row
#' @importFrom nnet which.is.max
#' @noRd

# mutate_if left_join full_join last %>% group_by arrange n filter mutate
# right_join between

NULL

p_value_function <- function(data){
    p_value_hl <- na.omit(unique(data[,"p_value_distance_HL"]))
    p_value_int <- na.omit(unique(data[,"p_value_distance_intensity"]))
return(c(p_value_hl, p_value_int))
}

eliminate_outlier_hl <- function(data){
    output <- data[grep(paste0("Dc_\\d+", "$"), data[,"HL_comb_fragment"]),]
    return(output)
}

eliminate_outlier_int <- function(data){
    output <- data[grep(paste0("I_\\d+", "$"),
                        data[,"intensity_comb_fragment"]),]
    return(output)
}

#extract the mean of logged values intensity and the length of the fragments implicated
mean_length_int <- function(data){
    output <- data %>%
        summarise(mean(distance_int), length(unique(intensity_comb_fragment)))
    colnames(output) <- c("mean", "length")
    return(output)
}

#extract the mean of logged values HL and the length of the fragments implicated
mean_length_hl <- function(data){
    output <- data %>%
        summarise(mean(distance_HL_log), length(unique(HL_comb_fragment)))
    colnames(output) <- c("mean", "length")
    return(output)
}

calculating_rate <- function(data){
    #log2FC of decay_rate
    dr <- log2((log(2)/mean(data$half_life.cdt1))/
             (log(2)/mean(data$half_life.cdt2)))
    #log2 FC of steady-state
    int <- log2(mean(data$intensity.cdt1)/
                   mean(data$intensity.cdt2))
    return(list(dr, int))
}

fragment_inty_pen <- function(probe, pen, pen_out, from, to, cores) {
  # I.Preparations: the dataframe is configured and some other variables are
  # assigned

  registerDoMC(cores)

  probe <- probe[with(probe, order(-xtfrm(probe$strand), probe$position)), ]

  probe[probe$strand == "-", ] <- probe[probe$strand == "-", ][
    order(probe[probe$strand == "-", ]$position, decreasing = TRUE), ]

  # In this special version we look at position_segments
  tmp_df <-
    data.frame(
      ID = probe$ID,
      val = probe$distance_int,
      seg = probe$position_segment
    )

  # this is just for safety, nothing should be omitted here
  tmp_df <- na.omit(tmp_df)

  # take log2 to adress noise
  #tmp_df$val <- log2(tmp_df$val)

  unique_seg <- unlist(unique(tmp_df$seg))

  # II. Dynamic Programming: the scoring function is interpreted

  frags <- foreach(k = seq_along(unique_seg)) %dopar% {
    section <- tmp_df[which(tmp_df$seg == unique_seg[k]), ]

    best_frags <- c()
    best_names <- c()

    if (nrow(section) >= from &
      nrow(section) <= to) {
      # the sampling is between 10 and 200

      for (i in 2:nrow(section)) {
        tmp_score <-
          score_fun_ave(section[seq_len(i), "val"],
                        section[seq_len(i), "ID"], pen_out)
        tmp_name <- names(tmp_score)
        if (i > 3) {
          for (j in (i - 1):3) {
            tmp_val <- section[j:i, "val"]
            tmp_ID <- section[j:i, "ID"]
            tmp <-
              score_fun_ave(tmp_val, tmp_ID, pen_out) + pen + best_frags[j - 2]
            tmp_score <- c(tmp_score, tmp)
            tmp_n <- paste0(best_names[j - 2], "|", names(tmp))
            tmp_name <- c(tmp_name, tmp_n)
          }
        }
        pos <- which(tmp_score == min(tmp_score))[1]
        tmp_score <- tmp_score[pos]
        tmp_name <- tmp_name[pos]
        best_frags <- c(best_frags, tmp_score)
        best_names <- c(best_names, tmp_name)
      }
      best_names[length(best_names)]
    }
  }

  # III. Fill the dataframe

  frags <- frags[!(vapply(frags, is.null, logical(1)))]

  if (length(frags) == 0) {
    res1 <- 0
    res2 <- 0
    res <- list(res1, res2)
    names(res) <- c("distance_int", "distance_int_out")
    return(res)
  }

  comp <- foreach(k = seq_along(frags)) %dopar% {
    na <- strsplit(frags[[k]], "\\|")[[1]]

    parts <- vector("list", length = length(na))

    for (i in seq_along(na)) {
      tmp_trgt <- strsplit(na[i], "_")[[1]][1]
      trgt <- strsplit(tmp_trgt, ",")[[1]]
      if (length(strsplit(na[i], "_")[[1]]) == 3) {
        tmp_outl <- strsplit(na[i], "_")[[1]][3]
        outl <- strsplit(tmp_outl, ",")[[1]]
        trgt <- trgt[-which(trgt %in% outl)]
      }
      rows <- match(trgt, probe[, "ID"])

      parts[[i]] <- probe[rows, "distance_int"]
    }
    parts
  }

  p <- c()
  all <- 0

  for (k in seq_along(comp)) {
    all <- all + (length(comp[[k]]) - 1)
    if (length(comp[[k]]) > 1) {
      for (i in seq_len(length(comp[[k]]) - 1)) {
        if (!identical(unique(comp[[k]][[i]]), unique(comp[[k]][[i + 1]]))) {
          tryCatch({
              p_val <- t.test(comp[[k]][[i]], comp[[k]][[i + 1]])$p.value
              p <- c(p, p_val)
            },
            error = function(e) {
            }
          )
        }
      }
    }
  }
  p <- p.adjust(p)
  count <- length(p[which(p < 0.01)])
  res1 <- count
  res2 <- all - count
  res <- list(res1, res2)
  names(res) <- c("distance_int", "distance_int_out")
  res
}

# =========================================================================
# gff3_preprocess    
# -------------------------------------------------------------------------
#'
#' gff3_preprocess processes gff3 file from database
#' 
#' gff3_preprocess processes the gff3 file extracting gene names and locus_tag
#' from all coding regions (CDS). UTRs/ncRNA/asRNA if available, are also
#' extracted. The resulting dataframe contains region, positions, strand, gene 
#' and locus_tag.
#'
#' @param path path: path to the directory containing the gff3 file.
#' 
#' @return A list with 2 items:
#' \describe{
#'   \item{data annotation:}{
#'     \describe{
#'       \item{region:}{String, the region from the gff file}
#'       \item{start:}{Integer, the start of the annotation}
#'       \item{end:}{Integer, the end of the annotation}
#'       \item{strand:}{Boolean, the strand of the annotation}
#'       \item{gene:}{String, the annotated gene name}
#'       \item{locus_tag:}{String, the annotated locus tag}
#'       \item{genome length:}{a numeric vector containing the length of the
#'       genome}
#'     }
#'   }   
#' }
#'
#' @examples
#' gff3_preprocess(
#' path = gzfile(system.file("extdata", "gff_synechocystis_6803.gff.gz", 
#' package = "rifiComparative"))
#' )
#' @export

gff3_preprocess <- function(path) {
  #grep the line containing the genome length
  ge_size <- genomeSize(path)
  #select columns region, start, end, strand and annotation
  inp <- readGFF(path)
  tmp <- inp[, c("type", "start", "end", "strand", "gene", "locus_tag")]
  tmp <-
    tmp[grep("^CDS$|UTR|asRNA|antisense_RNA|ncRNA|^tRNA$",
             tmp$type,
             invert = FALSE), ]
  colnames(tmp)[1] <- "region"
   #replace gene with NA with locus_tag in case NA is not recognized as NA
  tmp[which(tmp$gene == "NA"), "gene"] <-
    tmp[which(tmp$gene == "NA"), "locus_tag"]
  #replace gene with NA with locus_tag
  tmp[is.na(tmp$gene), "gene"] <- tmp[is.na(tmp$gene), "locus_tag"]
  if (length(which(tmp$region %in% "antisense_RNA")) != 0) {
    tmp[which(tmp$region == "antisense_RNA"), "region"] <- "asRNA"
  }
  return(list(tmp, ge_size))
}

#strand_function plots HL and intensity segments of both conditions.

strand_function <-
    function(data,
             data_p,
             data_n,
             data_p_c,
             data_n_c,
             Strand,
             condition,
             frag,
             i,
             fontface,
             axis_text_y_size,
             axis_title_y_size
             ) {
        #first plot for intensity segments
        for (j in seq_along(Strand)) {
            df <- data.frame()
            if (Strand[j] == "+") {
                df <- data_p
                df_c <- data_p_c
            } else{
                df <- data_n
                df_c <- data_n_c
            }
            if (nrow(df) != 0 & nrow(df_c) != 0) {
                p1 <-
                    ggplot(df, aes(x = get('position'))) +
                    scale_x_continuous(limits = c(frag[i], frag[i + 1])) +
                    labs(y = "Intensity [log2FC]") +
                    theme_bw() +
                    background_grid(major = "xy", minor = "none") +
                    theme(
                        legend.title = element_blank(),
                        axis.title.y = element_text(colour = 5,
                                                    size = axis_title_y_size),
                        axis.text.y = element_text(
                            angle = 90,
                            hjust = 1,
                            size = axis_text_y_size
                        ),
                        axis.text.x = element_blank(),
                        axis.title.x = element_blank(),
                        panel.grid.major.x = element_blank(),
                        panel.grid.minor.x = element_blank(),
                        legend.position = "none",
                        plot.margin = margin(.1, .2, .1, .2, "cm"),
                        panel.border = element_blank()
                    )
                
                #######################segment plot###################
                #first plot for half-life segments
                #select segments without outliers
                df <- indice_function(df, "HL_fragment")
                # increase the limit to 20 in case 3 or more probes/bins have a HL
                # above 10
                Limit_h_df1 <-
                    limit_function(df, "half_life", ind = 1)
                if (Limit_h_df1 == 20) {
                    Breaks_h <- seq(0, Limit_h_df1, by = 4)
                } else{
                    Breaks_h <- seq(0, Limit_h_df1, by = 2)
                }
                df1.h <- secondaryAxis(df, "half_life", ind = 1)
                #in case only one bin is available and the HL is above 20
                if (all(df$half_life > 20)) {
                    df$half_life <- 20
                }
                p2 <-
                    ggplot(df, aes(x = get('position'))) +
                    scale_x_continuous(limits = c(frag[i], frag[i + 1])) +
                    labs(y = "Half-life [min]") +
                    theme_bw() +
                    background_grid(major = "xy", minor = "none") +
                    theme(
                        legend.title = element_blank(),
                        legend.position = "none",
                        axis.title.y = element_text(colour = 6,
                                                    size = axis_title_y_size),
                        axis.text.x = element_text(size = 6),
                        axis.title.x = element_blank(),
                        axis.text.y = element_text(
                            angle = 90,
                            hjust = 1,
                            size = axis_text_y_size
                        ),
                        panel.grid.major.x = element_blank(),
                        panel.grid.minor.x = element_blank(),
                        plot.margin = margin(.1, .2, .1, .2, "cm"),
                        panel.border = element_blank()
                    )
                #add the second axis for half-life segments plot
                if (length(unique(df$half_life)) == 1) {
                    if (is.na(unique(df$half_life))) {
                        p2 <- p2 +
                            geom_blank() +
                            scale_y_continuous(
                                limits = c(0, Limit_h_df1),
                                breaks = Breaks_h,
                                sec.axis = sec_axis( ~ . * 1,
                                                     name = "Half-life [min]",
                                                     breaks = Breaks_h)
                            )
                    }
                }
               ######################intensity plot################
                    #add a reference to outliers probes or bins
                    #plot distance and new fragments results of DP of both
                    #conditions
                    df_c <-
                        indice_function(df_c, "intensity_comb_fragment")
                    df1_wo <-
                        meanPosition(df_c %>%
                                         filter(indice==1),
                                     "intensity_comb_fragment")
                    if (nrow(df_c %>% filter(indice == 1)) != 0) {
                        p1 <- p1 +
                            geom_point(
                                data = filter(
                                    df_c,
                                    indice == 1,
                                    distance_int < 0,
                                    distance_int > -5
                                ),
                                aes(x = position, y = distance_int),
                                col = 6,
                                size = .5
                            ) +
                            geom_point(
                                data = filter(
                                    df_c,
                                    indice == 1,
                                    distance_int > 0,
                                    distance_int < 5
                                ),
                                aes(x = position, y = distance_int),
                                col = 4,
                                size = .5
                            ) +
                            geom_line(data =  filter(df_c, indice == 1),
                                      aes(
                                          x = get('position'),
                                          y = get('intensity_mean_comb_fragment'),
                                          col = get('intensity_comb_fragment')
                                      )
                            ) +
                            geom_text(
                                data = df1_wo,
                                aes(
                                    x = get('meanPosi'),
                                    y = get('intensity_mean_comb_fragment'),
                                    label = get('intensity_comb_fragment')
                                ),
                                size = 1.3,
                                check_overlap = TRUE
                            )
                        if (nrow(df_c %>% filter(
                            indice == 1,
                            p_value_distance_intensity < 0.05
                        )) != 0) {
                            if (unique(df_c$strand) == "+") {
                                df_c_mean <- arrange_byGroup(
                                    df_c %>% filter(
                                        indice == 1,
                                        p_value_distance_intensity < 0.05
                                    ),
                                    "intensity_comb_fragment"
                                )
                            } else{
                                df_c_mean <- df_c %>% filter(indice == 1,
                                                             p_value_distance_intensity < 0.05)
                                df_c_mean <-
                                    df_c_mean[!duplicated(df_c_mean$p_value_distance_intensity), ]
                            }
                            p1 <- p1 +
                                geom_text(
                                    data = df_c_mean,
                                    aes(
                                        x = get('position'),
                                        y = get('intensity_mean_comb_fragment')
                                    ),
                                    label = "**",
                                    fontface = fontface,
                                    size = 2,
                                    check_overlap = TRUE
                                )
                            
                        }
                    }
                    if (nrow(df_c %>% filter(get('indice') == 2)) != 0) {
                        p1 <- p1 +
                            geom_point(
                                data = df_c %>%
                                    filter(
                                        get('indice') == 2 & distance_int > 0 &
                                            distance_int < 10
                                    ),
                                aes(x = position, y = distance_int),
                                col = 2,
                                shape = 17,
                                size = .5
                            ) +
                            geom_point(
                                data = df_c %>%
                                    filter(
                                        get('indice') == 2 & distance_int < 0 &
                                            distance_int > -10
                                    ),
                                aes(x = position, y = distance_int),
                                col = 3,
                                shape = 12,
                                size = .5
                            )
                    }
                    #######################HL plot###################
                    #plot distance and new fragments results of DP of both
                    #conditions
                    #dismiss outliers
                    df_c <-
                        indice_function(df_c, "HL_comb_fragment")
                    #add fragment label 
                    df1_wo <-
                        meanPosition(df_c %>%
                                         filter(indice==1),
                                     "HL_comb_fragment")
                    if (nrow(df_c %>% filter(indice == 1)) != 0) {
                        p2 <- p2 +
                            geom_point(
                                data = filter(
                                    df_c,
                                    indice == 1,
                                    distance_HL < 0,
                                    distance_HL < 5
                                ),
                                aes(x = position, y = distance_HL),
                                col = 6,
                                size = .5
                            ) +
                            geom_point(
                                data = filter(
                                    df_c,
                                    indice == 1,
                                    distance_HL > 0,
                                    distance_HL > -5
                                ),
                                aes(x = position, y = distance_HL),
                                col = 4,
                                size = .5
                            ) +
                            geom_line(data =  filter(df_c, indice == 1),
                                      aes(
                                          x = get('position'),
                                          y = get('HL_mean_comb_fragment'),
                                          col = get('HL_comb_fragment')
                                      )
                            )+
                            geom_text(
                                data = df1_wo,
                                aes(
                                    x = get('meanPosi'),
                                    y = get('HL_mean_comb_fragment'),
                                    label = get('HL_comb_fragment')
                                ),
                                size = 1.3,
                                check_overlap = TRUE
                            )
                            
                        if (nrow(df_c %>% filter(p_value_distance_HL < 0.05)) != 0) {
                            if (unique(df_c$strand) == "+") {
                                df_c_mean <- arrange_byGroup(
                                    df_c %>% filter(
                                        indice == 1,
                                        p_value_distance_HL < 0.05
                                    ),
                                    "HL_comb_fragment"
                                )
                            } else{
                                df_c_mean <- df_c %>% filter(indice == 1,
                                                             p_value_distance_HL < 0.05)
                                df_c_mean <-
                                    df_c_mean[!duplicated(df_c_mean$p_value_distance_HL), ]
                            }
                            p2 <- p2 +
                                geom_text(
                                    data = df_c_mean,
                                    aes(
                                        x = get('position'),
                                        y = get('HL_mean_comb_fragment')
                                    ),
                                    label = "**",
                                    fontface = fontface,
                                    size = 2,
                                    check_overlap = TRUE
                                )
                            
                        }
                    }
                    if (nrow(df_c %>% filter(get('indice') == 2)) != 0) {
                        p2 <- p2 +
                            geom_point(
                                data = df_c %>%
                                    filter(
                                        get('indice') == 2 & distance_HL > 0 &
                                            distance_HL < 10
                                    ),
                                aes(x = position, y = distance_HL),
                                col = 2,
                                shape = 17,
                                size = .5
                            ) +
                            geom_point(
                                data = df_c %>%
                                    filter(
                                        get('indice') == 2 & distance_HL < 0 &
                                            distance_HL > -10
                                    ),
                                aes(x = position, y = distance_HL),
                                col = 3,
                                shape = 12,
                                size = .5
                            )
                    }
                
            }
            if (Strand[j] == "+") {
                p <- list(p1, p2)
            } else {
                p4 <- p1 + coord_trans(y = "reverse")
                p5 <- p2 + coord_trans(y = "reverse")
                p.1 <- list(p4, p5)
            }
        }
        p <- c(p, p.1)
        return(p)
    }

plot_volcano <- function(input) {
    ##load data with log2FC intensity by segment
    png("volcano_plot.png", 900, 900, res = 200)
    v <- input %>%
        ggplot(aes(x = logFC_int,
                   y = -log10(P.Value))) +
        geom_point() +
        geom_point(
            data = . %>% filter(-log10(P.Value) > 3 & logFC_int < 0),
            color = "cornflowerblue",
            size = .5
        ) +
        geom_point(
            data = . %>% filter(-log10(P.Value) > 3 & logFC_int > 0),
            color = "firebrick",
            size = .5
        ) +
        labs(x = "log2FC(mRNA)", y = "-log10(P.Value)",
             title = "cdt2 vs. cdt1") +
        theme(title = element_text(face = "bold"))
    print(v)
    dev.off()
}

#plot scatter of HL from both conditions at probe/bin level
plot_scatter <- function(data,
                         y = 30,
                         x = 30,
                         limits = c(0, 20)) {
    png("scatter_plot_HL.png", 900, 900, res = 200)
    
    s <- ggplot(data, aes(x = half_life.cdt1, y = half_life.cdt2)) +
        geom_point(alpha = .5) +
        scale_y_continuous(breaks = seq(0, y, by = 2), limits = limits) +
        scale_x_continuous(breaks = seq(0, x, by = 2), limits = limits) +
        geom_smooth(
            method = 'lm',
            se = TRUE,
            span = .01,
            colour = "yellowgreen",
            show.legend = TRUE
        ) +
        labs(x = "\nHalf-life in standard conditions [min]",
             y = "Half-life in iron depletion [min]\n") +
        theme(
            panel.background = element_blank(),
            legend.position = "none",
            axis.text = element_text(size = 13, face = "bold"),
            axis.text.x = element_text(colour = "black"),
            axis.line = element_line(colour = "dimgrey"),
            text = element_text(size = 12)
        )
    print(s)
    dev.off()
}

#in case the dataframe from the positive strand is empty, a dataframe is
#created to be plotted for the genome annotation.
empty_data_positive <- function(data_p,
                                data_n,
                                frag,
                                i,
                                axis_title_y_size = axis_title_y_size,
                                axis_text_y_size = axis_text_y_size,
                                Limit = Limit) {
    print(paste0(i, ": no data on positive strand"))
    df1_f <- data.frame(matrix(NA, nrow = 1, ncol = ncol(data_p)))
    colnames(df1_f) <- colnames(data_p)
    df1_f$ID <- "ID_fake"
    df1_f$position <- frag[i]
    df1_f$strand <- "+"
    df1_f$delay <- .01
    df1_f$half_life <- .01
    df1_f$intensity <- 1000
    Title <- NA
    
    #add arrow and virtual boxes to adjust the scale in ggplot
    p1 <-
        ggplot(df1_f, aes(x = get('position'), y = get('intensity'))) +
        scale_x_continuous(limits = c(frag[i], frag[i + 1])) +
        labs(y = "Intensity [A.U]") +
        scale_y_continuous(
            trans = 'log2',
            labels = label_log2_function,
            sec.axis = sec_axis( ~ . * 1, name = "Coverage",
                                 labels = label_square_function)
        ) +
        theme_bw() +
        background_grid(major = "xy", minor = "none") +
        theme(
            legend.text = element_blank(),
            legend.position = "none",
            axis.title.y = element_text(colour = 5, size = axis_title_y_size),
            axis.text.x = element_blank(),
            axis.title.x = element_blank(),
            panel.grid.major.x = element_blank(),
            plot.title = element_text(hjust = 0.5),
            axis.text.y = element_text(
                angle = 90,
                hjust = 1,
                size = axis_text_y_size
            ),
            panel.border = element_blank()
        )
    if (nrow(data_n) != 0) {
        p1 <- p1 +
            ggtitle(
                paste0(
                    "ID: ",
                    data_n$ID[1],
                    "-",
                    last(data_n$ID),
                    "; ",
                    "FC*: ",
                    "significant t-test of two consecutive segments",
                    "; Term: termination, NS: new start, PS: pausing site,",
                    "iTSS_I: internal starting site,",
                    "TI: transcription interferance."
                )
            ) +
            theme(plot.title = element_text(size = 6, hjust = .5))
    }
    p2 <-
        ggplot(df1_f, aes(x = get('position'), y = get('half_life'))) +
        scale_x_continuous(limits = c(frag[i], frag[i + 1])) +
        scale_y_continuous(
            limits = c(0, 10),
            breaks = seq(0, 10, by = 2),
            sec.axis = sec_axis( ~ . * 1, name = "Half-life [min]", breaks =
                                     seq(0, Limit, by = 2))
        ) +
        labs(y = "Half-life [min]") +
        theme_bw() +
        background_grid(major = "xy", minor = "none") +
        theme(
            legend.title = element_blank(),
            legend.position = "none",
            axis.title.y = element_text(colour = 6, size = axis_title_y_size),
            axis.text.x = element_blank(),
            axis.title.x = element_blank(),
            panel.grid.major.x = element_blank(),
            axis.text.y = element_text(
                angle = 90,
                hjust = 1,
                size = axis_text_y_size
            ),
            panel.border = element_blank()
        )
    p <- list(p1, p2)
    return(p)
}

## ----include=FALSE------------------------------------------------------------
devtools::load_all(".")

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(echo = TRUE,
                      message = TRUE,
                      warning = TRUE)

## ----echo = FALSE, message = FALSE--------------------------------------------
require(rifiComparative)
suppressPackageStartupMessages(library(SummarizedExperiment))

## ----loading_fun, eval = TRUE-------------------------------------------------
data(stats_se_cdt1)
data(stats_se_cdt2)
data(differential_expression)
inp_s <-  
    loading_fun(stats_se_cdt1, stats_se_cdt2, differential_expression)[[1]]
head(inp_s, 5)
inp_f <- 
    loading_fun(stats_se_cdt1, stats_se_cdt2, differential_expression)[[2]]
head(inp_f, 5)

## ----joining_data_row, eval = TRUE--------------------------------------------
data(inp_s)
data(inp_f)
data_combined_minimal <- 
joining_data_row(input1 = inp_s, input2 = inp_f)
head(data_combined_minimal, 5)

## ----joinging_data_column, eval = TRUE----------------------------------------
data(data_combined_minimal)
df_comb_minimal <- joining_data_column(data = data_combined_minimal)
head(df_comb_minimal, 5)

## ----make_pen HL, eval = FALSE------------------------------------------------
# 
# df_comb_minimal[,"distance_HL"] <-
#     df_comb_minimal[, "half_life.cdt1"] - df_comb_minimal[, "half_life.cdt2"]
# 
# pen_HL <- make_pen(
#     probe = df_comb_minimal,
#     FUN = rifiComparative:::fragment_HL_pen,
#     cores = 2,
#     logs = as.numeric(rep(NA, 8))
# )

## ----make_pen int, eval = FALSE-----------------------------------------------
# 
# df_comb_minimal[,"distance_int"] <- df_comb_minimal[,"logFC_int"]
# 
# pen_int <- make_pen(
#     probe = df_comb_minimal,
#     FUN = rifiComparative:::fragment_inty_pen,
#     cores = 2,
#     logs = as.numeric(rep(NA, 8))
# )

## ----penalties, eval = TRUE---------------------------------------------------
data(df_comb_minimal) 
penalties_df <- penalties(df_comb_minimal)[[1]]
pen_HL <- penalties(df_comb_minimal)[[2]]
pen_int <- penalties(df_comb_minimal)[[3]]
head(penalties_df, 5)

## ----fragment_HL, eval = TRUE-------------------------------------------------
penalties_df <-
    fragment_HL(
    probe = penalties_df,
    cores = 2,
    pen = pen_HL[[1]][[9]],
    pen_out = pen_HL[[1]][[10]]
)

## ----fragment_inty, eval = TRUE-----------------------------------------------
fragment_int <-
    fragment_inty(
        probe = penalties_df,
        cores = 2,
        pen = pen_int[[1]][[9]],
        pen_out = pen_int[[1]][[10]]
    )
head(fragment_int, 5)

## ----t_test_function_HL, eval = TRUE------------------------------------------
data(fragment_int)
stats_df_comb_minimal <- statistics(data= fragment_int)[[1]]
df_comb_uniq_minimal <- statistics(data= fragment_int)[[2]]

## ----rifi_visualization_comparison, eval = FALSE------------------------------
# data(data_combined_minimal)
# data(stats_df_comb_minimal)
# data(annot_g)
# rifi_visualization_comparison(
#      data = data_combined_minimal,
#      data_c = stats_df_comb_minimal,
#      genomeLength = annot_g[[2]],
#      annot = annot_g[[1]]
#      )

## ----visualization, echo = FALSE, fig.cap = "**genome fragments visualization of both conditions**", out.width = '100%'----
knitr::include_graphics("visualization_cdts.png")

## ----adjusting_HLToInt, eval = TRUE-------------------------------------------
data(stats_df_comb_minimal) 
data(annot_g)
df_adjusting_HLToInt <- adjusting_HLToInt(data = stats_df_comb_minimal, 
                                          annotation = annot_g[[1]])
head(df_adjusting_HLToInt, 5)

## ----figures_fun, eval = FALSE, echo = TRUE, out.width = '100%'---------------
#  data(data_combined_minimal)
#  data(df_comb_minimal)
#  data(differential_expression)
#  data(df_mean_minimal)
#  figures_fun(data.1 = df_mean_minimal, data.2 = data_combined_minimal,
#  input.1 = df_comb_minimal, input.2 = differential_expression, cdt1 = "sc",
#  cdt2 = "fe")

## ----echo = FALSE, fig.cap = "**\\label{fig:figs}Decay rate vs. Synthesis rate**", out.width = '100%'----
knitr::include_graphics("Decay_rate_vs_Synthesis_rate.png")

## ----echo = FALSE, fig.cap = "**\\label{fig:figs}Heatscatter Decay rate vs. Synthesis rate**", out.width = '100%'----
knitr::include_graphics("heatscatter_Decay_rate_vs_Synthesis_rate.png")

## ----echo = FALSE, fig.cap = "**\\label{fig:figs}Half-life Density**", out.width = '100%'----
knitr::include_graphics("density_HL.png")

## ----echo = FALSE, fig.cap = "**\\label{fig:figs}Half-life Classification**", out.width = '100%'----
knitr::include_graphics("histogram_count.png")

## ----echo = FALSE, fig.cap = "**\\label{fig:figs}Half-life Scatter Plot **", out.width = '100%'----
knitr::include_graphics("scatter_plot_HL.png")

## ----echo = FALSE, fig.cap = "**\\label{fig:figs}Volcano Plot**", out.width = '100%'----
knitr::include_graphics("volcano_plot.png")

## ----gff3_preprocess----------------------------------------------------------
gff3_preprocess(path = gzfile(
   system.file("extdata", "gff_synechocystis_6803.gff.gz", package = "rifiComparative")
 ))

## -----------------------------------------------------------------------------
sessionInfo()

# =========================================================================
#  joining_data_row           
# -------------------------------------------------------------------------
#' joining_data_row joins two data frames by row
#' 
#' joining_data_row joins two data frames from different conditions by row.
#'
#' @param input1 data frame from SummarizedExperiment output of rifi_stats 
#' from rifi package of the first condition. 
#' @param input2 data frame from SummarizedExperiment output of rifi_stats 
#' from rifi package of the second condition.
#'
#' @return The data frame with joined rows from both conditions with the 
#' corresponding columns: ID with position, strand, intensity, probe_TI, flag, 
#' position_segment, delay, half_life, TI_termination_factor, delay_fragment, 
#' velocity_fragment, intercept, slope, HL_fragment, HL_mean_fragment, 
#' intensity_fragment, intensity_mean_fragment, TU, TI_termination_fragment, 
#' TI_mean_termination_factor, seg_ID, pausing_site, iTSS_I, ps_ts_fragment, 
#' event_ps_itss_p_value_Ttest, p_value_slope, delay_frg_slope, velocity_ratio, 
#' event_duration, event_position, FC_HL, FC_fragment_HL, p_value_HL, 
#' FC_intensity, FC_fragment_intensity, p_value_intensity, FC_HL_intensity, 
#' FC_HL_intensity_fragment, FC_HL_adapted, synthesis_ratio, 
#' synthesis_ratio_event, p_value_Manova, p_value_TI, cdt (condition), 
#' logFC_int (log2FC(intensity)), P.Value of log2FC(intensity)
#'
#' @examples
#' data(inp_s)
#' data(inp_f)
#' data_combined_minimal <- 
#' joining_data_row(input1 = inp_s, input2 = inp_f)
#' @export
 

joining_data_row <- function(input1, input2){
    data <- rbind(input1, input2)
    return(data)
}

score_fun_ave <-
    function(y, z, pen, n_out = min(10, max(1, 0.2 * length(z)))) {
        n_out <-
            min(n_out, length(z) - 3) # the number of allowed outliers is decided
        tmp_ave <- mean(y) # the mean is calculated
        tmp_dif <- abs(y - tmp_ave) # the difference to the mean is calculated
        names(tmp_dif) <-
            z # tmp_dif and y are named by z to decide for outliers
        names(y) <- z
        out <-
            sort(tmp_dif, decreasing = TRUE)[1] # out is is the sorted vector of
        #differences to the mean
        tmp_score <-
            sum(tmp_dif) # the sum of the differences to the mean is used as score
        tmp_mean <- tmp_ave # the mean is cached
        if (n_out >= 1) {
            # checks if more than 0 outliers are allowed
            for (i in seq_len(n_out)) {
                # the loop iterates over the number of allowed outliers
                tmp_out <- names(out) # all but the i worst are selected
                tmp_y <- y[!names(y) %in% tmp_out]
                tmp_ave_o <- mean(tmp_y) # new mean
                tmp_dif_o <- abs(tmp_y - tmp_ave_o) # new difference to mean
                out <- c(out, sort(tmp_dif_o, decreasing = TRUE)[1])
                tmp_score_o <-
                    sum(tmp_dif_o) + pen * i # new score with outliers penalty
                tmp_score <- c(tmp_score, tmp_score_o) # the score(s) are cached
                tmp_mean <- c(tmp_mean, tmp_ave_o) # the mean(s) are cached
            }
        }
        mi <-
            which(tmp_score == min(tmp_score))[1] # the lowest score is selected
        nam <- paste0(z, collapse = ",") # all names (z) are collected
        nam <- paste0(nam, "_", tmp_mean[mi]) # the mean is pasted to the name
        if (mi > 1) {
            # checks if outliers were found
            outlier <-
                paste(names(out)[seq_len(mi - 1)], collapse = ",") # pastes all
            #outliers together
            nam <- paste0(nam, "_", outlier) # pastes the outliers to the mean
        }
        res <- tmp_score[mi] # the lowest score
        names(res) <- nam # the name
        res
    }

# ==============================================================================
# statistics                
# ------------------------------------------------------------------------------
# 
#' statistics check segments significance using statistical test
#' 
#' statistics uses t-test to check HL and intensity segments significance. The 
#' function returns the data frame with p_value and p_value adjusted. 
#' The function used is t_test_function.
#'
#' @param data data frame: data frame output of fragmentation
#' 
#' @return A list of two data frames, the first one contains all segments with 
#' p_value and p_value adjusted. The second one removes the duplicated segments 
#' from intensity and could be saved as an excel file. 
#'
#' @examples
#' data(fragment_int)
#' stats_df_comb_minimal <- statistics(data= fragment_int)[[1]]
#' df_comb_uniq_minimal <- statistics(data= fragment_int)[[2]]
#' 
#' @export

statistics <- function(data){
    
    #eliminate outliers from HL fragment
    frag_HL <-
        unique(data[,"HL_comb_fragment"][
            grep(paste0("Dc_\\d+$"), data[,"HL_comb_fragment"])])
    
    #eliminate outlier from intensity fragment
    frag_int <-
        unique(data[,"intensity_comb_fragment"][
            grep(paste0("I_\\d+$"), data[,"intensity_comb_fragment"])])
    
    data <-
        t_test_function(
            data = data,
            par = "HL",
            par1 = "half_life",
            frag_HL = frag_HL, 
            frag_int = frag_int
        )
    p_adjusted <-
        as.numeric(p.adjust(as.numeric(data[ ,"p_value_distance_HL"]),
                            method = "fdr"))
    data <-
        tibble::add_column(data, formatC(p_adjusted, format = "e", digits = 2),
                           .after = ncol(data)-1)
    
    colnames(data)[ncol(data)] <- "p_adjusted_HL"
    
    data <-
        t_test_function(
            data = data,
            par = "intensity",
            par1 = "intensity",
            frag_HL = frag_HL, 
            frag_int = frag_int
        )

        p_adjusted <-
            as.numeric(p.adjust(as.numeric(
                data[ ,"p_value_distance_intensity"]), method = "fdr"))
        data <-
            tibble::add_column(data, formatC(p_adjusted, format = "e", 
                                             digits = 2), .after = ncol(data)-1)
        
        colnames(data)[ncol(data)] <- "p_adjusted_intensity"
        
        df_comb_uniq <-
            data[!duplicated(data[,"intensity_comb_fragment"]), ]
        
        return(list(data, df_comb_uniq))
}

t_test_function <- function(data, par, par1, frag_HL, frag_int){
    
    data[,paste0("p_value_distance_", par)] <- NA
    
    if(par == "HL"){
        frag <- frag_HL
    }else{
        frag <- frag_int
    }
    for (i in seq_along(frag)) {
        par.cd1 <- data[which(data[,paste0(par,"_comb_fragment")] == frag[i]),
                        paste0(par1, ".cdt1")]
        par.cd2 <- data[which(data[,paste0(par,"_comb_fragment")] == frag[i]),
                        paste0(par1, ".cdt2")]
        if (length(par.cd1) < 3 | length(par.cd2) < 3 ) {
            next ()
        } 
        t_h <-
            t.test(par.cd1,
                   par.cd2,
                   alternative = "two.sided",
                   var.equal = FALSE)
        #fill in the dataframe with the p_value 
        data[which(data[,paste0(par,"_comb_fragment")] == frag[i]), 
             paste0("p_value_distance_", par)] <- t_h[[3]]
    }
    return(data)
}

HL_category <- function(data, indice) {
    l1 <- length(which(data[, paste0("half_life.", indice)] <= 2))
    l2 <- length(which(data[, paste0("half_life.", indice)] > 2 &
                           data[, paste0("half_life.", indice)] <= 4))
    l3 <- length(which(data[, paste0("half_life.", indice)] > 4 &
                           data[, paste0("half_life.", indice)] <= 8))
    l4 <- length(which(data[, paste0("half_life.", indice)] > 8 &
                           data[, paste0("half_life.", indice)] <= 10))
    l5 <- length(which(data[, paste0("half_life.", indice)] > 10 &
                           data[, paste0("half_life.", indice)] <= 20))
    l6 <- length(which(data[, paste0("half_life.", indice)] > 20))
    return(c(l1, l2, l3, l4, l5, l6))
}

#' An example SummarizedExperiment from Synechosystis PCC 6803 first condition
#' obtained from rifi_statistics and used as input for rifiComparative
#'
#' @format A rowRanges of SummarizedExperiment with 500 rows and 50 variables:
#' \describe{
#'   \item{seqnames:}{The sequence name chromosome}
#'   \item{start:}{The bin/probe start position}
#'   \item{end:}{The bin/probe end position}
#'   \item{width:}{The bin/probe length}
#'   \item{strand:}{The strand specific}
#'   \item{position:}{The bin/probe specific position}
#'   \item{ID:}{The bin/probe specific ID}
#'   \item{FLT:}{The bin/probe flag for background level}
#'   \item{intensity:}{The relative intensity at time point 0}
#'   \item{probe_TI:}{An internal value to determine which fitting model is
#'   applied}
#'   \item{flag:}{Information on which fitting model is applied}
#'   \item{position_segment:}{The position based segment}
#'   \item{delay:}{The delay value of the bin/probe}
#'   \item{half_life:}{The half-life of the bin/probe}
#'   \item{TI_termination_factor:}{The termination factor of the bin/probe}
#'   \item{delay_fragment:}{The delay fragment the bin belongs to}
#'   \item{velocity_fragment:}{The velocity value of the respective delay
#'   fragment}
#'   \item{intercept:}{The vintercept of fit through the respective delay
#'   fragment}
#'   \item{slope:}{The slope of the fit through the respective delay fragment}
#'   \item{HL_fragment:}{The half-life fragment the bin belongs to}
#'   \item{HL_mean_fragment:}{The mean half-life value of the respective
#'   half-life fragment}
#'   \item{intensity_fragment:}{The intensity fragment the bin belongs to}
#'   \item{intensity_mean_fragment:}{The mean intensity value of the respective
#'   intensity fragment}
#'   \item{TU:}{The overarching transcription unit}
#'   \item{TI_termination_fragment:}{The TI fragment the bin belongs to}
#'   \item{TI_mean_termination_factor:}{The mean termination factor of the
#'   respective TI fragment}
#'   \item{seg_ID:}{The combined ID of the fragment}
#'   \item{pausing_site:}{presence of pausing site indicated by +/-}
#'   \item{iTSS_I:}{presence of iTSS_I indicated by +/-}
#'   \item{ps_ts_fragment:}{The fragments involved in pausing site or iTSS_I}
#'   \item{event_ps_itss_p_value_Ttest:}{p_value of pausing site or iTSS_I}#'   
#'   \item{delay_frg_slope:}{the slope value of the respective delay fragment}
#'   \item{p_value_slope:}{p_value of the slope}
#'   \item{velocity_ratio:}{Integer, ratio of velocity between 2 delay fragments}
#'   \item{event_duration:}{Integer, the duration between two delay fragments}
#'   \item{event_position:}{Integer, the position middle between 2 fragments with an event}
#'   \item{FC_HL:}{Integer, the fold change value of 2 HL fragments}
#'   \item{FC_fragment_HL:}{Integer, the fold change value of 2 intensity fragments}
#'   \item{p_value_HL:}{p_value of the fold change of HL fragments}
#'   \item{FC_intensity:}{Integer, the fold change value of 2 intensity fragments}
#'   \item{FC_fragment_intensity:}{String, fragments involved in fold change 
#'   between 2 intensity fragments}
#'   \item{p_value_intensity:}{p_value of the fold change of intensity fragments}
#'   \item{FC_HL_intensity:}{ratio of fold change between 2 half-life fragments 
#'   and fold change between 2 intensity fragments}
#'   \item{FC_HL_intensity_fragment:}{fragments involved on ratio of fold change
#'   between 2 half-life fragments and fold change between 2 intensity fragments}
#'   \item{FC_HL_adapted:}{Integer, the fold change of half-life/ fold change
#'   of intensity, position of the half-life fragment is adapted to intensity 
#'   fragment}
#'   \item{synthesis_ratio:}{Integer, the value correspomding to synthesis rate}
#'   \item{synthesis_ratio_event:}{String, the event assigned by synthesis rate
#'   either Termination or iTSS}
#'   \item{p_value_Manova:}{p_value of the variance between two fold-changes, 
#'   HL and intensity}
#'   \item{p_value_TI:}{p_value of TI fragment} 
#'   \item{TI_fragments_p_value:}{p_value of 2 TI fragments}
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(stats_se_cdt1)  
#'
#'
"stats_se_cdt1"


#' An example SummarizedExperiment from Synechosystis PCC 6803 second condition
#' obtained from rifi_statistics and used as input for rifiComparative
#'
#' @format A rowRanges of SummarizedExperiment with 500 rows and 50 variables:
#' \describe{
#'   \item{seqnames:}{The sequence name chromosome}
#'   \item{start:}{The bin/probe start position}
#'   \item{end:}{The bin/probe end position}
#'   \item{width:}{The bin/probe length}
#'   \item{strand:}{The strand specific}
#'   \item{position:}{The bin/probe specific position}
#'   \item{ID:}{The bin/probe specific ID}
#'   \item{FLT:}{The bin/probe flag for background level}
#'   \item{intensity:}{The relative intensity at time point 0}
#'   \item{probe_TI:}{An internal value to determine which fitting model is
#'   applied}
#'   \item{flag:}{Information on which fitting model is applied}
#'   \item{position_segment:}{The position based segment}
#'   \item{delay:}{The delay value of the bin/probe}
#'   \item{half_life:}{The half-life of the bin/probe}
#'   \item{TI_termination_factor:}{The termination factor of the bin/probe}
#'   \item{delay_fragment:}{The delay fragment the bin belongs to}
#'   \item{velocity_fragment:}{The velocity value of the respective delay
#'   fragment}
#'   \item{intercept:}{The vintercept of fit through the respective delay
#'   fragment}
#'   \item{slope:}{The slope of the fit through the respective delay fragment}
#'   \item{HL_fragment:}{The half-life fragment the bin belongs to}
#'   \item{HL_mean_fragment:}{The mean half-life value of the respective
#'   half-life fragment}
#'   \item{intensity_fragment:}{The intensity fragment the bin belongs to}
#'   \item{intensity_mean_fragment:}{The mean intensity value of the respective
#'   intensity fragment}
#'   \item{TU:}{The overarching transcription unit}
#'   \item{TI_termination_fragment:}{The TI fragment the bin belongs to}
#'   \item{TI_mean_termination_factor:}{The mean termination factor of the
#'   respective TI fragment}
#'   \item{seg_ID:}{The combined ID of the fragment}
#'   \item{pausing_site:}{presence of pausing site indicated by +/-}
#'   \item{iTSS_I:}{presence of iTSS_I indicated by +/-}
#'   \item{ps_ts_fragment:}{The fragments involved in pausing site or iTSS_I}
#'   \item{event_ps_itss_p_value_Ttest:}{p_value of pausing site or iTSS_I}
#'   \item{p_value_slope:}{p_value of the slope}
#'   \item{delay_frg_slope:}{the slope value of the respective delay fragment}
#'   \item{velocity_ratio:}{Integer, ratio of velocity between 2 delay fragments}
#'   \item{event_duration:}{Integer, the duration between two delay fragments}
#'   \item{event_position:}{Integer, the position middle between 2 fragments 
#'   with an event}
#'   \item{FC_HL:}{Integer, the fold change value of 2 HL fragments}
#'   \item{FC_fragment_HL:}{Integer, the fold change value of 2 intensity fragments}
#'   \item{p_value_HL:}{p_value of the fold change of HL fragments}
#'   \item{FC_intensity:}{Integer, the fold change value of 2 intensity fragments}
#'   \item{FC_fragment_intensity:}{String, fragments involved in fold change 
#'   between 2 intensity fragments}
#'   \item{p_value_intensity:}{p_value of the fold change of intensity fragments}
#'   \item{FC_HL_intensity:}{ratio of fold change between 2 half-life fragments 
#'   and fold change between 2 intensity fragments}
#'    \item{FC_HL_intensity_fragment:}{fragments involved on ratio of fold 
#'    change between 2 half-life fragments and fold change between 2 intensity 
#'    fragments}
#'   \item{FC_HL_adapted:}{Integer, the fold change of half-life/ fold change
#'   of intensity, position of the half-life fragment is adapted to intensity 
#'   fragment}
#'   \item{synthesis_ratio:}{Integer, the value correspomding to synthesis rate}
#'   \item{synthesis_ratio_event:}{String, the event assigned by synthesis rate 
#'   either  Termination or iTSS}
#'   \item{p_value_Manova:}{p_value of the variance between two fold-changes, 
#'   HL and intensity}
#'   \item{p_value_TI:}{p_value of TI fragment} 
#'   \item{TI_fragments_p_value:}{p_value of 2 TI fragments} 
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(stats_se_cdt2)
#'
#'
"stats_se_cdt2"


#' An example data frame from Synechosystis PCC 6803 differential probes
#' expression obtained from limma package and only interesting variables were
#' selected. The data frame was used entirely.
#'
#' @format A data frame of differential_expression with 55508 rows and 4 variables:
#' \describe{
#'   \item{position:}{The bin/probe specific position}
#'   \item{strand:}{The strand specific}
#'   \item{logFC_int:}{The bin/probe differential expression}
#'   \item{P.Value:}{The bin/probe p_value adjusted}
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(differential_expression)
#'
#'
"differential_expression"

#' The result of loading_fun for stats_se_cdt1 example data
#' Two data frame containing the output of loading_fun as first element of a
#' list.
#'
#' @format A data frame with 500 rows and 49 variables:
#' \describe{
#'   \item{strand:}{The strand specific}
#'   \item{position:}{The bin/probe specific position}
#'   \item{ID:}{The bin/probe specific ID}
#'   \item{FLT:}{The bin/probe flag for background level}
#'   \item{intensity:}{The relative intensity at time point 0}
#'   \item{probe_TI:}{An internal value to determine which fitting model is
#'   applied}
#'   \item{flag:}{Information on which fitting model is applied}
#'   \item{position_segment:}{The position based segment}
#'   \item{delay:}{The delay value of the bin/probe}
#'   \item{half_life:}{The half-life of the bin/probe}
#'   \item{TI_termination_factor:}{The termination factor of the bin/probe}
#'   \item{delay_fragment:}{The delay fragment the bin belongs to}
#'   \item{velocity_fragment:}{The velocity value of the respective delay
#'   fragment}
#'   \item{intercept:}{The vintercept of fit through the respective delay
#'   fragment}
#'   \item{slope:}{The slope of the fit through the respective delay fragment}
#'   \item{HL_fragment:}{The half-life fragment the bin belongs to}
#'   \item{HL_mean_fragment:}{The mean half-life value of the respective
#'   half-life fragment}
#'   \item{intensity_fragment:}{The intensity fragment the bin belongs to}
#'   \item{intensity_mean_fragment:}{The mean intensity value of the respective
#'   intensity fragment}
#'   \item{TU:}{The overarching transcription unit}
#'   \item{TI_termination_fragment:}{The TI fragment the bin belongs to}
#'   \item{TI_mean_termination_factor:}{The mean termination factor of the
#'   respective TI fragment}
#'   \item{seg_ID:}{The combined ID of the fragment}
#'   \item{pausing_site:}{presence of pausing site indicated by +/-}
#'   \item{iTSS_I:}{presence of iTSS_I indicated by +/-}
#'   \item{ps_ts_fragment:}{The fragments involved in pausing site or iTSS_I}
#'   \item{event_ps_itss_p_value_Ttest:}{p_value of pausing site or iTSS_I}
#'   \item{p_value_slope:}{p_value of the slope}
#'   \item{delay_frg_slope:}{the slope value of the respective delay fragment}
#'   \item{velocity_ratio:}{Integer, ratio of velocity between 2 delay fragments}
#'   \item{event_duration:}{Integer, the duration between two delay fragments}
#'   \item{event_position:}{Integer, the position middle between 2 fragments with an event}
#'   \item{FC_HL:}{Integer, the fold change value of 2 HL fragments}
#'   \item{FC_fragment_HL:}{Integer, the fold change value of 2 intensity fragments}
#'   \item{p_value_HL:}{p_value of the fold change of HL fragments}
#'   \item{FC_intensity:}{Integer, the fold change value of 2 intensity fragments}
#'   \item{FC_fragment_intensity:}{String, fragments involved in fold change 
#'   between 2 intensity fragments}
#'   \item{p_value_intensity:}{p_value of the fold change of intensity fragments}
#'   \item{FC_HL_intensity:}{ratio of fold change between 2 half-life fragments 
#'   and fold change between 2 intensity fragments}
#'   \item{FC_HL_intensity_fragment:}{fragments involved on ratio of fold 
#'   change between 2 half-life fragments and fold change between 2 intensity 
#'   fragments}
#'   \item{FC_HL_adapted:}{Integer, the fold change of half-life/ fold change of
#'   intensity, position of the half-life fragment is adapted to intensity fragment}
#'   \item{synthesis_ratio:}{Integer, the value correspomding to synthesis rate}
#'   \item{synthesis_ratio_event:}{String, the event assigned by synthesis rate 
#'   either  Termination or iTSS}
#'   \item{p_value_Manova:}{p_value of the variance between two fold-changes, 
#'   HL and intensity}
#'   \item{p_value_TI:}{p_value of TI fragment}
#'   \item{TI_fragments_p_value:}{p_value of 2 TI fragments} 
#'   \item{cdt:}{The condition assigned to the experiment here cdt1}
#'   \item{logFC_int:}{The bin/probe log2 fold change of intensity at time 0}
#'   \item{P.Value:}{The bin/probe p_value adjusted }
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(inp_s)  
#'
#'
"inp_s"


#' The result of loading_fun for stats_se_cdt2 example data
#' Two data frame containing the output of loading_fun as second element of a
#' list.
#'
#' @format A data frame with 500 rows and 49 variables:
#' \describe{
#'   \item{strand:}{The strand specific}
#'   \item{position:}{The bin/probe specific position}
#'   \item{ID:}{The bin/probe specific ID}
#'   \item{FLT:}{The bin/probe flag for background level}
#'   \item{intensity:}{The relative intensity at time point 0}
#'   \item{probe_TI:}{An internal value to determine which fitting model is
#'   applied}
#'   \item{flag:}{Information on which fitting model is applied}
#'   \item{position_segment:}{The position based segment}
#'   \item{delay:}{The delay value of the bin/probe}
#'   \item{half_life:}{The half-life of the bin/probe}
#'   \item{TI_termination_factor:}{The termination factor of the bin/probe}
#'   \item{delay_fragment:}{The delay fragment the bin belongs to}
#'   \item{velocity_fragment:}{The velocity value of the respective delay
#'   fragment}
#'   \item{intercept:}{The vintercept of fit through the respective delay
#'   fragment}
#'   \item{slope:}{The slope of the fit through the respective delay fragment}
#'   \item{HL_fragment:}{The half-life fragment the bin belongs to}
#'   \item{HL_mean_fragment:}{The mean half-life value of the respective
#'   half-life fragment}
#'   \item{intensity_fragment:}{The intensity fragment the bin belongs to}
#'   \item{intensity_mean_fragment:}{The mean intensity value of the respective
#'   intensity fragment}
#'   \item{TU:}{The overarching transcription unit}
#'   \item{TI_termination_fragment:}{The TI fragment the bin belongs to}
#'   \item{TI_mean_termination_factor:}{The mean termination factor of the
#'   respective TI fragment}
#'   \item{seg_ID:}{The combined ID of the fragment}
#'   \item{pausing_site:}{presence of pausing site indicated by +/-}
#'   \item{iTSS_I:}{presence of iTSS_I indicated by +/-}
#'   \item{ps_ts_fragment:}{The fragments involved in pausing site or iTSS_I}
#'   \item{event_ps_itss_p_value_Ttest:}{p_value of pausing site or iTSS_I}
#'   \item{p_value_slope:}{p_value of the slope}
#'   \item{delay_frg_slope:}{the slope value of the respective delay fragment}
#'   \item{velocity_ratio:}{Integer, ratio of velocity between 2 delay fragments}
#'   \item{event_duration:}{Integer, the duration between two delay fragments}
#'   \item{event_position:}{Integer, the position middle between 2 fragments 
#'   with an event}
#'   \item{FC_HL:}{Integer, the fold change value of 2 HL fragments}
#'   \item{FC_fragment_HL:}{Integer, the fold change value of 2 intensity 
#'   fragments}
#'   \item{p_value_HL:}{p_value of the fold change of HL fragments}
#'   \item{FC_intensity:}{Integer, the fold change value of 2 intensity fragments}
#'   \item{FC_fragment_intensity:}{String, fragments involved in fold change 
#'   between 2 intensity fragments}
#'   \item{p_value_intensity:}{p_value of the fold change of intensity fragments}
#'   \item{FC_HL_intensity:}{ratio of fold change between 2 half-life fragments 
#'   and fold change between 2 intensity fragments}
#'    \item{FC_HL_intensity_fragment:}{fragments involved on ratio of fold 
#'    change between 2 half-life fragments and fold change between 2 intensity 
#'    fragments}
#'   \item{FC_HL_adapted:}{Integer, the fold change of half-life/ fold change of
#'   intensity, position of the half-life fragment is adapted to intensity 
#'   fragment}
#'   \item{synthesis_ratio:}{Integer, the value correspomding to synthesis rate}
#'   \item{synthesis_ratio_event:}{String, the event assigned by synthesis 
#'   rate either  Termination or iTSS}
#'   \item{p_value_Manova:}{p_value of the variance between two fold-changes,
#'    HL and intensity}
#'   \item{p_value_TI:}{p_value of TI fragment} 
#'   \item{TI_fragments_p_value:}{p_value of 2 TI fragments} 
#'   \item{cdt:}{The condition assigned to the experiment here cdt2}
#'   \item{logFC_int:}{The bin/probe log2 fold change of intensity at time 0}
#'   \item{P.Value:}{The bin/probe p_value adjusted }
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(inp_f)  
#'
#'
"inp_f"


#' The result of joining_by_row for inp_s and inp_f example data
#' A data frame containing the output of joining_by_row as a data frame
#' 
#' @format A data frame with 600 rows and 49 variables:
#' \describe{
#'   \item{strand:}{The strand specific}
#'   \item{position:}{The bin/probe specific position}
#'   \item{ID:}{The bin/probe specific ID}
#'   \item{FLT:}{The bin/probe flag for background level}
#'   \item{intensity:}{The relative intensity at time point 0}
#'   \item{probe_TI:}{An internal value to determine which fitting model is
#'   applied}
#'   \item{flag:}{Information on which fitting model is applied}
#'   \item{position_segment:}{The position based segment}
#'   \item{delay:}{The delay value of the bin/probe}
#'   \item{half_life:}{The half-life of the bin/probe}
#'   \item{TI_termination_factor:}{The termination factor of the bin/probe}
#'   \item{delay_fragment:}{The delay fragment the bin belongs to}
#'   \item{velocity_fragment:}{The velocity value of the respective delay
#'   fragment}
#'   \item{intercept:}{The vintercept of fit through the respective delay
#'   fragment}
#'   \item{slope:}{The slope of the fit through the respective delay fragment}
#'   \item{HL_fragment:}{The half-life fragment the bin belongs to}
#'   \item{HL_mean_fragment:}{The mean half-life value of the respective
#'   half-life fragment}
#'   \item{intensity_fragment:}{The intensity fragment the bin belongs to}
#'   \item{intensity_mean_fragment:}{The mean intensity value of the respective
#'   intensity fragment}
#'   \item{TU:}{The overarching transcription unit}
#'   \item{TI_termination_fragment:}{The TI fragment the bin belongs to}
#'   \item{TI_mean_termination_factor:}{The mean termination factor of the
#'   respective TI fragment}
#'   \item{seg_ID:}{The combined ID of the fragment}
#'   \item{pausing_site:}{presence of pausing site indicated by +/-}
#'   \item{iTSS_I:}{presence of iTSS_I indicated by +/-}
#'   \item{ps_ts_fragment:}{The fragments involved in pausing site or iTSS_I}
#'   \item{event_ps_itss_p_value_Ttest:}{p_value of pausing site or iTSS_I}
#'   \item{p_value_slope:}{p_value of the slope}
#'   \item{delay_frg_slope:}{the slope value of the respective delay fragment}
#'   \item{velocity_ratio:}{Integer, ratio of velocity between 2 delay fragments}
#'   \item{event_duration:}{Integer, the duration between two delay fragments}
#'   \item{event_position:}{Integer, the position middle between 2 fragments 
#'   with an event}
#'   \item{FC_fragment_HL:}{Integer, the fold change value of 2 intensity 
#'   fragments}
#'   \item{FC_HL:}{Integer, the fold change value of 2 HL fragments}#'   
#'   \item{p_value_HL:}{p_value of the fold change of HL fragments}
#'   \item{FC_intensity:}{Integer, the fold change value of 2 intensity 
#'   fragments}
#'   \item{FC_fragment_intensity:}{String, fragments involved in fold change 
#'   between 2 intensity fragments}
#'   \item{p_value_intensity:}{p_value of the fold change of intensity fragments}
#'   \item{FC_HL_intensity:}{ratio of fold change between 2 half-life fragments 
#'   and fold change between 2 intensity fragments}
#'    \item{FC_HL_intensity_fragment:}{fragments involved on ratio of fold 
#'    change between 2 half-life fragments and fold change between 2 intensity 
#'    fragments}
#'   \item{FC_HL_adapted:}{Integer, the fold change of half-life/ fold change of
#'   intensity, position of the half-life fragment is adapted to intensity 
#'   fragment}
#'   \item{synthesis_ratio:}{Integer, the value correspomding to synthesis rate}
#'   \item{synthesis_ratio_event:}{String, the event assigned by synthesis 
#'   rate either  Termination or iTSS}
#'   \item{p_value_Manova:}{p_value of the variance between two fold-changes, 
#'   HL and intensity}
#'   \item{p_value_TI:}{p_value of TI fragment} 
#'   \item{TI_fragments_p_value:}{p_value of 2 TI fragments} 
#'   \item{cdt:}{The condition assigned to the experiment here cdt2}
#'   \item{logFC_int:}{The bin/probe log2 fold change of intensity at time 0}
#'   \item{P.Value:}{The bin/probe p_value adjusted }
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifi}
#'
#' @usage data(data_combined_minimal)
#'
"data_combined_minimal"


#' The result of joining_by_column for data_combined_minimal example data
#' A data frame containing the output of joining_by_row as a data frame
#'
#' @format A data frame with 300 rows and 18 variables:
#' \describe{
#'   \item{strand:}{The strand specific}
#'   \item{position:}{The bin/probe specific position}
#'   \item{ID:}{The bin/probe specific ID}
#'   \item{intensity.cdt1:}{The relative intensity at time point 0 for 
#'   condition 1}
#'   \item{position_segment:}{The position based segment}
#'   \item{half_life.cdt1:}{The half-life of the bin/probe condition 1}
#'   \item{TI_termination_factor.cdt1:}{The termination factor of the bin/probe
#'   condition 1}
#'   \item{HL_fragment.cdt1:}{The half-life fragment the bin belongs to  
#'   condition 1}
#'   \item{intensity_fragment.cdt1:}{The intensity fragment the bin belongs to
#'   condition 1}
#'   \item{TI_termination_fragment.cdt1:}{The TI fragment the bin belongs to 
#'   condition 1}
#'   \item{logFC_int:}{The bin/probe log2 fold change of intensity at time 0}
#'   \item{P.Value:}{The bin/probe p_value adjusted }
#'   \item{intensity.cdt2:}{The relative intensity at time point 0  
#'   condition 2}
#'   \item{half_life.cdt2:}{The half-life of the bin/probe condition 2}
#'   \item{TI_termination_factor.cdt2:}{The termination factor of the bin/probe
#'   condition 2}
#'   \item{HL_fragment.cdt2:}{The half-life fragment the bin belongs to  
#'   condition 2}
#'   \item{intensity_fragment.cdt2:}{The intensity fragment the bin belongs to
#'   condition 2}
#'   \item{TI_termination_fragment.cdt2:}{The TI fragment the bin belongs to 
#'   condition 2}
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(df_comb_minimal)  
#'
#'
"df_comb_minimal"

#' The result of penalties for df_comb_minimal example data
#' A data frame containing the output of penalties as a data frame
#'
#' @format A data frame with 300 rows and 20 variables:
#' \describe{
#'   \item{strand:}{The strand specific}
#'   \item{position:}{The bin/probe specific position}
#'   \item{ID:}{The bin/probe specific ID}
#'   \item{intensity.cdt1:}{The relative intensity at time point 0 for 
#'   condition 1}
#'   \item{position_segment:}{The position based segment}
#'   \item{half_life.cdt1:}{The half-life of the bin/probe condition 1}
#'   \item{TI_termination_factor.cdt1:}{The termination factor of the bin/probe
#'   condition 1}
#'   \item{HL_fragment.cdt1:}{The half-life fragment the bin belongs to  
#'   condition 1}
#'   \item{intensity_fragment.cdt1:}{The intensity fragment the bin belongs to
#'   condition 1}
#'   \item{TI_termination_fragment.cdt1:}{The TI fragment the bin belongs to 
#'   condition 1}
#'   \item{logFC_int:}{The bin/probe log2 fold change of intensity at time 0}
#'   \item{P.Value:}{The bin/probe p_value adjusted }
#'   \item{intensity.cdt2:}{The relative intensity at time point 0  
#'   condition 2}
#'   \item{half_life.cdt2:}{The half-life of the bin/probe condition 2}
#'   \item{TI_termination_factor.cdt2:}{The termination factor of the bin/probe
#'   condition 2}
#'   \item{HL_fragment.cdt2:}{The half-life fragment the bin belongs to  
#'   condition 2}
#'   \item{intensity_fragment.cdt2:}{The intensity fragment the bin belongs to
#'   condition 2}
#'   \item{TI_termination_fragment.cdt2:}{The TI fragment the bin belongs to 
#'   condition 2}
#'   \item{distance_HL:}{The bin/probe difference of half-life from both
#'   conditions}
#'   \item{distance_int:}{The bin/probe log2 fold change of intensity at time 0}
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(penalties_df)  
#'
#'
"penalties_df"


#' The result of penalties for df_comb_minimal example data.
#' A list containing the output from penalties including the logbook and two
#' penalty objects.
#' 
#' @format A list with 5 items:
#' \describe{
#'   \item{pen_obj_HL:}{A list with 4 items:
#'     \describe{
#'       \item{logbook:}{The logbook vector containing half-life penalty
#'       information}
#'       \item{HL_penalties:}{a vetor with the half-life penalty and half-life
#'       outlier penalty}
#'       \item{correct:}{a matrix of the correct splits}
#'       \item{wrong:}{a matrix of the incorrect splits}
#'     }
#'   }
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifi}
#'
#' @usage data(pen_HL)
#'
"pen_HL"

#' The result of penalties for df_comb_minimal example data.
#' A list containing the output from penalties including the logbook and two
#' penalty objects.
#' 
#' @format A list with 5 items:
#' \describe{
#'   \item{pen_int:}{A list with 4 items:
#'     \describe{
#'       \item{logbook:}{The logbook vector containing intensity penalty
#'       information}
#'       \item{int_penalties:}{a vector with the intensity penalty and
#'       intensity outlier penalty}
#'       \item{correct:}{a matrix of the correct splits}
#'       \item{wrong:}{a matrix of the incorrect splits}
#'     }
#'   }
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifi}
#'
#' @usage data(pen_int)
#'
"pen_int"


#' The result of fragmentation for df_comb_minimal example data
#' A data frame containing the output of fragmentation as a data frame
#'
#' @format A data frame with 500 rows and 24 variables:
#' \describe{
#'   \item{strand:}{The strand specific}
#'   \item{position:}{The bin/probe specific position}
#'   \item{ID:}{The bin/probe specific ID}
#'   \item{intensity.cdt1:}{The relative intensity at time point 0 for 
#'   condition 1}
#'   \item{position_segment:}{The position based segment}
#'   \item{half_life.cdt1:}{The half-life of the bin/probe condition 1}
#'   \item{TI_termination_factor.cdt1:}{The termination factor of the bin/probe
#'   condition 1}
#'   \item{HL_fragment.cdt1:}{The half-life fragment the bin belongs to  
#'   condition 1}
#'   \item{intensity_fragment.cdt1:}{The intensity fragment the bin belongs to
#'   condition 1}
#'   \item{TI_termination_fragment.cdt1:}{The TI fragment the bin belongs to 
#'   condition 1}
#'   \item{logFC_int:}{The bin/probe log2 fold change of intensity at time 0}
#'   \item{P.Value:}{The bin/probe p_value adjusted }
#'   \item{intensity.cdt2:}{The relative intensity at time point 0  
#'   condition 2}
#'   \item{half_life.cdt2:}{The half-life of the bin/probe condition 2}
#'   \item{TI_termination_factor.cdt2:}{The termination factor of the bin/probe
#'   condition 2}
#'   \item{HL_fragment.cdt2:}{The half-life fragment the bin belongs to  
#'   condition 2}
#'   \item{intensity_fragment.cdt2:}{The intensity fragment the bin belongs to
#'   condition 2}
#'   \item{TI_termination_fragment.cdt2:}{The TI fragment the bin belongs to 
#'   condition 2}
#'   \item{distance_HL:}{The bin/probe difference of half-life from both
#'   conditions}
#'   \item{distance_int:}{The bin/probe log2 fold change of intensity at time 0}
#'   \item{HL_comb_fragment:}{The half-life fragment the bin belongs to both
#'   conditions}
#'   \item{HL_mean_comb_fragment:}{The half-life mean of the fragment the bin
#'   belongs to both conditions}
#'   \item{intensity_comb_fragment:}{The intensity fragment the bin belongs to 
#'   both conditions}
#'   \item{intensity_mean_comb_fragment:}{The intensity mean of the fragment the
#'   bin belongs to both conditions}
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(fragment_int)
#'
#'
"fragment_int"

#' The result of statistics for fragment_int example data
#' A data frame containing the output of statistics as a data frame
#'
#' @format A data frame with 500 rows and 26 variables:
#' \describe{
#'   \item{strand:}{The strand specific}
#'   \item{position:}{The bin/probe specific position}
#'   \item{ID:}{The bin/probe specific ID}
#'   \item{intensity.cdt1:}{The relative intensity at time point 0 for 
#'   condition 1}
#'   \item{position_segment:}{The position based segment}
#'   \item{half_life.cdt1:}{The half-life of the bin/probe condition 1}
#'   \item{TI_termination_factor.cdt1:}{The termination factor of the bin/probe
#'   condition 1}
#'   \item{HL_fragment.cdt1:}{The half-life fragment the bin belongs to  
#'   condition 1}
#'   \item{intensity_fragment.cdt1:}{The intensity fragment the bin belongs to
#'   condition 1}
#'   \item{TI_termination_fragment.cdt1:}{The TI fragment the bin belongs to 
#'   condition 1}
#'   \item{logFC_int:}{The bin/probe log2 fold change of intensity at time 0}
#'   \item{P.Value:}{The bin/probe p_value adjusted }
#'   \item{intensity.cdt2:}{The relative intensity at time point 0  
#'   condition 2}
#'   \item{half_life.cdt2:}{The half-life of the bin/probe condition 2}
#'   \item{TI_termination_factor.cdt2:}{The termination factor of the bin/probe
#'   condition 2}
#'   \item{HL_fragment.cdt2:}{The half-life fragment the bin belongs to  
#'   condition 2}
#'   \item{intensity_fragment.cdt2:}{The intensity fragment the bin belongs to
#'   condition 2}
#'   \item{TI_termination_fragment.cdt2:}{The TI fragment the bin belongs to 
#'   condition 2}
#'   \item{distance_HL:}{The bin/probe difference of half-life from both
#'   conditions}
#'   \item{distance_int:}{The bin/probe log2 fold change of intensity at time 0}
#'   \item{HL_comb_fragment:}{The half-life fragment the bin belongs to both
#'   conditions}
#'   \item{HL_mean_comb_fragment:}{The half-life mean of the fragment the bin
#'   belongs to both conditions}
#'   \item{intensity_comb_fragment:}{The intensity fragment the bin belongs to 
#'   both conditions}
#'   \item{intensity_mean_comb_fragment:}{The intensity mean of the fragment the
#'   bin belongs to both conditions}
#'   \item{p_value_distance_HL:}{The p_value adjusted of the half-life fragment 
#'   the bin belongs to both conditions}
#'   \item{p_value_distance_intensity:}{The p_value adjusted of the intensity
#'   fragment the bin belongs to both conditions}
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(stats_df_comb_minimal)
#'
#'
"stats_df_comb_minimal"


#' The result of adjusting_HLToInt for stats_df_comb_minimal and annotation
#' example data
#' A data frame containing the output of adjusting_HLToInt as a data frame
#'
#' @format A data frame with 52 rows and 15 variables:
#' \describe{
#'   \item{position:}{The bin/probe specific position}
#'   \item{region:}{the region from the gff file}
#'   \item{gene:}{the annotated gene name}
#'   \item{locus_tag:}{the annotated locus tag}
#'   \item{strand:}{The strand specific}
#'   \item{fragment_HL:}{The half-life fragment the bin belongs}
#'   \item{fragment_int:}{The intensity fragment the bin belongs}
#'   \item{position_frg_int:}{The position of the first fragment and the last 
#'   position of the last fragment}
#'   \item{mean_HL_fragment:}{The mean half-life value of the respective
#'   half-life fragments}
#'   \item{mean_int_fragment:}{The mean intensity value of the respective
#'   intensity fragments}
#'   \item{log2FC(decay_rate):}{log2FC(decay(condition1)/decay(condition2))}
#'   \item{Log2FC(HL)-Log2FC(int):}{log2FC(decay_rate/intensity)}
#'   \item{log2FC(synthesis_rate):}{log2FC(decay_rate) + 
#'      log2FC(intensity)}
#'   \item{intensity_FC:}{log2FC(mean(intensity(condition1))/mean(
#'      intensity(condition2)))}
#'   \item{p_value:}{indicated by "*" means at least one fragment 
#'      either HL fragment or intensity fragment has a significant p_value}
#' }
#'
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(df_mean_minimal)  
#'
#'
"df_mean_minimal"


#' The result of gff3_preprocessing of gff3 file
#' A list containing all necessary information from a gff file for 
#' adjusting_HLToInt and visualization. 
#'
#' @format A list with 2 items:
#' \describe{
#'   \item{data annotation:}{a data frame with 5853 rows and 6 variables
#'     \describe{
#'       \item{region:}{the region from the gff file}
#'       \item{start:}{the start of the annotation}
#'       \item{end:}{the end of the annotation}
#'       \item{strand:}{the strand of the annotation}
#'       \item{gene:}{the annotated gene name}
#'       \item{locus_tag:}{the annotated locus tag}
#'     }
#'   }
#'   \item{genome length:}{a numeric vector containing the length of the genome}
#' }
#' @source \url{https://github.com/CyanolabFreiburg/rifiComparative}
#'
#' @usage data(annot_g)  
#'
#'
"annot_g"

# =========================================================================
#  fragmentation       
# -------------------------------------------------------------------------
#
#' fragmentation: Conveniently wraps all fragmentation steps
#' 
#' fragmentation fragments the half-life and intensity into segments using 
#' the penalties output. 
#'
#' @param data data frame: data frame combined data by column
#' @param cores integer: the number of assigned cores for the task. It needs to 
#' be increased in case of big data.
#' @param pen_HL list: list of the penalties set optimal for the fragmentation
#' for half-life
#' @param pen_int list: list of the penalties set optimal for the fragmentation
#' for intensity
#' 
#' @return Two data frames with half-life and intensity fragments and the mean 
#' of the coefficient fragment based. 
#'
#' @examples
#' data(penalties_df)
#' data(pen_HL)
#' data(pen_int)
#' df_comb_minimal <- fragmentation(data = penalties_df, pen_HL, 
#' pen_int)
#' @export

 
fragmentation <- function(data, pen_HL, pen_int, cores = 2){
#I. Dynamic Programming for HL
    data <- fragment_HL(
    probe = data,
    cores = cores,
    pen = pen_HL[[1]][[9]],
    pen_out = pen_HL[[1]][[10]]
    )

#II. Dynamic Programming for intensity
    data <- fragment_inty(
    probe = data,
    cores = cores,
    pen = pen_int[[1]][[9]],
    pen_out = pen_int[[1]][[10]]
    )
    return(data)
}

utils::globalVariables(
        c(
                "intensity_comb_fragment",
                "cdt",
                ".",
                "synthesis_ratio",
                "label_log2_function",
                "label_square_function" ,
                "HL_comb_fragment" ,
                "distance_int" ,
                "png",
                "fc_sr" ,
                "fc_dr" ,
                "median" ,
                "HL_mean_fragment" ,
                "heatscatter" ,
                "value" ,
                "variable" ,
                "half_life.cdt1" ,
                "half_life.cdt2" ,
                "logFC_int" ,
                "P.Value" ,
                "annot_g" ,
                "indice" ,
                "position" ,
                "p_value_distance_intensity" ,
                "frag_HL" ,
                "frag_int" ,
                "synthesis_ratio",
                "distance_HL_log",
                "distance_HL",
                "p_value_distance_HL"
                )
)

# =========================================================================
# adjusting_HLToInt  
# -------------------------------------------------------------------------
#' adjusting_HLToInt Creates one table merging HL and intensity fragments
#' with genome annotation
#'
#'
#' 'adjusting_HLToInt' merges HL and intensity segments adapting the positions 
#' to each other and combining to the genome annotation.
#' To make HL and intensity segments comparable, log2FC(HL) is used to generate 
#' the data frame instead of distance.
#' The fragments should have a significant p_value from t-test at least from one
#' segmentation, either HL or intensity.
#'
#' The functions used are:
#'
#' 1. p_value_function extracts and return the p_values of HL and intensity
#' segments respectively.
#'
#' 2. eliminate_outlier_hl eliminates outliers from HL fragments.
#'
#' 3. eliminate_outlier_int eliminates outliers from intensity fragments.
#'
#' 4. mean_length_int calculates the mean of the log2FC(intensity) fragments
#' adapted to HL_fragments and their lengths
#'
#' 5. mean_length_hl calculates the mean of log2FC(HL) fragments adapted to the
#' intensity fragments and their lengths.
#'
#' 6. calculating_rate calculates decay rate and log2FC(intensity). Both are
#' used to calculate synthesis rate.

#' @param data data frame: data frame combined data by column
#' @param Strand string: either "+" or "-"
#' @param annotation data frame: data frame from processed gff3 file.
#'
#' @return The data frame with the corresponding columns:
#'    \describe{
#'      \item{position:}{Integer, position of the first fragment}
#'      \item{region:}{String, region annotation covering the fragments}
#'      \item{gene:}{String, gene annotation covering the fragments}
#'      \item{locus_tag:}{String, locus_tag annotation covering the fragments}
#'      \item{strand:}{Boolean. The bin/probe specific strand (+/-)}
#'      \item{fragment_HL:}{String, HL fragments}
#'      \item{fragment_int:}{String, intensity fragments}
#'      \item{position_frg_int:}{Integer, position of the first fragment and
#'      the last position of the last fragment}
#'      \item{mean_HL_fragment:}{Integer, mean of the HL of the fragments
#'      involved}
#'      \item{mean_int_fragment:}{Integer, mean of the intensity of the
#'      fragments involved}
#'      \item{log2FC(decay_rate):}{Integer, log2FC(decay(condition1)/
#'      decay(condition2))}
#'      \item{log2FC(synthesis_rate):}{Integer, sum of log2FC(decay_rate) and
#'      log2FC(intensity)}
#'      \item{intensity_FC:}{Integer, log2FC(mean(intensity(condition1))/mean(
#'      intensity(condition2)))}
#'      \item{Log2FC(HL)+Log2FC(int):}{Integer, sum of log2FC(decay_rate) and
#'      log2FC(intensity)}
#'      \item{p_value:}{String, indicated by "*" means at least one fragment
#'      either HL fragment or intensity fragment has a significant p_value}
#'     }
#'
#' @examples
#' data(stats_df_comb_minimal)
#' data(annot_g)
#' df_mean_minimal <- adjusting_HLToInt(data = stats_df_comb_minimal,
#' annotation = annot_g[[1]])
#' 
#' @export


adjusting_HLToInt <-
    function(data,
             Strand = c("+", "-"),
             annotation) {
        # distance HL between two conditions. log2 is applied after dynamic
        # programming to compare HL with intensity
        # colnames(data)[c(25,27)] <- c("p_value_distance_HL", 
        #                               "p_value_distance_intensity") 
        data[, "distance_HL_log"] <-
            log2(data[, "half_life.cdt1"] / data[, "half_life.cdt2"])
        
        #select unique fragments without outliers
        frag_HL <-
            unique(eliminate_outlier_hl(data)[, "HL_comb_fragment"])
        
        #assign empty vectors
        df <- data.frame()
        Position <- c()
        Region <- c()
        Gene <- c()
        Locus_tag <- c()
        STrand <- c()
        Fragment_HL <- c()
        Fragment_int <- c()
        position_frg_int <- c()
        Mean_HL_fragment <- c()
        Mean_int_fragment <- c()
        Decay_rate <- c()
        Synthesis_rate <- c()
        intensity_FC <- c()
        p_value <- c()
        
        for (j in seq_along(Strand)) {
            #select fragment by strand
            fragments_HL <-
                data[which(data$strand == Strand[j]), "HL_comb_fragment"]
            
            #eliminate outliers
            fragments_HL <-
                unique(fragments_HL[grep(paste0("Dc_\\d+", "$"), fragments_HL)])
            
            #loop into HL fragments
            for (i in seq_along(fragments_HL)) {
                #assign objects
                fg_hl <- NA
                fg_int <- NA
                position <- NA
                region <- NA
                gene <- NA
                locus_tag <- NA
                strand <- NA
                fragment_HL <- NA
                fragment_int <- NA
                mean_HL_fragment <- NA
                mean_int_fragment <- NA
                decay_rate <- NA
                synthesis_rate <- NA
                Description <- NA
                
                #selecting strand
                fg <- data[which(data$strand %in% Strand[j]), ]
                
                #selecting the positions covering HL_comb fragment
                fg_hl_pos <-
                    fg[which(fg$HL_comb_fragment ==
                                 fragments_HL[i]), "position"]
                
                #positions boarders
                pos.1 <- fg_hl_pos[1]
                pos.2 <- last(fg_hl_pos)
                
                #in case of strand is negative, the positions are flipped
                if (j == 2) {
                    pos.1 <- last(fg_hl_pos)
                    pos.2 <- fg_hl_pos[1]
                }
                
                #df with the corresponding positions
                fg_pos <-
                    fg[between(fg$position, pos.1, pos.2),]
                
                # select strand on the annotation data frame
                ann <- as.data.frame(annotation) %>%
                    filter(strand == Strand[j])
                
                tryCatch({
                    region <-  
                        paste0(annotation_function_df(
                            feature = "region",
                            pos.1 = pos.1, 
                            pos.2 = pos.2,
                            strand = Strand[j],
                            data_annotation = ann
                        ), collapse = "|")
                    
                    gene <- 
                        paste0(annotation_function_df(
                            feature = "gene",
                            pos.1 = pos.1, 
                            pos.2 = pos.2,
                            strand = Strand[j],
                            data_annotation = ann
                        ), collapse = "|")
                    
                    locus_tag <-
                        paste0(annotation_function_df(
                            feature = "locus_tag",
                            pos.1 = pos.1, 
                            pos.2 = pos.2,
                            strand = Strand[j],
                            data_annotation = ann
                        ), collapse = "|")
                    
                    Description <-
                        paste0(annotation_function_df(
                            feature = "Annotation",
                            pos.1 = pos.1, 
                            pos.2 = pos.2,
                            strand = Strand[j],
                            data_annotation = ann
                        ), collapse = "|")
                }, error = function(e) {
                    "No match for the annotation"
                })
                
                #eliminate HL and intensity outliers
                f_withoutOutlier <- eliminate_outlier_hl(fg_pos)
                f_withoutOutlier <-
                    eliminate_outlier_int(f_withoutOutlier)
                f_int <-
                    unique(f_withoutOutlier$intensity_comb_fragment)
                
                #split intensity fragments in case length is more than 1,
                if (length(f_int) > 1) {
                    for (k in seq_along(f_int)) {
                        #delimit the intensity fragment positions
                        hl_int <- f_withoutOutlier %>%
                            filter(intensity_comb_fragment == f_int[k])
                        
                        #extract the mean of distance delimiting int fragment 
                        #positions
                        fg_hl <- mean_length_hl(hl_int)
                        
                        #delimit the intensity fragment positions
                        fg_int <- mean_length_int(hl_int)
                        
                        # check p_values
                        p_values <- p_value_function(hl_int)
                        
                        Position <-
                            c(Position, f_withoutOutlier$position[1])
                        Region <- c(Region, region)
                        Gene <- c(Gene, gene)
                        Locus_tag <- c(Locus_tag, locus_tag)
                        #Annotation <- c(Annotation, Description)
                        STrand <- c(STrand, Strand[j])
                        
                        #HL fragment
                        Fragment_HL <-
                            c(Fragment_HL, fragments_HL[i])
                        
                        #int fragment
                        Fragment_int <- c(Fragment_int, f_int[k])
                        #border positions of the fragment
                        position_frg_int <-
                            c(position_frg_int,
                              paste(
                                  hl_int$position[1],
                                  last(hl_int$position),
                                  sep = ":"
                              ))
                        
                        if (length(p_values) < 2) {
                            Mean_HL_fragment <- c(Mean_HL_fragment, NA)
                            Mean_int_fragment <-
                                c(Mean_int_fragment, NA)
                            Decay_rate <- c(Decay_rate, NA)
                            Synthesis_rate <- c(Synthesis_rate, NA)
                            intensity_FC <- c(intensity_FC, NA)
                            p_value <- c(p_value, NA)
                        }
                        
                        if (length(p_values) == 2) {
                            #mean of the distance on the fragment hl
                            Mean_HL_fragment <-
                                c(Mean_HL_fragment, fg_hl$mean)
                            #mean of the distance on the fragment int
                            Mean_int_fragment <-
                                c(Mean_int_fragment, fg_int$mean)
                            # decay_rate is calculated dividing log2/mean(HL) of
                            # both condition
                            # please refer to calculating_rate function
                            Decay_rate <- c(Decay_rate,
                                            calculating_rate(hl_int)[[1]])
                            ##ratio between log2FC(decay) and log2FC(intensity)
                            intensity_FC <-
                                c(intensity_FC, log2(
                                    mean(hl_int$intensity.cdt1) /
                                        mean(hl_int$intensity.cdt2)
                                ))
                            # synthesis_rate is calculated from steady-state and
                            # decay rate
                            # multiplication of log2FC(decay) and log2FC(intensity)
                            Synthesis_rate <- c(
                                Synthesis_rate,
                                calculating_rate(hl_int)[[1]] +
                                    calculating_rate(hl_int)[[2]]
                            )
                            if (p_values[1] < .05 |
                                p_values[2] < .05) {
                                p_value <- c(p_value, "*")
                            } else{
                                p_value <- c(p_value, NA)
                            }
                        }
                    }
                }
                if (length(f_int) == 1) {
                    p_values <- p_value_function(fg_pos)
                    fg_hl <- mean_length_hl(f_withoutOutlier)
                    fg_int <- mean_length_int(f_withoutOutlier)
                    Position <-
                        c(Position, f_withoutOutlier$position[1])
                    Region <- c(Region, region)
                    Gene <- c(Gene, gene)
                    Locus_tag <- c(Locus_tag, locus_tag)
                    STrand <- c(STrand, Strand[j])
                    Fragment_HL <- c(Fragment_HL, fragment_HL[i])
                    Fragment_int <- c(Fragment_int, f_int)
                    position_frg_int <- c(
                        position_frg_int,
                        paste(
                            f_withoutOutlier$position[1],
                            last(f_withoutOutlier$position),
                            sep = ":"
                        )
                    )
                    
                    if (length(p_values) < 2) {
                        Mean_HL_fragment <- c(Mean_HL_fragment, NA)
                        Mean_int_fragment <-
                            c(Mean_int_fragment, NA)
                        Decay_rate <- c(Decay_rate, NA)
                        Synthesis_rate <- c(Synthesis_rate, NA)
                        intensity_FC <- c(intensity_FC, NA)
                        p_value <- c(p_value, NA)
                    }
                    if (length(p_values) == 2) {
                        Mean_HL_fragment <- c(Mean_HL_fragment, fg_hl$mean)
                        Mean_int_fragment <-
                            c(Mean_int_fragment, fg_int$mean)
                        Decay_rate <-
                            c(Decay_rate,
                              calculating_rate(f_withoutOutlier)[[1]])
                        Synthesis_rate <- c(
                            Synthesis_rate,
                            calculating_rate(f_withoutOutlier)[[1]] +
                                calculating_rate(f_withoutOutlier)[[2]]
                        )
                        intensity_FC <- c(intensity_FC,
                                          log2(
                                              mean(
                                                  f_withoutOutlier$intensity.cdt1) /
                                                  mean(f_withoutOutlier$intensity.cdt2)
                                          ))
                        if (p_values[1] < .05 | p_values[2] < .05) {
                            p_value <- c(p_value, "*")
                        } else{
                            p_value <- c(p_value, NA)
                        }
                    }
                }
            }
            df <-
                cbind.data.frame(
                    Position,
                    Region,
                    Gene,
                    Locus_tag,
                    STrand,
                    Fragment_HL,
                    Fragment_int,
                    position_frg_int,
                    Mean_HL_fragment,
                    Mean_int_fragment,
                    Decay_rate,
                    Synthesis_rate,
                    intensity_FC,
                    p_value
                )
        }
        return(df)
    }

# density plot on HL
plot_density <- function(data, cdt1, cdt2) {
    
    png("density_HL.png", 900, 900, res = 200)
    
    d <- ggplot(filter(data, HL_mean_fragment < 30),
           aes(HL_mean_fragment, color = cdt)) +
        geom_density(alpha = 0.2) +
        geom_vline(data = data,
                   mapping = aes(xintercept =
                                     mean(na.omit(
                                         HL_mean_fragment
                                     )), color = cdt)) +
        scale_color_discrete(labels = c(cdt1, cdt2)) +
        scale_x_continuous(breaks = seq(0, 30, by = 4), limits = c(0, 30)) +
        labs(x = "Half-life [min]\n") +
        ggtitle("Decay density") +
        theme(
            panel.background = element_blank(),
            axis.line = element_line(colour = "dimgrey"),
            legend.title = element_blank(),
            plot.title = element_text(
                size = 12,
                face = "bold",
                hjust = .5
            )
        )
    print(d)
    dev.off()
    
}

#annotation_plot function plots genome annotation from a gff preprocessed file
#and the transcription units annotated from rifi framework. 
#Since the genome annotation from gff file is same for both conditions, 
#only one box is plotted for locus_tag and gene respectively but 2 boxes for TUs 
#according to the condition.
#annotation_plot plots as well events as termination and iTSS_II.
annotation_plot <-
  function(data_p,
           data_n,
           condition = condition,
           tmp.1,
           tmp.2,
           frag,
           i,
           an = an,
           region = region,
           color_region = color_region,
           fontface = fontface,
           color_text.1 = color_text.1,
           color_TU = color_TU,
           scaling_TU = scaling_TU,
           Alpha = Alpha,
           size_tu = size_tu,
           termination_threshold =
             termination_threshold,
           iTSS_threshold =
             iTSS_threshold,
           p_value_manova =
             p_value_manova,
           pos.1 = pos.1,
           pos.2 = pos.2) {
    #create an annotation data frame upon strand orientation
    an.p <- an[which(an$strand == "+"),]
    an.p <- as.character(unique(an.p$region))
    an.m <- an[which(an$strand == "-"),]
    an.m <- as.character(unique(an.m$region))
    breaks <- seq(frag[i], frag[i + 1], 1000)
    
    df.annt <- data.frame()
    segment_data_t.1 <- data.frame()
    segment_data_g.1 <- data.frame()
    segment_data_g.2 <- data.frame()
    segment_data_g.p1 <- data.frame()
    segment_data_g.p2 <- data.frame()
    #TU_annotation and gene_annot_function functions are used to annotate
    #TUs and genes on the positive strand.
    
    tryCatch({
      #only in case the dataframe from the positive strand is not empty,
      #the TU are annotated
      for (o in seq_along(condition)) {
        if (length(which(data_p$cdt == condition[o])) != 0) {
          segment_data_t.1 <-
            TU_annotation(data_p[which(data_p$cdt == condition[o]),],
                          "TU",
                          2 + scaling_TU[o],
                          5 + scaling_TU[o],
                          color_TU[o],
                          cdt = condition[o])
          segment_data_t.1 <-
            segment_data_t.1[grep("_NA", segment_data_t.1$annotation,
                                  invert = TRUE), ]
        }
        if (nrow(segment_data_t.1) == 0) {
            segment_data_t.1 <- empty_boxes(
              ystart = 2 + scaling_TU[o],
              yend = 5 + scaling_TU[o],
              frag = frag,
              i = i,
              strand = "+"
            )
          } 
        df.annt <- rbind(df.annt, segment_data_t.1)
            # Function to find TUs split into 2 pages
            tu_border <-
              function_TU_arrow(data_p[which(data_p$cdt == condition[o]),],
                                tmp.1,
                                frag = frag,
                                i = i)
            # Eliminate the TU split on the border to avoid arrow plot
            if (length(tu_border) != 0) {
              segment_data_t.1.tuLeft <-
                segment_data_t.1[-which(tu_border ==
                                          segment_data_t.1$annotation), ]
            } else {
              segment_data_t.1.tuLeft <- segment_data_t.1
        }
      }
      if (length(an.p) != 0) {
        for (k in seq_along(an.p)) {
          segment_data_g.1 <-
            gene_annot_function(
              pos.1 = pos.1,
              pos.2 = pos.2,
              yint = 13,
              yend = 16,
              annot = an,
              Strand = "+",
              reg = an.p[k],
              cdt = condition[o],
              col = color_region[which(an.p[k] == region)]
            )
          segment_data_g.2 <-
            gene_annot_function(
              pos.1 = pos.1,
              pos.2 = pos.2,
              yint = 9.2,
              yend = 12.2,
              annot = an,
              Strand = "+",
              reg = an.p[k],
              cdt = condition[o],
              col = color_region[which(an.p[k] == region)]
            )
          segment_data_g.p1 <-
            rbind(segment_data_g.p1, segment_data_g.1)
          segment_data_g.p2 <-
            rbind(segment_data_g.p2, segment_data_g.2)
        }
      }
    }, warning = function(war) {
      
    },
    error = function(err) {
    })
    
    segment_data_t.2 <- data.frame()
    segment_data_g.1 <- data.frame()
    segment_data_g.2 <- data.frame()
    segment_data_g.m1 <- data.frame()
    segment_data_g.m2 <- data.frame()
    #TU and genes annotation in the negative strand
    tryCatch({
      for (o in seq_along(condition)) {
        if (length(which(data_n$cdt == condition[o])) != 0) {
           segment_data_t.2 <-
            TU_annotation(data_n[which(data_n$cdt == condition[o]),],
                          "TU",
                          -2 - scaling_TU[o],
                          -5 - scaling_TU[o],
                          color_TU[o],
                          cdt = condition[o])
          segment_data_t.2 <-
            segment_data_t.2[grep("_NA", segment_data_t.2$annotation,
                                  invert = TRUE), ]
        }
        if (nrow(segment_data_t.2) == 0) {
            segment_data_t.2 <- empty_boxes(
                ystart = -2 + scaling_TU[o],
                yend = -5 + scaling_TU[o],
                frag = frag,
                i = i,
                strand = "-"
            )
           # segment_data_t.2 <- empty_boxes(-3, -6, frag = frag, i = i)
        } 
        df.annt <- rbind(df.annt, segment_data_t.2)
            # Function to find TUs split into 2 pages
            tu_border <-
              function_TU_arrow(data_n[which(data_n$cdt == condition[o]),],
                                tmp.2,
                                frag = frag,
                                i = i)
            # Eliminate the TU split on the border to avoid arrow plot
            if (length(tu_border) != 0) {
              segment_data_t.2.tuLeft <-
                segment_data_t.2[-which(tu_border ==
                                          segment_data_t.2$annotation), ]
            } else {
              segment_data_t.2.tuLeft <- segment_data_t.2
            }
      }
      if (length(an.m) != 0) {
        for (k in seq_along(an.m)) {
          segment_data_g.1 <-
            gene_annot_function(
              pos.1 = pos.1,
              pos.2 = pos.2,
              yint = -13,
              yend = -16,
              annot = an,
              Strand = "-",
              reg = an.m[k],
              cdt = condition[o],
              col = color_region[which(an.m[k] == region)]
            )
          segment_data_g.2 <-
            gene_annot_function(
              pos.1 = pos.1,
              pos.2 = pos.2,
              yint = -9.2,
              yend = -12.2,
              annot = an,
              Strand = "-",
              reg = an.m[k],
              cdt = condition[o],
              col = color_region[which(an.m[k] == region)]
            )
          segment_data_g.m1 <-
            rbind(segment_data_g.m1, segment_data_g.1)
          segment_data_g.m2 <-
            rbind(segment_data_g.m2, segment_data_g.2)
        }
      }
    }, warning = function(war) {
      
    },
    error = function(err) {
      
    })
    
    df.annt <-
      rbind(
        df.annt,
        segment_data_g.p1,
        segment_data_g.p2,
        segment_data_g.m1,
        segment_data_g.m2
      )
    
    ###################################plot#############################
    if (nrow(df.annt) != 0) {
      p7 <- ggplot(data = df.annt) +
        scale_x_continuous(limits = c(frag[i], frag[i + 1]),
                           breaks = breaks) +
        scale_y_continuous(limits = c(-16, 16), expand = c(0, 0)) +
        geom_hline(yintercept = 0) +
        theme_minimal(base_size = 11) +
        theme(
          legend.title = element_blank(),
          axis.title.x = element_blank(),
          legend.position = "none",
          axis.ticks.y =  element_blank(),
          axis.title.y = element_blank(),
          axis.text.y = element_blank(),
          axis.text.x = element_blank(),
          panel.background = element_blank(),
          panel.grid = element_blank(),
          plot.title = element_blank(),
          panel.border = element_blank()
        )
      
      #################add arrows to TUs, both strands separately##########
      if (length(which(df.annt$region == "r")) != 0) {
      p7 <- p7 +
      annotate(
        "segment",
        x = frag[i + 1],
        xend = frag[i],
        y = unique((
          df.annt[which(df.annt$region == "r" &
                          df.annt$strand == "+"), "ystart"] +
            df.annt[which(df.annt$region == "r" &
                            df.annt$strand == "+"), "yend"]
        ) / 2),
        yend = unique((
          df.annt[which(df.annt$region == "r" &
                          df.annt$strand == "+"), "ystart"] +
            df.annt[which(df.annt$region == "r" &
                            df.annt$strand == "+"), "yend"]
        ) / 2),
        size = .1,
        arrow = my_arrow(1, "open")
      )+
      annotate(
        "segment",
        xend = frag[i + 1],
        x = frag[i],
        y = unique((
          df.annt[which(df.annt$region == "r" &
                          df.annt$strand == "-"), "ystart"] +
            df.annt[which(df.annt$region == "r" &
                            df.annt$strand == "-"), "yend"]
        ) / 2),
        yend = unique((
          df.annt[which(df.annt$region == "r" &
                          df.annt$strand == "-"), "ystart"] +
            df.annt[which(df.annt$region == "r" &
                            df.annt$strand == "-"), "yend"]
        ) / 2),
        size = .1,
        arrow = my_arrow(1, "open")
      )
      }
      ###############################################################
       #add rectangle for each box
      if (nrow(df.annt) != 0) {
        p7 <- p7 +
          geom_rect(
            data = df.annt,
            aes(
              xmin = get('xstart'),
              ymin = get('ystart'),
              xmax = get('xend'),
              ymax = get('yend')
            ),
            alpha = Alpha,
            fill = df.annt$color
          ) +
          geom_text(
            data = df.annt[grep("UTR", df.annt$region, invert = TRUE), ],
            aes((get('xstart') + get('xend')) / 2, (get('ystart') +
                                                      get('yend')) / 2,
                label = get('annotation')),
            size = size_tu,
            fontface = fontface,
            color = color_text.1,
            check_overlap = TRUE
          )
      }
   
      if (nrow(df.annt %>% filter(region == "r")) != 0) {
        ####################### add small ticks to TUs positive strand#########
     if(nrow(df.annt[which(df.annt$region == "r" &
                      df.annt$strand == "+"),]) != 0){
      for(o in seq_along(condition)){
        df.annt_p <- df.annt[which(df.annt$region == "r" &
                        df.annt$strand == "+"),]
        p7 <- p7 +
          annotate(
            "segment",
            x = unique(df.annt_p[which(df.annt_p$cdt == condition[o]),
                               "xstart"]) - 10,
            xend = unique(df.annt_p[which(df.annt_p$cdt == condition[o]),
                                  "xstart"]) - 10,
            y = unique(df.annt_p[which(df.annt_p$cdt == condition[o]),
                               "ystart"]),
            yend = unique(df.annt_p[which(df.annt_p$cdt == condition[o]),
                                  "yend"]) + .3,
            size = .2
          ) +
          annotate(
            "segment",
            xend = unique(df.annt_p[which(df.annt_p$cdt == condition[o]),
                                  "xstart"]) - 5,
            x = unique(df.annt_p[which(df.annt_p$cdt == condition[o]),
                               "xstart"]) + 60,
            y = unique(df.annt_p[which(df.annt_p$cdt == condition[o]),
                               "yend"]) + .3,
            yend = unique(df.annt_p[which(df.annt_p$cdt == condition[o]),
                                  "yend"]) + .3,
            size = .2,
            arrow = my_arrow(.4, "open")
          )
      }
     }
        ####################### add small ticks to TUs negative strand#########
     if(nrow(df.annt[which(df.annt$region == "r" &
                              df.annt$strand == "-"),]) != 0){ 
      for(o in seq_along(condition)){
          df.annt_n <- df.annt[which(df.annt$region == "r" &
                                       df.annt$strand == "-"),]
          p7 <- p7 +
            annotate(
              "segment",
              x = unique(df.annt_n[which(df.annt_n$cdt == condition[o]),
                                   "xend"]) + 10,
              xend = unique(df.annt_n[which(df.annt_n$cdt == condition[o]),
                                      "xend"]) + 10,
              y = unique(df.annt_n[which(df.annt_n$cdt == condition[o]),
                                   "ystart"]),
              yend = unique(df.annt_n[which(df.annt_n$cdt == condition[o]),
                                      "yend"]) - .3,
              size = .2
            ) + 
            annotate(
              "segment",
              xend = unique(df.annt_n[which(df.annt_n$cdt == condition[o]),
                                      "xend"]) + 5,
              x = unique(df.annt_n[which(df.annt_n$cdt == condition[o]),
                                   "xend"]) - 60,
              y = unique(df.annt_n[which(df.annt_n$cdt == condition[o]),
                                   "yend"]) - .3,
              yend = unique(df.annt_n[which(df.annt_n$cdt == condition[o]),
                                      "yend"]) - .3,
              size = .2,
              arrow = my_arrow(.4, "open")
            )
        }  
      }
    }
        
      ############################events plot##############################
        df1_syR_T <- NA
      for(o in seq_along(condition)){
        if (length(which(!is.na(data_p[which(data_p$cdt == condition[o]),
                                       "synthesis_ratio"]))) != 0) {
          df1_syR <- data_p %>%
            filter(cdt == condition[o] & !is.na(synthesis_ratio))
          #in case last position matches with an event which needs to be
          #on the next page of the plot.
          if (last(df1_syR$position) == frag[c(i + 1)]) {
            fc_seg <-
              df1_syR[which(df1_syR$position ==
                              frag[c(i + 1)]), "FC_HL_intensity_fragment"]
            df1_syR[which(df1_syR$FC_HL_intensity_fragment == fc_seg),
                    c("synthesis_ratio_event",
                      "p_value_Manova")] <- NA
          }
          if (length(which(
            df1_syR$synthesis_ratio < termination_threshold &
            !is.na(df1_syR$FC_HL_intensity_fragment)
          )) != 0) {
            df1_syR_T <-
              df1_syR[which(
                df1_syR$synthesis_ratio < termination_threshold &
                  !is.na(df1_syR$FC_HL_intensity_fragment)
              ), ]
            df1_syR_T <-
              arrange_byGroup(df1_syR_T, "FC_HL_intensity_fragment")
            if (length(which(df1_syR_T$p_value_Manova < p_value_manova)) != 0) {
              df1_syR_T.m <-
                df1_syR_T %>%
                filter(get('p_value_Manova') < p_value_manova)
              p7 <-
                my_segment_T(
                  p7,
                  data = df1_syR_T.m,
                  "Ter*",
                  y = 2 + scaling_TU[o],
                  yend = 5 +  scaling_TU[o],
                  dis = 50,
                  ytext = 2.1,
                  color = 2,
                  linetype = "solid",
                  df = "termination",
                  fontface = fontface
                )
            }
            if (length(which(df1_syR_T$p_value_Manova > p_value_manova)) != 0) {
              df1_syR_T.t <-
                df1_syR_T %>%
                filter(get('p_value_Manova') > p_value_manova)
              p7 <-
                my_segment_T(
                  p7,
                  data = df1_syR_T.t,
                  "Ter",
                  y = 2 + scaling_TU[o],
                  yend = 5 +  scaling_TU[o],
                  dis = 50,
                  ytext = 2.1,
                  color = 2,
                  linetype = "solid",
                  df = "termination",
                  fontface = fontface
                )
            }
            if (length(which(is.na(df1_syR_T$p_value_Manova))) != 0) {
              df1_syR_T.t <- df1_syR_T %>%
                filter(is.na(get('p_value_Manova')))
              p7 <-
                my_segment_T(
                  p7,
                  data = df1_syR_T.t,
                  "Ter",
                  y = 2 + scaling_TU[o],
                  yend = 5 +  scaling_TU[o],
                  dis = 50,
                  ytext = 2.1,
                  color = 2,
                  linetype = "solid",
                  df = "termination",
                  fontface = fontface
                )
            }
          }
          df1_syR_T <- NA
          #plot New_start event from synthesis_ratio_event
          if (length(which(
            df1_syR$synthesis_ratio > iTSS_threshold &
            !is.na(df1_syR$FC_HL_intensity_fragment)
          )) != 0) {
            df1_syR_T <-
              df1_syR[which(
                df1_syR$synthesis_ratio > iTSS_threshold &
                  !is.na(df1_syR$FC_HL_intensity_fragment)
              ), ]
            df1_syR_T <-
              arrange_byGroup(df1_syR_T, "FC_HL_intensity_fragment")
            if (length(which(df1_syR_T$p_value_Manova < p_value_manova)) != 0) {
              df1_syR_T.m <-
                df1_syR_T %>%
                filter(get('p_value_Manova') < p_value_manova)
              p7 <-
                my_segment_NS(
                  p7,
                  data = df1_syR_T.m,
                  "NS*",
                  y = 2 + scaling_TU[o],
                  yend = 5 +  scaling_TU[o],
                  dis = 10,
                  ytext = 2.1,
                  color = "coral4",
                  linetype = "solid",
                  fontface = fontface
                )
            }
            if (length(which(df1_syR_T$p_value_Manova > p_value_manova)) != 0) {
              df1_syR_T.t <-
                df1_syR_T %>%
                filter(get('p_value_Manova') > p_value_manova)
              p7 <-
                my_segment_NS(
                  p7,
                  data = df1_syR_T.t,
                  "NS",
                  y = 2 + scaling_TU[o],
                  yend = 5 + scaling_TU[o],
                  dis = 10,
                  ytext = 2.1,
                  color = "coral4",
                  linetype = "solid",
                  fontface = fontface
                )
            }
            if (length(which(is.na(df1_syR_T$p_value_Manova))) != 0) {
              df1_syR_T.t <- df1_syR_T %>%
                filter(is.na(get('p_value_Manova')))
              p7 <-
                my_segment_NS(
                  p7,
                  data = df1_syR_T.t,
                  "NS",
                  y = 2 + scaling_TU[o],
                  yend = 5 + scaling_TU[o],
                  dis = 10,
                  ytext = 2.1,
                  color = "coral4",
                  linetype = "solid",
                  fontface = fontface
                )
              }
            }
         }
      }
    }
    
    if (nrow(df.annt %>% filter(region == "r" & strand == "-")) != 0) {
         df2_syR_T <- NA
         for(o in seq_along(condition)){
          if (length(which(!is.na(data_n[which(data_n$cdt == condition[o]),
                                         "synthesis_ratio"]))) != 0) {
            df2_syR <- data_n %>%
              filter(cdt == condition[o] & !is.na(synthesis_ratio))
          if (length(which(
            df2_syR$synthesis_ratio < termination_threshold &
            !is.na(df2_syR$FC_HL_intensity_fragment)
          )) != 0) {
            df2_syR_T <-
              df2_syR[which(
                df2_syR$synthesis_ratio < termination_threshold &
                  !is.na(df2_syR$FC_HL_intensity_fragment)
              ),]
            df2_syR_T <-
              df2_syR_T[!duplicated(df2_syR_T$FC_fragment_intensity),]
            if (length(which(df2_syR_T$p_value_Manova < p_value_manova)) != 0) {
              df2_syR_T.m <-
                df2_syR_T %>%
                filter(get('p_value_Manova') < p_value_manova)
              p7 <-
                my_segment_T(
                  p7,
                  data = df2_syR_T.m,
                  "Ter*",
                  y = -2 - scaling_TU[o] ,
                  yend = -5 - scaling_TU[o],
                  dis = 50,
                  ytext = -2.1,
                  color = 2,
                  linetype = "solid",
                  df = "termination",
                  fontface = fontface
                )
            }
            if (length(which(df2_syR_T$p_value_Manova > p_value_manova)) != 0) {
              df2_syR_T.t <-
                df2_syR_T %>%
                filter(get('p_value_Manova') > p_value_manova)
              p7 <-
                my_segment_T(
                  p7,
                  data = df2_syR_T.t,
                  "Ter",
                  y = -2 - scaling_TU[o] ,
                  yend = -5 - scaling_TU[o],
                  dis = 50,
                  ytext = -2.1,
                  color = 2,
                  linetype = "solid",
                  df = "termination",
                  fontface = fontface
                )
            }
            if (length(which(is.na(df2_syR_T$p_value_Manova))) != 0) {
              df2_syR_T.t <- df2_syR_T %>%
                filter(is.na(get('p_value_Manova')))
              p7 <-
                my_segment_T(
                  p7,
                  data = df2_syR_T.t,
                  "Ter",
                  y = -2 - scaling_TU[o] ,
                  yend = -5 - scaling_TU[o],
                  dis = 50,
                  ytext = -2.1,
                  color = 2,
                  linetype = "solid",
                  df = "termination",
                  fontface = fontface
                )
            }
          }
          df2_syR_T <- NA
          #plot New_start event from synthesis_ratio_event column
          if (length(which(
            df2_syR$synthesis_ratio > iTSS_threshold &
            !is.na(df2_syR$FC_HL_intensity_fragment)
          )) != 0) {
            df2_syR_T <-
              df2_syR[which(
                df2_syR$synthesis_ratio > iTSS_threshold &
                  !is.na(df2_syR$FC_HL_intensity_fragment)
              ),]
            df2_syR_T <-
              df2_syR_T[!duplicated(df2_syR_T$FC_fragment_intensity),]
            if (length(which(df2_syR_T$p_value_Manova < p_value_manova)) != 0) {
              df2_syR_T.m <-
                df2_syR_T %>%
                filter(get('p_value_Manova') < p_value_manova)
              p7 <-
                my_segment_NS(
                  p7,
                  data = df2_syR_T.m,
                  "NS*",
                  y = -2 - scaling_TU[o] ,
                  yend = -5 - scaling_TU[o],
                  dis = 10,
                  ytext = -2.1,
                  color = "coral4",
                  linetype = "solid",
                  fontface = fontface
                )
            }
            if (length(which(df2_syR_T$p_value_Manova > p_value_manova)) != 0) {
              df2_syR_T.t <-
                df2_syR_T %>%
                filter(get('p_value_Manova') > p_value_manova)
              p7 <-
                my_segment_NS(
                  p7,
                  data = df2_syR_T.t,
                  "NS",
                  y = -2 - scaling_TU[o] ,
                  yend = -5 - scaling_TU[o],
                  dis = 10,
                  ytext = -2.1,
                  color = "coral4",
                  linetype = "solid",
                  fontface = fontface
                )
            }
            if (length(which(is.na(df2_syR_T$p_value_Manova))) != 0) {
              df2_syR_T.t <- df2_syR_T %>%
                filter(is.na(get('p_value_Manova')))
               p7 <-
                my_segment_NS(
                  p7,
                  data = df2_syR_T.t,
                  "NS",
                  y = -2 - scaling_TU[o] ,
                  yend = -5 - scaling_TU[o],
                  dis = 10,
                  ytext = -2.1,
                  color = "coral4",
                  linetype = "solid",
                  fontface = fontface
                )
              }
            }
          }
        }
      }

    return(p7)
  }

#plot HL categories
plot_histogram <- function(data, cdt1, cdt2) {
    
    png("histogram_count.png", 900, 900, res = 200)
    
    hist1 <- HL_category(data, "cdt1")
    hist2 <- HL_category(data, "cdt2")
    
    category <- c("<=2", "2-4", "4-8", "8-10", "10-20", ">20")
    
    #add category to the dataframe
    hist_sf <- cbind.data.frame(hist1, hist2, category)
    
    #Value Standardization
    hist_sf[, 1:2] <- sapply(hist_sf[, 1:2], function(x)
        x / sum(x))
    
    colnames(hist_sf)[1:2] <- c(cdt1, cdt2)
    hist_sf <- reshape2::melt(hist_sf, id.vars = "category")
    
    h <- ggplot(hist_sf, aes(x = category, y = value,
                        fill = variable)) +
        geom_bar(
            color = "black",
            stat = "identity",
            position = position_dodge2(),
            orientation = "x",
            show.legend = TRUE
        ) +
        scale_x_discrete(limits = category) +
        labs(x = "\nHalf-life [min]", y = "Relative frequency % \n",
             title = "Half-life classification") +
        scale_fill_brewer(palette = 'Purples') +
        theme(
            legend.position = c(.85, .9),
            legend.title = element_blank(),
            axis.text = element_text(size = 13, face = "bold"),
            axis.text.x = element_text(colour = "black"),
            axis.line = element_line(colour = "dimgrey"),
            text = element_text(size = 10, face = "bold"),
            plot.title = element_text(hjust = .5)
        ) +
        theme_bw()
    print(h)
    dev.off()
}

#the function tries to cover all annotations. Positions 1 and 2 cover those segments starting before the beginning of the gene/TU annotated. 
annotation_function_df <-
  function(feature, pos.1, pos.2, strand, data_annotation) {
    data_annotation[, "region"]  <-
      as.character(data_annotation[, "region"])
    data_annotation <-
      data_annotation[which(data_annotation[, "strand"] %in% strand),]
    
    positions.1 <- data_annotation[
      between(data_annotation$end, pos.1, pos.2), "end"]
    positions.2 <- data_annotation[
      between(data_annotation$start, pos.1, pos.2),
      "start"]
    positions.1.1 <- data_annotation[
      which(pos.1 >= data_annotation$start & pos.2 <= data_annotation$end), "start"]
    positions.2.2 <- data_annotation[
      which(pos.1 >= data_annotation$start & pos.2 <= data_annotation$end), "end"]
    
    positions <- unique(c(positions.1, positions.2, positions.1.1, positions.2.2))
    positions <- positions[order(positions, decreasing = FALSE)]
    features  <-
      unique(c(data_annotation[between(data_annotation$start, positions[1],
                                       last(positions)), feature],
               data_annotation[between(data_annotation$end, positions[1],
                                       last(positions)), feature]))
    
    return(features)
  }

#strand_selection used to select the strand
strand_selection <- function(data, Strand) {
  data %>%
    filter(get('strand') == Strand) %>%
    arrange(get('position'))
}

#splitGenome_function used to split the genome into same fragments
splitGenome_function <- function(x, gLength) {
  fl_v <- c()
  for (i in seq_along(unique(x))) {
    fl_v <- c(fl_v, x[which(x == i)][1])
  }
  fl_v <- na.omit(fl_v)
  fl_v <- fl_v[c(1, fl_v)]
  names(fl_v)[1] <- 1
  fl_v[1] <- 0
  frag <- as.numeric(as.character(names(fl_v)))
  frag <- c(frag, last(gLength))
  frag <- frag[!duplicated(frag)]
  return(frag)
}

#indice_function assign to distinguish between outlier, terminal or bin/probe belonging to the segment
indice_function <- function(data, col) {
  data[, "indice"] <- NA
  pos <- grep(paste0("\\D_\\d+", "$"), data[, col])
  pos_0 <- grep(paste0("\\D_\\d+\\_O", "$"), data[, col])
  pos_1 <- grep(paste0("\\D_\\d+\\_T", "$"), data[, col])
  data[pos, "indice"] <- 1
  data[pos_0, "indice"] <- 2
  data[pos_1, "indice"] <- 3
  return(data)
}

#TU_annotation plots TUs
TU_annotation <- function(data, annot, ystart, yend, color_tu, cdt) {
  pos.1_v <- c()
  pos.2_v <- c()
  annot_tmp <- (unique(data[, annot]))
  for (j in seq_along(annot_tmp)) {
    if (length(annot_tmp) == 0) {
      break ()
    }
    pos <- which(data[, annot] == annot_tmp[j])
    pos.1 <- data$position[pos[1]]
    pos.1_v <- c(pos.1_v, pos.1)
    pos.2 <- data$position[last(pos)]
    pos.2_v <- c(pos.2_v, pos.2)
  }
  segment_data <- data.frame(
    xstart = pos.1_v,
    xend = pos.2_v,
    ystart = rep(ystart, times = length(pos.1_v)),
    yend = yend,
    region = rep("r", times = length(pos.1_v)),
    color = color_tu,
    annotation = annot_tmp,
    gene = rep("g", times = length(pos.1_v)),
    cdt = cdt,
    stringsAsFactors = FALSE
  )
  if (unique(data$strand) == "-") {
    segment_data$strand <- "-"
  } else{
    segment_data$strand <- "+"
  }
  return(na.omit(segment_data))
}

#gene_annot_function plots genes or locus_tag
gene_annot_function <-
  function(pos.1,
           pos.2,
           annot,
           Strand,
           yint,
           yend,
           reg,
           col,
           cdt) {
    annot_tmp <- annot[which(annot[, "strand"] %in% Strand), ]
    annot_tmp <-
      annot_tmp[order(annot_tmp[, "start"], decreasing = FALSE), ]
    if (Strand == "-") {
      annot_tmp <- annot_tmp[between(annot_tmp[, "start"], pos.1, pos.2), ]
    } else{
      annot_tmp <- annot_tmp[between(annot_tmp[, "end"], pos.1, pos.2), ]
    }
    if (!is_empty(reg)) {
      annot_tmp <- annot_tmp[which(annot_tmp[, "region"] %in% reg), ]
      if (!is_empty(annot_tmp[, "region"])) {
        pos_v <- c()
        color_v <- c()
        for (j in seq_along(annot_tmp[, "region"])) {
          pos <- which(annot_tmp[, "region"][j] == reg)
          region <- reg[pos]
          color <- col[pos]
          pos_v <- c(pos_v, pos)
          color_v <- c(color_v, color)
        }
        segment_data <- data.frame(
          xstart = annot_tmp$start,
          xend = annot_tmp$end,
          ystart = rep(yint, times = length(color_v)),
          yend = rep(yend, times = length(color_v)),
          region = annot_tmp$region,
          color = color_v,
          annotation = annot_tmp$locus_tag,
          gene = annot_tmp$gene,
          cdt = cdt,
          strand = Strand,
          stringsAsFactors = FALSE
        )
      }
    } else{
      segment_data <- data.frame(
        xstart = annot_tmp$start,
        xend = annot_tmp$end,
        ystart = yint,
        yend = yend,
        region = rep(NA, times = length(annot_tmp$start)),
        color = rep(NA, times = length(annot_tmp$start)),
        annotation = annot_tmp$locus_tag,
        gene = annot_tmp$gene,
        strand = Strand,
        stringsAsFactors = FALSE
      )
    }
    segment_data[which(is.na(segment_data$gene)), "gene"] <-
      segment_data[which(is.na(segment_data$gene)), "annotation"]
    segment_data$xend <- ifelse(segment_data$xend > pos.2 - 2000, 
                                pos.2 - 2000, segment_data$xend)
    segment_data$xstart <- ifelse(segment_data$xstart < pos.1 + 1999, 
                                pos.1 + 2000, segment_data$xstart)
    return(segment_data)
  }

#secondaryAxis designs the secondray axis
secondaryAxis <-  function(data, parameter, ind) {
  data <- data %>%
    filter(get('indice') == ind)
  if (nrow(data) > 1 & length(data[, parameter] > 20) >= 1) {
    data[which(data[, parameter] > 20), parameter] <- 20
  }
  return(data)
}

#arrange_byGroup used to slice the rows by parameter
arrange_byGroup <- function(input, parameter) {
  slice <- slice
  if (unique(input$strand) == "+") {
    input <- as.data.frame(input %>%
                          group_by(input[, parameter]) %>%
                          arrange(get('position')) %>%
                            dplyr::slice(n()))
  }else{
    input <- as.data.frame(input %>%
                            group_by(input[, parameter]) %>%
                            arrange(get('position')) %>%
                             dplyr::slice(n()))
    input[which(input$pausing_site == "+"), "position"] <-
      input[which(input$pausing_site == "+"), "position"] + 40
    input[which(input$iTSS_I == "+"), "position"] <-
      input[which(input$iTSS_I == "+"), "position"] + 40
  }
  return(input)
}

#add an arrow to TU 
my_arrow <- function(Unit, type) {
  return(arrow(
    type = type,
    ends = "first",
    length = unit(Unit, "mm")
  ))
}

#my_segment_T plots terminal events
my_segment_T <-
  function(p,
           data,
           label,
           y,
           yend,
           dis,
           ytext,
           color,
           linetype,
           df,
           fontface) {
    p <- p +
      annotate(
        "segment",
        x = unique(data$position),
        xend = unique(data$position),
        y = y,
        yend = yend,
        size = .4,
        color = color,
        linetype = linetype
      ) +
      annotate(
        "segment",
        x = unique(data$position) + dis,
        xend = unique(data$position) - dis,
        y = yend,
        yend = yend,
        size = .2,
        color = color,
        lineend = "butt"
      ) +
      geom_text(
        data = data,
        aes(x = get('position'), y = ytext),
        label = label,
        fontface = fontface,
        color = color,
        size = 1.2
      )
    return(p)
  }

#my_segment_NS plots iTSS_II events
my_segment_NS <-
  function(p,
           data,
           label,
           y,
           yend,
           dis,
           ytext,
           color,
           linetype,
           fontface) {
    if (unique(data$strand) == "+") {
      p <- p +
        annotate(
          "segment",
          x = unique(data$position) - dis,
          xend =
            unique(data$position) - dis,
          y = y,
          yend = yend,
          size = .4,
          color = color,
          linetype = linetype
        ) +
        annotate(
          "segment",
          xend = unique(data$position),
          x = unique(data$position) + 60,
          y = yend,
          yend = yend,
          size = .2,
          arrow = my_arrow(.4, "open")
        ) +
        geom_text(
          data = data,
          aes(x = get('position'), y = ytext),
          label = label,
          fontface = fontface,
          color = color,
          size = 1
        )
    } else if (unique(data$strand) == "-") {
      p <- p +
        annotate(
          "segment",
          x = unique(data$position) + dis,
          xend = unique(data$position) + dis,
          y = y,
          yend = yend,
          size = .2,
          color = color,
          linetype = linetype
        ) +
        annotate(
          "segment",
          xend = unique(data$position) + 5,
          x = unique(data$position) - 60,
          y = yend,
          yend = yend,
          size = .2,
          arrow = my_arrow(.4, "open")
        ) +
        geom_text(
          data = data,
          aes(x = get('position'), y = ytext),
          label = label,
          fontface = fontface,
          color = color,
          size = 1
        )
    }
    return(p)
  }

#limit_function limits the scaling in delay and HL
limit_function <- function(data, parameter, ind) {
  data <- data %>%
    filter(get('indice') == ind)
  if (length(which(data[, parameter] > 10)) >= 3 &
      length(which(data[, parameter] <= 20)) >= 3) {
    Limit <- 20
  } else if (nrow(data) < 3 &
             length(which(data[, parameter] > 10)) >= 1) {
    Limit <- 20
  } else{
    Limit <- 10
  }
  return(Limit)
}

#empty_boxes plots empty boxes in case no genes or TUs are available
empty_boxes <- function(ystart,
                        yend,
                        frag = frag,
                        i = i,
                        strand) {
  data <- data.frame(
    xstart = frag[i],
    xend = frag[i + 1],
    ystart = ystart,
    yend = yend,
    region = "CDS",
    color = adjustcolor("white", alpha.f = 0.2),
    annotation = "",
    gene = NA,
    cdt = NA,
    strand = strand
  )
  return(data)
}

# function_TU_arrow finds TUs split into 2 pages
function_TU_arrow <- function(data,
                              big_data,
                              frag = frag,
                              i = i) {
  tu <- unique(data$TU)
  tu <- tu[grep("_NA", tu, invert = TRUE)]
  tu_v <- c()
  for (j in seq_along(tu)) {
    pos <- big_data[which(big_data$TU == tu[j]), "position"]
    if (unique(data$strand == "+")) {
      if (j == 1 & pos[1] < frag[i]) {
        tu_v <- c(tu_v, tu[j])
      }
    } else{
      if (last(pos) > frag[i + 1]) {
        tu_v <- c(tu_v, tu[j])
      }
    }
  }
  return(tu_v)
}

meanPosition <- function(input, parameter) {
  input <- as.data.frame(input %>%
                           group_by(input[, parameter]) %>%
                           mutate(meanPosi = mean(get('position'))))
  input <- input[!duplicated(input[, parameter]), ]
  return(input)
}

label_log2_function <-
    function(x)
        parse(text = paste0('2^', log(x, 2)))

label_square_function <- function(x)
    round(sqrt(x), 0)

coverage_function <- function(coverage, chr_fwd, chr_rev) {
    if (coverage == 1) {
        chr_fwd <- cbind.data.frame(seq_along(chr_fwd), chr_fwd, strand = "+")
        colnames(chr_fwd) <- c("position", "coverage", "strand")
        chr_rev <-
            cbind.data.frame(seq_along(chr_rev), chr_rev, strand = "-")
        colnames(chr_rev) <- c("position", "coverage", "strand")
        chr_cov <- rbind(chr_fwd, chr_rev)
    } else{
        chr_cov <- NA
    }
    return(chr_cov)
}

# II. Dynamic Programming: the scoring function is interpreted
fragment_inty <- function(probe, cores = 1, pen, pen_out) {
    num_args <- list(pen, pen_out)
    names(num_args) <- c("pen", "pen_out")
        
    registerDoMC(cores)
    
    probe <- probe[with(probe, order(-xtfrm(probe$strand), probe$position)), ]
    
    probe[probe$strand == "-", ] <-
        probe[probe$strand == "-", ][order(probe[probe$strand == "-",
        ]$position, decreasing = TRUE), ]
    
    probe[, "intensity_comb_fragment"] <- NA
    probe[, "intensity_mean_comb_fragment"] <- NA
    
    # here the assigned penalty is cached to be changed dynamically in the loop
    tmp_df <-
        data.frame(
            ID = probe$ID,
            val = probe$distance_int,
            seg = probe$position_segment
        )
    
    # here it is important that (terminal) outliers and NAs are considered, as all
    # bins have an intensity that needs to be grouped.
    tmp_df[, "seg"] <- gsub("_O|_NA", "", tmp_df$seg)
    
    # this is just for safety, nothing should be omitted here
    tmp_df <- na.omit(tmp_df)
    
    unique_seg <- unlist(unique(tmp_df$seg))
    
    count <- 1
    
    # II. Dynamic Programming: the scoring function is interpreted
    
    frags <- foreach(k = seq_along(unique_seg)) %dopar% {
        section <- tmp_df[which(tmp_df$seg == unique_seg[k]), ]
        
        best_frags <- c()
        best_names <- c()
        
        if (nrow(section) > 1) {
            # only segments with more than one value are grouped...*
            
            for (i in 2:nrow(section)) {
                tmp_score <-
                    score_fun_ave(section[seq_len(i), "val"],
                                  section[seq_len(i), "ID"], pen_out)
                tmp_name <- names(tmp_score)
                if (i > 3) {
                    for (j in (i - 1):3) {
                        tmp_val <- section[j:i, "val"]
                        tmp_ID <- section[j:i, "ID"]
                        tmp <-
                            score_fun_ave(tmp_val, tmp_ID, pen_out) + pen + best_frags[j - 2]
                        tmp_score <- c(tmp_score, tmp)
                        tmp_n <- paste0(best_names[j - 2], "|", names(tmp))
                        tmp_name <- c(tmp_name, tmp_n)
                    }
                }
                pos <- which(tmp_score == min(tmp_score))[1]
                tmp_score <- tmp_score[pos]
                tmp_name <- tmp_name[pos]
                best_frags <- c(best_frags, tmp_score)
                best_names <- c(best_names, tmp_name)
            }
        } else {
            #* ...all segments with less than two values are grouped automatically
            tmp_score <-
                score_fun_ave(section[, "val"], section[, "ID"], pen_out)
            tmp_name <- names(tmp_score)
            best_names <- c(best_names, tmp_name)
        }
        best_names[length(best_names)]
    }
    
    # III. Fill the dataframe
    
    for (k in seq_along(frags)) {
        na <- strsplit(frags[[k]], "\\|")[[1]]
        for (i in seq_along(na)) {
            tmp_trgt <- strsplit(na[i], "_")[[1]][1]
            trgt <- strsplit(tmp_trgt, ",")[[1]]
            if (length(strsplit(na[i], "_")[[1]]) == 3) {
                tmp_outl <- strsplit(na[i], "_")[[1]][3]
                outl <- strsplit(tmp_outl, ",")[[1]]
                trgt <- trgt[-which(trgt %in% outl)]
                rows <- match(outl, probe[, "ID"])
                nam <- paste0("I_", count, "_O")
                probe[rows, "intensity_comb_fragment"] <- nam
                # the mean needs to be reverted by the correction factor here
                probe[rows, "intensity_mean_comb_fragment"] <- (as.numeric(strsplit(na[i], "_")[[1]][2]))
            }
            rows <- match(trgt, probe[, "ID"])
            nam <- paste0("I_", count)
            probe[rows, "intensity_comb_fragment"] <- nam
            # the mean needs to be reverted by the correction factor here
            probe[rows, "intensity_mean_comb_fragment"] <- 
                (as.numeric(strsplit(na[i], "_")[[1]][2]))
            count <- count + 1
        }
    }
    
    if (sum(cumprod(is.na(probe$intensity_comb_fragment))) > 0) {
        probe$intensity_comb_fragment[seq_len(
            sum(cumprod(is.na(probe$intensity_comb_fragment))))] <- "I_0.5_NA"
    }
    row_NA <- which(is.na(probe$intensity_comb_fragment))
    if (length(row_NA) > 0) {
        group <- c(row_NA[1])
        for (i in seq_along(row_NA)) {
            if (is.na(probe$intensity_comb_fragment[row_NA[i] + 1])) {
                group <- c(group, row_NA[i] + 1)
            } else if (gsub("_O", "", probe$intensity_comb_fragment[group[1] - 1]) ==
                       gsub("_O", "", probe$intensity_comb_fragment[group[length(group)] + 1])) {
                probe$intensity_comb_fragment[group] <-
                    paste0(gsub("_O", "", probe$intensity_comb_fragment[group[1] - 1]), "_NA")
                probe$intensity_mean_comb_fragment[group] <-
                    probe$intensity_mean_comb_fragment[group[1] - 1]
                group <- row_NA[i + 1]
            } else if (probe$intensity_comb_fragment[group[1] - 1] !=
                       probe$intensity_comb_fragment[group[length(group)] + 1]) {
                probe$intensity_comb_fragment[group] <-
                    paste0("I_", as.numeric(gsub(
                        "I_|_O", "", probe$intensity_comb_fragment[group[1] - 1]
                    )) + 0.5, "_NA")
                group <- row_NA[i + 1]
            }
        }
        probe$intensity_comb_fragment[is.na(probe$intensity_comb_fragment)] <-
            paste0("I_", as.numeric(gsub(
                "I_|_O", "", probe$intensity_comb_fragment[!is.na(probe$intensity_comb_fragment)]
                [length(probe$intensity_comb_fragment[!is.na(probe$intensity_comb_fragment)])]
            )) + 0.5, "_NA")
    }
    probe
}

# =========================================================================
# figures_fun                    
# -------------------------------------------------------------------------
#' 'figures_fun': generates several plots 
#' 
#' 'figures_fun' plots at one the density of HL, the HL category as histogram, 
#' log2FC of decay and synthesis rate and their heatscatter. Scatter plot of HL
#' and volcano plot. The function uses the four output generated previously.
#' 
#' The functions used are:
#' 
#'  plot_decay_synt: plots the changes in RNA decay rates versus the changes 
#'  in RNA synthesis rates 
#'    
#'  plot_heatscatter: plots the changes in RNA decay rates versus the changes 
#'  in RNA synthesis rates with density.
#'  
#'  plot_volcano: plots statistical significance  versus magnitude of change .
#'  
#'  plot_histogram: plot a histogram of probe/bin half-life categories from 
#'  2 to 20 minutes in both conditions.
#'  
#'  plot_density: plots the probe/bin half-life density in both conditions.
#'  
#'  plot_scatter: plots of the bin/probe half-life in one condition1 vs.
#'  condition2.
#' 
#' extract the object of rifi_statistics from both conditions. 
#' The differential gene expression at time 0 needs to be run separately. 
#' The columns log2FC, p_value adjusted, position and strand are extracted and 
#' saved to a data frame. loading_fun_fig joins the differential gene expression 
#' table and the output from rifi statistics into one data frame.
#'
#' @param data.1 data frame output of statistic
#' @param data.2 data frame joining two outputs from rifi_stats by row
#' @param input.1 data frame joining two outputs from rifi_stats by column
#' @param input.2 data frame of differential gene expression at time 0
#' @param cdt1 string for the first condition
#' @param cdt2 string for the second condition
#' @param y integer to break the scaling in scatter plot for y_axis
#' @param x integer to break the scaling in scatter plot for x_axis
#' @param limits vector to limit the scaling in scatter plot for both axis
#'
#' @return several plots
#'
#' @examples
#' data(data_combined_minimal)
#' data(df_comb_minimal)
#' data(differential_expression) 
#' data(df_mean_minimal)
#' figures_fun(data.1 = df_mean_minimal, data.2 = data_combined_minimal, 
#' input.1 = df_comb_minimal, input.2 = differential_expression, cdt1 = "sc", 
#' cdt2 = "fe") 
#' 
#' @export


figures_fun <- function(data.1, data.2, input.1, input.2, cdt1, cdt2, y = 30, 
                        x = 30, limits = c(0, 20)) {
    
    # log2FC(decay.rate) vs. log2FC(synthesis.rate)
    # data.1 = df_mean_minimal
    plot_decay_synt(data.1)
    
    # plot heatscatter log2FC(decay.rate) vs. log2FC(synthesis.rate)
    # data.1 = df_mean_minimal
    plot_heatscatter(data.1)
    
    # plot density of HL
    # data.2 = data_combined_minimal
    plot_density(data.2, cdt1 = cdt1, cdt2 = cdt2)
    
    # plot histogram of HL classification
    # input.1 = df_comb_minimal
    plot_histogram(input.1, cdt1 = cdt1, cdt2 = cdt2)
    
    # plot scatter of HL
    # input.1 = df_comb_minimal
    plot_scatter(input.1)
    
    # plot volcano plot
    # input.2 = differential_expression
    plot_volcano(input.2)
    
}

---
title: "rifiComparative"

author: "Loubna Youssar"

date: "`r Sys.Date()`"
output:
  BiocStyle::html_document:
    toc: true
    toc_float: true
    number_sections: false
vignette: >
  %\VignetteIndexEntry{rifiComparative}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
```{r, include=FALSE}
devtools::load_all(".")
```

```{r setup, include = FALSE}
knitr::opts_chunk$set(echo = TRUE,
                      message = TRUE,
                      warning = TRUE)
```


``` {r, echo = FALSE, message = FALSE}
require(rifiComparative)
suppressPackageStartupMessages(library(SummarizedExperiment))
```

## 0. Installation

Required dependencies are cited on README, please make sure they are properly
installed (README).
All functions should be located on the same folder and add them to your 
path directory.

## I. Introduction

rifiComparative is a successor framework of `r BiocStyle::Biocpkg("rifi")`
*(https://github.com/CyanolabFreiburg/rifi)*. Generated outputs from the same
organism with different treatments could be compared. Trying to combine segments
of the same gene from different conditions is not straight forward and makes the
data analysis nearly impossible. Therefore we developed a new workflow, 
rifiComparative, with an easy strategy to make 2 conditions comparable. 
The principle of rifiComparative consists on segmenting the half-life 
(difference between half-life (condition1) and half-life (condition2) 
at probe/bin level) and segmenting intensity using the log2FC(mRNA at time 0). 
The workflow does not apply any hierarchy. Half-life (in some cases, HL) and 
intensity segmentation are independent.  
The fragments result of clustering from half-life and intensity are compared using
log2FC(log2FC(half-life)/log2FC(intensity)). These values are a pre-analysis for
transcription and post-transcription regulation. Events for each treatment are 
depicted with the position on the genome (For more detail, refer to section visualization).
P-values from statistical tests are estimated. rifiComparative generates data frame summary, genome plot and several figures (refer to section Plots for more details).


## II. Workflow

### 1. Joining data

The first step is combining the data from two conditions. The data are combined
by row on one hand and combined by column on the other hand. Both objects are 
saved and used as input for the next analysis.

The functions used are:

`loading_fun`: you need to load either `rifi_fit` or `rifi_stats` outputs from
each condition and place all in one directory. `rifi_fit` is sufficient to run the 
workflow unless if you want to select more column from `rifi_stats` for more 
analysis or plot. The "cdt" is added referring to the sample condition. 

<span style="color:red"> Very important: </span> you will need to run the 
differential expression at probe/bin level. This is the log2FC(intensity) or 
log2FC(mRNA at time 0). Pick-up the logFC, the p_value adjusted, probe position 
and strand columns. Save the first two as `logFC_int` and `P.Value`. You can use either `left_join` or `right_join` from the `r BiocStyle::CRANpkg("dplyr")` 
package to join both data by strand and position. 
<br/><br/>

``` {r loading_fun, eval = TRUE}
data(stats_se_cdt1)
data(stats_se_cdt2)
data(differential_expression)
inp_s <-  
    loading_fun(stats_se_cdt1, stats_se_cdt2, differential_expression)[[1]]
head(inp_s, 5)
inp_f <- 
    loading_fun(stats_se_cdt1, stats_se_cdt2, differential_expression)[[2]]
head(inp_f, 5)
```
<br/><br/>

`joining_data_row`: contains `joining_data_row` function. It gathers data frame 
from both conditions in one by rows. The object is called data_combined_se.rda
<br/><br/>

``` {r joining_data_row, eval = TRUE}
data(inp_s)
data(inp_f)
data_combined_minimal <- 
joining_data_row(input1 = inp_s, input2 = inp_f)
head(data_combined_minimal, 5)
```
<br/><br/>

`joining_data_column`: contains `joining_data_column` function. It gathers 
data frame from both conditions in one by columns. The object is called 
df_comb_se.rda
<br/><br/>

``` {r joinging_data_column, eval = TRUE}
data(data_combined_minimal)
df_comb_minimal <- joining_data_column(data = data_combined_minimal)
head(df_comb_minimal, 5)
```

### 2. Penalties

Same as `r BiocStyle::Biocpkg("rifi")` workflow, to get the best segmentation we
need the optimal penalties. 
To calculate half-life penalty, the difference between half-life from both conditions is calculated and added as `distance_HL` variable to `df_comb_minimal`
data frame.
On other hand the `logFC_int` is used to assign penalties for intensity values 
and added as distance_int variable. `df_comb_minimal` with the additional variables
is named `penalties_df`.

The functions needed for penalty are:

`make_pen` calls one of two available penalty functions to automatically assign
penalties for the dynamic programming. Four functions are called:

 * `make_pen`
 * `fragment_HL_pen`
 * `fragment_inty_pen`
 * `score_fun_ave`

#### 1. `make_pen`

`make_pen` calls one of two available penalty functions to automatically
assign penalties for the dynamic programming. the function iterates over many
penalty pairs and picks the most suitable pair based on the difference between
wrong and correct splits. The sample size, penalty range and resolution as well
as the number of cycles can be customized. The primary start parameters create 
a matrix with n = `rez_pen` rows and n = `rez_pen_out` columns with values between
sta_pen/sta_pen_out and end_pen/end_pen_out. The best penalty pair is
picked. If dept is bigger than 1 the same process is repeated with a new matrix
of the same size based on the result of the previous cycle. Only position
segments with length within the sample size range are considered for the
penalties to increase run time. Also, outlier penalties cannot be smaller
than 40% of the respective penalty. For more detail check vignette from `r BiocStyle::Biocpkg("rifi")` package.
<br/><br/>

#### 2. `fragment_HL_pen`

`fragment_HL_pen` is called by `make_pen` function to automatically assign
penalties for the dynamic programming of half-life fragments. The function used 
for `fragment_HL_pen` is `score_fun_ave`. `score_fun_ave` scores the values of 
y on how close they are to the mean. for more details, see below.
<br/><br/>

``` {r make_pen HL, eval = FALSE}

df_comb_minimal[,"distance_HL"] <-
    df_comb_minimal[, "half_life.cdt1"] - df_comb_minimal[, "half_life.cdt2"]

pen_HL <- make_pen(
    probe = df_comb_minimal,
    FUN = rifiComparative:::fragment_HL_pen,
    cores = 2,
    logs = as.numeric(rep(NA, 8))
)
```
<br/><br/>

#### 3. `fragment_inty_pen`

`fragment_inty_pen` is called by `make_pen` function to automatically assign
penalties for the dynamic programming of intensity fragments. 
The function used is `score_fun_ave`.

``` {r make_pen int, eval = FALSE}

df_comb_minimal[,"distance_int"] <- df_comb_minimal[,"logFC_int"]

pen_int <- make_pen(
    probe = df_comb_minimal,
    FUN = rifiComparative:::fragment_inty_pen,
    cores = 2,
    logs = as.numeric(rep(NA, 8))
)
```
<br/><br/>

``` {r penalties, eval = TRUE}
data(df_comb_minimal) 
penalties_df <- penalties(df_comb_minimal)[[1]]
pen_HL <- penalties(df_comb_minimal)[[2]]
pen_int <- penalties(df_comb_minimal)[[3]]
head(penalties_df, 5)
```
<br/><br/>

#### 4. `score_fun_ave`

`score_fun_ave` scores the values of y on how close they are to the mean. 
for more details, see below.
<br/><br/>

### 3. Fragmentation

After finding the optimal set of penalties, fragmentation process could be applied.
The functions used are:
 
 `fragment_HL`
 `fragment_inty`
 `score_fun_ave`

#### 1. `fragment_HL`

`fragment_HL` performs the half_life fragmentation and assigns all gathered 
information to the probe based data frame. The columns `HL_comb_fragment` and 
`HL_mean_comb_fragment` are added to data frame. `fragment_HL` makes 
half-life_fragments and assigns the mean of each fragment.

``` {r fragment_HL, eval = TRUE}
penalties_df <-
    fragment_HL(
    probe = penalties_df,
    cores = 2,
    pen = pen_HL[[1]][[9]],
    pen_out = pen_HL[[1]][[10]]
)
```
<br/>

#### 2. `fragment_inty`

`fragment_inty` performs the intensity fragmentation and assigns all gathered
information to the probe based data frame. The columns `intensity_comb_fragment`
and `intensity_mean_comb_fragment` are added to the data frame. `fragment_inty` 
makes `intensity_fragments` and assigns the mean of each fragment.
The hierarchy is not followed, fragments from different size could be generated 
independently of half-life fragments.

``` {r fragment_inty, eval = TRUE}
fragment_int <-
    fragment_inty(
        probe = penalties_df,
        cores = 2,
        pen = pen_int[[1]][[9]],
        pen_out = pen_int[[1]][[10]]
    )
head(fragment_int, 5)
```
<br/>

#### 3. `score_fun_ave`

`score_fun_ave` is the score function used by dynamic programming for intensity
fragmentation, for more details, see below.

### 4. Statistics

To check segment significance, t-test with two.sided was used. Each fragment was
tested for the number of probes involved in each condition.

``` {r t_test_function_HL, eval = TRUE}
data(fragment_int)
stats_df_comb_minimal <- statistics(data= fragment_int)[[1]]
df_comb_uniq_minimal <- statistics(data= fragment_int)[[2]]
```

### 5. Visualization

The visualization depicts half-life and intensity slots of the fragments. Since 
hierarchy is not applied, the fragments from half-life and intensity are 
independent.

``` {r rifi_visualization_comparison, eval = FALSE}
data(data_combined_minimal)
data(stats_df_comb_minimal)
data(annot_g)
rifi_visualization_comparison(
     data = data_combined_minimal,
     data_c = stats_df_comb_minimal,
     genomeLength = annot_g[[2]],
     annot = annot_g[[1]]
     )
```

Three objects are required:

 `data_combined_minimal` : data frame from joined data by row.
 `df_comb_minimal` : data frame from joined data by column
 `annot` : ggf3 preprocessed (for more information, see below)
 
The plot is located on vignette "genome_fragments_comparison.pdf" and shows 3 sections: `annotation`, half-life difference and log2FC (mRNA=time0 or intensity).
Either half_life difference or log2FC(intensity), the line 0 indicates no changes between both conditions. Conditions 1 and 2 are indicated by blue and lilac color respectively. Fragments result of dynamic programming are indicated by different colors.
The annotation englobes genome annotation preprocessed by gff3_preprocessing function included on the package and a superposed TU annotation of both conditions from
`r BiocStyle::Biocpkg("rifi")` output.

<br/><br/>
``` {r visualization, echo = FALSE, fig.cap = "**genome fragments visualization of both conditions**", out.width = '100%'}
knitr::include_graphics("visualization_cdts.png")
```
<br/>

## III. Outputs

### 1. `adjusting_HLToInt`

`adjusting_HLToInt` function combines half-life and intensity fragments generated 
without hierarchy on one hand and the genome annotation on other hand. The first
step is adjusting the fragments from half-life to intensity and vise-versa and join 
them to the genome annotation. To make half-life and intensity segments comparable, 
`log2FC(HL)` is used instead of `distance_HL`. At least one fragment should have 
a significant p_value from t-test, either half-life or intensity. 

To generate the data frame, two objects are required:

 `df_comb_minimal` : data frame from joined data by column.
 `annot` : ggf3 preprocessed (for more information, see below).

The functions used are:

`p_value_function` extracts and return the p_values of half-life and intensity segments respectively.

`eliminate_outlier_hl` eliminates outliers from half-life fragments.

`eliminate_outlier_int` eliminates outliers from intensity fragments.

`mean_length_int` extracts the mean of the log2FC(intensity) fragments adapted 
to HL_fragments and their lengths.

`mean_length_hl` extracts the mean of log2FC(HL) fragments adapted to the 
intensity fragments and their lengths.

`calculating_rate` calculates decay rate and log2FC(intensity). Both are used to
calculate synthesis rate.

The output data frame contains the corresponding columns:

 **position**: position of the first fragment
 **region**:  region annotation covering the fragments
 **gene**: gene annotation covering the fragments
 **locus_tag**: locus_tag annotation covering the fragments
 **strand**: The bin/probe specific strand (+/-)
 **fragment_HL**: Half-life fragments
 **fragment_int**: intensity fragments
 **position_frg_int**: position of the first fragment and the last position of 
 the last fragment.
 **mean_HL_fragment**: mean of the HL of the fragments involved.
 **mean_int_fragment**: mean of the intensity of the fragments involved.
 **log2FC(decay_rate)**: log2FC(decay(condition1)/decay(condition2)).
 **log2FC(synthesis_rate)**: sum of log2FC(decay_rate) and log2FC(intensity).
 **Log2FC(HL)-Log2FC(int)**: sum of log2FC(decay_rate) and log2FC(intensity).
 **intensity_FC**: log2FC(mean(intensity(condition1))/mean(intensity(condition2))).
 **Log2FC(HL)-Log2FC(int)**: sum of log2FC(decay_rate) and log2FC(intensity).
 **p_value**: indicated by "*" means at least one fragment either half-life fragment or intensity fragment has a significant p_value.

``` {r adjusting_HLToInt, eval = TRUE}
data(stats_df_comb_minimal) 
data(annot_g)
df_adjusting_HLToInt <- adjusting_HLToInt(data = stats_df_comb_minimal, 
                                          annotation = annot_g[[1]])
head(df_adjusting_HLToInt, 5)
```

## IV. Plots

A serie of plots could be generated using the `figures_fun`. The functions
included are:

`plot_decay_synt`

`plot_heatscatter`

`plot_density`

`plot_histogram`

`plot_scatter`

`plot_volcano`

<br/>
``` {r figures_fun, eval = FALSE, echo = TRUE, out.width = '100%'}
 data(data_combined_minimal)
 data(df_comb_minimal)
 data(differential_expression) 
 data(df_mean_minimal)
 figures_fun(data.1 = df_mean_minimal, data.2 = data_combined_minimal, 
 input.1 = df_comb_minimal, input.2 = differential_expression, cdt1 = "sc", 
 cdt2 = "fe") 
```
<br/>

### 1. `plot_decay_synt`

The generated data frame `df_mean_minimal` could be used to plot changes in RNA
decay rates (log fold, x-axis) versus the changes in RNA synthesis rates (log fold, y-axis) in the condition 1 versus condition 2. The black lines horizontal, vertical and diagonal are the median of synthesis_rate, decay_rate and mRNA at time 0 respectively. Dashed gray lines indicate 0.5-fold changes from 0 (gray lines) referring to unchanged fold.
Coloration could be adjusted upon the parameter selected. In this case decay rate 
above 0.5 and synthesis rate below -0.5 are highlighted in yellow.
Segments could be labeled using `geom_text_repel` function, they are commented on
the function.

<br/><br/>
``` {r, echo = FALSE, fig.cap = "**\\label{fig:figs}Decay rate vs. Synthesis rate**", out.width = '100%'}
knitr::include_graphics("Decay_rate_vs_Synthesis_rate.png")
```
<br/>


### 2. `plot_heatscatter`

Heatscatter plot could be generated using "df_mean_minimal" data frame. It plots
the changes in RNA decay rates (log fold, x-axis) versus the changes in RNA 
synthesis rates (log fold, y-axis) in the condition 1 versus condition 2. 
The coloring indicates the local point density.

<br/><br/>
``` {r, echo = FALSE, fig.cap = "**\\label{fig:figs}Heatscatter Decay rate vs. Synthesis rate**", out.width = '100%'}
knitr::include_graphics("heatscatter_Decay_rate_vs_Synthesis_rate.png")
```
<br/>

### 3. `plot_density`

The function uses the `data_combined_minimal` to plot the probe/bin half-life 
density in both conditions. Condition 1 and 2 could be indicated.

<br/><br/>
``` {r, echo = FALSE, fig.cap = "**\\label{fig:figs}Half-life Density**", out.width = '100%'}
knitr::include_graphics("density_HL.png")
```
<br/>

### 4. `plot_histogram`

The function uses `df_comb_minimal` to plot a histogram of probe/bin half-life 
categories from 2 to 20 minutes in both conditions. Condition 1 and 2 could be
indicated.

<br/><br/>
``` {r, echo = FALSE, fig.cap = "**\\label{fig:figs}Half-life Classification**", out.width = '100%'}
knitr::include_graphics("histogram_count.png")
```
<br/>

### 5. `plot_scatter`

A scatter plot of the bin/probe half-life in condition 1 vs. condition 2. 

<br/><br/>
``` {r, echo = FALSE, fig.cap = "**\\label{fig:figs}Half-life Scatter Plot **", out.width = '100%'}
knitr::include_graphics("scatter_plot_HL.png")
```
<br/>


### 6. `plot_volcano`

A volcano plot of statistical significance (P value) versus magnitude of change 
(fold change).
    
<br/><br/>
``` {r, echo = FALSE, fig.cap = "**\\label{fig:figs}Volcano Plot**", out.width = '100%'}
knitr::include_graphics("volcano_plot.png")
```
<br/>

## III. Additional functions

### 1. `score_fun_ave`

`score_fun_ave` scores the difference of the values from their mean.
`score_fun_ave` calculates the mean of a minimum 2 values **y** and substrates
the difference from their mean. The IDs **z** and the sum of differences from
the mean are stored. A new value y is added, the mean is calculated and the new
IDs and sum of differences are stored. After several rounds, the minimum score
and the corresponding IDs is selected and stored as the best fragment.
`score_fun_ave` selects simultaneously for outliers, the maximum number is fixed
previously. Outliers are those values with high difference from the mean, they
are stored but excluded from the next calculation. The output of the function is
a vector of IDs separated by ",", a vector of mean separated by "_" and a
vector of outliers separated by ",".

### 2. `gff3_preprocess`

`gff3_preprocess` processes gff3 file from database, extracting gene names and
locus_tag from all coding regions (CDS). Other features like UTRs, ncRNA, asRNA
ect.. if available and the genome length are extracted. The output is a list of 
2 elements.

The output data frame from `gff3_preprocess` function contains the following
columns:

a. *region*: CDS or any other available like UTRs, ncRNA, asRNA
b. *start*: start position of the gene
c. *end*: end position of the gene
d. *strand*: +/-
e. *gene*: gene annotation if available otherwise locus_tag annotation replaces
it
f. *locus_tag*: locus_tag annotation
<br/><br/>
``` {r gff3_preprocess}
gff3_preprocess(path = gzfile(
   system.file("extdata", "gff_synechocystis_6803.gff.gz", package = "rifiComparative")
 ))
```
<br/><br/>

``` {r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{pen_int}
\alias{pen_int}
\title{The result of penalties for df_comb_minimal example data.
A list containing the output from penalties including the logbook and two
penalty objects.}
\format{
A list with 5 items:
\describe{
\item{pen_int:}{A list with 4 items:
\describe{
\item{logbook:}{The logbook vector containing intensity penalty
information}
\item{int_penalties:}{a vector with the intensity penalty and
intensity outlier penalty}
\item{correct:}{a matrix of the correct splits}
\item{wrong:}{a matrix of the incorrect splits}
}
}
}
}
\source{
\url{https://github.com/CyanolabFreiburg/rifi}
}
\usage{
data(pen_int)
}
\description{
The result of penalties for df_comb_minimal example data.
A list containing the output from penalties including the logbook and two
penalty objects.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fragmentation.r
\name{fragmentation}
\alias{fragmentation}
\title{fragmentation: Conveniently wraps all fragmentation steps}
\usage{
fragmentation(data, pen_HL, pen_int, cores = 2)
}
\arguments{
\item{data}{data frame: data frame combined data by column}

\item{pen_HL}{list: list of the penalties set optimal for the fragmentation
for half-life}

\item{pen_int}{list: list of the penalties set optimal for the fragmentation
for intensity}

\item{cores}{integer: the number of assigned cores for the task. It needs to
be increased in case of big data.}
}
\value{
Two data frames with half-life and intensity fragments and the mean
of the coefficient fragment based.
}
\description{
fragmentation fragments the half-life and intensity into segments using
the penalties output.
}
\examples{
data(penalties_df)
data(pen_HL)
data(pen_int)
df_comb_minimal <- fragmentation(data = penalties_df, pen_HL, 
pen_int)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/joining_data_column.r
\name{joining_data_column}
\alias{joining_data_column}
\title{joining_data_column joins two data frames by column}
\usage{
joining_data_column(data)
}
\arguments{
\item{data}{data frame with joined columns from both conditions}
}
\value{
The data frame with joined columns from both conditions with the
corresponding columns: strand, position, ID, intensity.cdt1, position_segment,
half_life.cdt1, TI_termination_factor.cdt1", HL_fragment.cdt1,
intensity_fragment.cdt1, TI_termination_fragment.cdt1, logFC_int, P.Value,
intensity.cdt2, half_life.cdt2, TI_termination_factor.cdt2, HL_fragment.cdt2,
intensity_fragment.cdt2, TI_termination_fragment.cdt2.

cdt1: first condition, cdt2: second condition.
}
\description{
'joining_data_column': joins two data frames from different conditions by
column.
}
\examples{
data(data_combined_minimal)
df_comb_minimal <- joining_data_column(data = data_combined_minimal)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make_pen.r
\name{make_pen}
\alias{make_pen}
\title{make_pen assigns automatically penalties}
\usage{
make_pen(
  probe,
  FUN,
  cores = 1,
  logs,
  dpt = 1,
  smpl_min = 10,
  smpl_max = 100,
  sta_pen = 0.5,
  end_pen = 4.5,
  rez_pen = 9,
  sta_pen_out = 0.5,
  end_pen_out = 3.5,
  rez_pen_out = 7
)
}
\arguments{
\item{probe}{data frame: data frame combined data by column}

\item{FUN}{function: one of the four bottom level functions (see details)}

\item{cores}{integer: the number of assigned cores for the task}

\item{logs}{numeric vector: the logbook vector.}

\item{dpt}{integer: the number of times a full iteration cycle is repeated
with a more narrow range based on the previous cycle.}

\item{smpl_min}{integer: the smaller end of the sampling size.}

\item{smpl_max}{integer: the larger end of the sampling size.}

\item{sta_pen}{numeric: the lower starting penalty.}

\item{end_pen}{numeric: the higher starting penalty.}

\item{rez_pen}{numeric: the number of penalties iterated within the penalty
range.}

\item{sta_pen_out}{numeric: the lower starting outlier penalty.}

\item{end_pen_out}{numeric: the higher starting outlier penalty.}

\item{rez_pen_out}{numeric: the number of outlier penalties iterated within
the outlier penalty range.}
}
\value{
A list with 4 items:
\describe{
\item{logbook:}{The logbook vector containing all penalty information}
\item{penalties:}{a vector with the respective penalty and outlier
penalty}
\item{correct:}{a matrix of the correct splits}
\item{wrong:}{a matrix of the incorrect splits}
}
}
\description{
make_pen calls one of four available penalty functions to automatically
assign penalties for the dynamic programming.
The two functions to be called are:
\enumerate{
\item fragment_HL_pen
\item fragment_inty_pen
}
}
\details{
The two functions called return the amount of statistically correct and
statistically wrong splits at a specific pair of penalties.
'make_pen' iterates over many penalty pairs and picks the most suitable pair
based on the difference between wrong and correct splits.
The sample size, penalty range and resolution as well as the number of cycles
can be customized.
The primary start parameters create a matrix with n = rez_pen rows and
n = rez_pen_out columns with values between sta_pen/sta_pen_out
and end_pen/end_pen_out. The best penalty pair is picked. If dept is bigger
than 1 the same process is repeated with a new matrix of the same size
based on the result of the previous cycle. Only position segments with length
within the sample size range are considered for the penalties to increase
run time.
}
\examples{
data(df_comb_minimal)

df_comb_minimal$distance_HL <- df_comb_minimal$half_life.cdt1 -
df_comb_minimal$half_life.cdt2

df_comb_minimal$distance_int <- df_comb_minimal$logFC_int

pen_HL <- make_pen(
  probe = df_comb_minimal, FUN = rifiComparative:::fragment_HL_pen, 
  cores = 2, logs = as.numeric(rep(NA, 8)), dpt = 1, smpl_min = 10, 
  smpl_max = 50, sta_pen = 0.5, end_pen = 4.5, rez_pen = 9, sta_pen_out = 0.5,
  end_pen_out = 3.5, rez_pen_out = 7
)

pen_int <- make_pen(
  probe = df_comb_minimal, FUN = rifiComparative:::fragment_inty_pen, 
  cores = 2, logs = as.numeric(rep(NA, 8)), dpt = 1, smpl_min = 10, 
  smpl_max = 50, sta_pen = 0.5, end_pen = 4.5, rez_pen = 9, sta_pen_out = 0.5,
  end_pen_out = 3.5, rez_pen_out = 7
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{differential_expression}
\alias{differential_expression}
\title{An example data frame from Synechosystis PCC 6803 differential probes
expression obtained from limma package and only interesting variables were
selected. The data frame was used entirely.}
\format{
A data frame of differential_expression with 55508 rows and 4 variables:
\describe{
\item{position:}{The bin/probe specific position}
\item{strand:}{The strand specific}
\item{logFC_int:}{The bin/probe differential expression}
\item{P.Value:}{The bin/probe p_value adjusted}
}
}
\source{
\url{https://github.com/CyanolabFreiburg/rifiComparative}
}
\usage{
data(differential_expression)
}
\description{
An example data frame from Synechosystis PCC 6803 differential probes
expression obtained from limma package and only interesting variables were
selected. The data frame was used entirely.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{inp_s}
\alias{inp_s}
\title{The result of loading_fun for stats_se_cdt1 example data
Two data frame containing the output of loading_fun as first element of a
list.}
\format{
A data frame with 500 rows and 49 variables:
\describe{
\item{strand:}{The strand specific}
\item{position:}{The bin/probe specific position}
\item{ID:}{The bin/probe specific ID}
\item{FLT:}{The bin/probe flag for background level}
\item{intensity:}{The relative intensity at time point 0}
\item{probe_TI:}{An internal value to determine which fitting model is
applied}
\item{flag:}{Information on which fitting model is applied}
\item{position_segment:}{The position based segment}
\item{delay:}{The delay value of the bin/probe}
\item{half_life:}{The half-life of the bin/probe}
\item{TI_termination_factor:}{The termination factor of the bin/probe}
\item{delay_fragment:}{The delay fragment the bin belongs to}
\item{velocity_fragment:}{The velocity value of the respective delay
fragment}
\item{intercept:}{The vintercept of fit through the respective delay
fragment}
\item{slope:}{The slope of the fit through the respective delay fragment}
\item{HL_fragment:}{The half-life fragment the bin belongs to}
\item{HL_mean_fragment:}{The mean half-life value of the respective
half-life fragment}
\item{intensity_fragment:}{The intensity fragment the bin belongs to}
\item{intensity_mean_fragment:}{The mean intensity value of the respective
intensity fragment}
\item{TU:}{The overarching transcription unit}
\item{TI_termination_fragment:}{The TI fragment the bin belongs to}
\item{TI_mean_termination_factor:}{The mean termination factor of the
respective TI fragment}
\item{seg_ID:}{The combined ID of the fragment}
\item{pausing_site:}{presence of pausing site indicated by +/-}
\item{iTSS_I:}{presence of iTSS_I indicated by +/-}
\item{ps_ts_fragment:}{The fragments involved in pausing site or iTSS_I}
\item{event_ps_itss_p_value_Ttest:}{p_value of pausing site or iTSS_I}
\item{p_value_slope:}{p_value of the slope}
\item{delay_frg_slope:}{the slope value of the respective delay fragment}
\item{velocity_ratio:}{Integer, ratio of velocity between 2 delay fragments}
\item{event_duration:}{Integer, the duration between two delay fragments}
\item{event_position:}{Integer, the position middle between 2 fragments with an event}
\item{FC_HL:}{Integer, the fold change value of 2 HL fragments}
\item{FC_fragment_HL:}{Integer, the fold change value of 2 intensity fragments}
\item{p_value_HL:}{p_value of the fold change of HL fragments}
\item{FC_intensity:}{Integer, the fold change value of 2 intensity fragments}
\item{FC_fragment_intensity:}{String, fragments involved in fold change
between 2 intensity fragments}
\item{p_value_intensity:}{p_value of the fold change of intensity fragments}
\item{FC_HL_intensity:}{ratio of fold change between 2 half-life fragments
and fold change between 2 intensity fragments}
\item{FC_HL_intensity_fragment:}{fragments involved on ratio of fold
change between 2 half-life fragments and fold change between 2 intensity
fragments}
\item{FC_HL_adapted:}{Integer, the fold change of half-life/ fold change of
intensity, position of the half-life fragment is adapted to intensity fragment}
\item{synthesis_ratio:}{Integer, the value correspomding to synthesis rate}
\item{synthesis_ratio_event:}{String, the event assigned by synthesis rate
either  Termination or iTSS}
\item{p_value_Manova:}{p_value of the variance between two fold-changes,
HL and intensity}
\item{p_value_TI:}{p_value of TI fragment}
\item{TI_fragments_p_value:}{p_value of 2 TI fragments}
\item{cdt:}{The condition assigned to the experiment here cdt1}
\item{logFC_int:}{The bin/probe log2 fold change of intensity at time 0}
\item{P.Value:}{The bin/probe p_value adjusted }
}
}
\source{
\url{https://github.com/CyanolabFreiburg/rifiComparative}
}
\usage{
data(inp_s)
}
\description{
The result of loading_fun for stats_se_cdt1 example data
Two data frame containing the output of loading_fun as first element of a
list.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/joining_data_row.r
\name{joining_data_row}
\alias{joining_data_row}
\title{joining_data_row joins two data frames by row}
\usage{
joining_data_row(input1, input2)
}
\arguments{
\item{input1}{data frame from SummarizedExperiment output of rifi_stats
from rifi package of the first condition.}

\item{input2}{data frame from SummarizedExperiment output of rifi_stats
from rifi package of the second condition.}
}
\value{
The data frame with joined rows from both conditions with the
corresponding columns: ID with position, strand, intensity, probe_TI, flag,
position_segment, delay, half_life, TI_termination_factor, delay_fragment,
velocity_fragment, intercept, slope, HL_fragment, HL_mean_fragment,
intensity_fragment, intensity_mean_fragment, TU, TI_termination_fragment,
TI_mean_termination_factor, seg_ID, pausing_site, iTSS_I, ps_ts_fragment,
event_ps_itss_p_value_Ttest, p_value_slope, delay_frg_slope, velocity_ratio,
event_duration, event_position, FC_HL, FC_fragment_HL, p_value_HL,
FC_intensity, FC_fragment_intensity, p_value_intensity, FC_HL_intensity,
FC_HL_intensity_fragment, FC_HL_adapted, synthesis_ratio,
synthesis_ratio_event, p_value_Manova, p_value_TI, cdt (condition),
logFC_int (log2FC(intensity)), P.Value of log2FC(intensity)
}
\description{
joining_data_row joins two data frames from different conditions by row.
}
\examples{
data(inp_s)
data(inp_f)
data_combined_minimal <- 
joining_data_row(input1 = inp_s, input2 = inp_f)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rifi_visualization_comparison.r
\name{rifi_visualization_comparison}
\alias{rifi_visualization_comparison}
\title{rifi_visualization_comparison plots the segments and genome annotation}
\usage{
rifi_visualization_comparison(
  data,
  data_c,
  genomeLength = annot_g[[2]],
  annot = annot_g[[1]],
  condition = c("cdt1", "cdt2"),
  Strand = c("+", "-"),
  region = c("CDS", "asRNA", "5'UTR", "ncRNA", "3'UTR", "tRNA"),
  color_region = c("grey0", "red", "blue", "orange", "yellow", "green", "white",
    "darkseagreen1", "grey50", "black"),
  color_TU = c("cyan", "yellow", "orange"),
  scaling_TU = c(0, 3.4, 6.6),
  color_text.1 = "grey0",
  color_text.2 = "black",
  Alpha = 0.5,
  size_tu = 1.6,
  size_locusTag = 1.6,
  size_gene = 1.6,
  Limit = 10,
  shape = 22,
  face = "bold",
  tick_length = 0.3,
  arrow.color = "darkseagreen1",
  col_above20 = "#00FFFF",
  fontface = "plain",
  shape_above20 = 14,
  axis_text_y_size = 3,
  axis_title_y_size = 6,
  iTSS_threshold = 1.2,
  p_value_manova = 0.05,
  termination_threshold = 0.8
)
}
\arguments{
\item{data}{dataframe: the probe based dataframe with joined columns.}

\item{data_c}{dataframe: the probe based dataframe with joined rows.}

\item{genomeLength}{integer: genome length output of gff3_preprocess
function.}

\item{annot}{dataframe: the annotation file.}

\item{condition}{string: assigned as cdt1 (condition 1) and cdt2
(condition2), it could be adapted to any name.}

\item{Strand}{string: either ("+" or "-").}

\item{region}{dataframe: gff3 features of the genome.}

\item{color_region}{string vector: vector of colors.}

\item{color_TU}{string. TU color}

\item{scaling_TU}{vector: values to adjusted termination and iTSSs to TUs.}

\item{color_text.1}{string: TU color text}

\item{color_text.2}{string: genes color text}

\item{Alpha}{integer: color transparency degree.}

\item{size_tu}{integer: TU size}

\item{size_locusTag}{integer: locus_tag size}

\item{size_gene}{integer: font size for gene annotation.}

\item{Limit}{integer: value for y-axis limit.}

\item{shape}{integer: value for shape.}

\item{face}{string: label font.}

\item{tick_length}{integer: value for ticks.}

\item{arrow.color}{string: arrows color.}

\item{col_above20}{string: color for probes/bin above value 20.}

\item{fontface}{integer: font type}

\item{shape_above20}{integer: shape for probes/bins above value 20.}

\item{axis_text_y_size}{integer: text size for y-axis.}

\item{axis_title_y_size}{integer: title size for y-axis.}

\item{iTSS_threshold}{integer: threshold for iTSS_II selected to plot,
default 1.2.}

\item{p_value_manova}{integer: p_value of manova test fragments to plot,
default 0.05.}

\item{termination_threshold}{integer: threshold for termination to plot,
default .8.}
}
\value{
The plot.
}
\description{
rifi_visualization_comparison plots the genome annotation, half-life
difference (HL), log2FC(intensity) fragments. It uses several functions to
plot TUs and genes including small-RNAs. Additionally it plots the
statistical t-test between the neighboring fragment, significant p-values
from t-test are assigned with '*'.
}
\details{
The functions used are:

strand_selection: plots HL, intensity fragments from both strands.

splitGenome_function: splits the genome into fragments.

annotation_plot_comp: plots the corresponding annotation.

indice_function: assign a new column to the data to distinguish between
fragments, outliers from delay or HL or intensity.

empty_data_positive: plots empty boxes in case no data is available for
positive strand

empty_data_negative: plots empty boxes in case no data is available for
negative strand

TU_annotation: designs the segments border for the genes and TUs annotation.

gene_annot_function: it requires gff3 file, returns a dataframe adjusting
each fragment according to its annotation. It allows as well the plot of
genes and TUs shared into two pages.

secondaryAxis: adjusts the half-life or delay to 20 in case of the dataframe
row numbers is equal to 1 and the half-life or delay exceed the limit,
they are plotted with different shape and color.

my_arrow: creates an arrow for the annotation.

arrange_byGroup: selects the last row for each segment and add 40 nucleotides
in case of negative strand for a nice plot.

my_segment_T: plots terminals and pausing sites labels.
}
\examples{
data(data_combined_minimal)
data(stats_df_comb_minimal)
data(annot_g)
rifi_visualization_comparison(
    data = data_combined_minimal,
    data_c = stats_df_comb_minimal,
    genomeLength = annot_g[[2]],
    annot = annot_g[[1]]
    ) 
    
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/figures_fun.r
\name{figures_fun}
\alias{figures_fun}
\title{'figures_fun': generates several plots}
\usage{
figures_fun(
  data.1,
  data.2,
  input.1,
  input.2,
  cdt1,
  cdt2,
  y = 30,
  x = 30,
  limits = c(0, 20)
)
}
\arguments{
\item{data.1}{data frame output of statistic}

\item{data.2}{data frame joining two outputs from rifi_stats by row}

\item{input.1}{data frame joining two outputs from rifi_stats by column}

\item{input.2}{data frame of differential gene expression at time 0}

\item{cdt1}{string for the first condition}

\item{cdt2}{string for the second condition}

\item{y}{integer to break the scaling in scatter plot for y_axis}

\item{x}{integer to break the scaling in scatter plot for x_axis}

\item{limits}{vector to limit the scaling in scatter plot for both axis}
}
\value{
several plots
}
\description{
'figures_fun' plots at one the density of HL, the HL category as histogram,
log2FC of decay and synthesis rate and their heatscatter. Scatter plot of HL
and volcano plot. The function uses the four output generated previously.
}
\details{
The functions used are:

plot_decay_synt: plots the changes in RNA decay rates versus the changes
in RNA synthesis rates

plot_heatscatter: plots the changes in RNA decay rates versus the changes
in RNA synthesis rates with density.

plot_volcano: plots statistical significance  versus magnitude of change .

plot_histogram: plot a histogram of probe/bin half-life categories from
2 to 20 minutes in both conditions.

plot_density: plots the probe/bin half-life density in both conditions.

plot_scatter: plots of the bin/probe half-life in one condition1 vs.
condition2.

extract the object of rifi_statistics from both conditions.
The differential gene expression at time 0 needs to be run separately.
The columns log2FC, p_value adjusted, position and strand are extracted and
saved to a data frame. loading_fun_fig joins the differential gene expression
table and the output from rifi statistics into one data frame.
}
\examples{
data(data_combined_minimal)
data(df_comb_minimal)
data(differential_expression) 
data(df_mean_minimal)
figures_fun(data.1 = df_mean_minimal, data.2 = data_combined_minimal, 
input.1 = df_comb_minimal, input.2 = differential_expression, cdt1 = "sc", 
cdt2 = "fe") 

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statistics.r
\name{statistics}
\alias{statistics}
\title{statistics check segments significance using statistical test}
\usage{
statistics(data)
}
\arguments{
\item{data}{data frame: data frame output of fragmentation}
}
\value{
A list of two data frames, the first one contains all segments with
p_value and p_value adjusted. The second one removes the duplicated segments
from intensity and could be saved as an excel file.
}
\description{
statistics uses t-test to check HL and intensity segments significance. The
function returns the data frame with p_value and p_value adjusted.
The function used is t_test_function.
}
\examples{
data(fragment_int)
stats_df_comb_minimal <- statistics(data= fragment_int)[[1]]
df_comb_uniq_minimal <- statistics(data= fragment_int)[[2]]

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gff3_preprocess.r
\name{gff3_preprocess}
\alias{gff3_preprocess}
\title{gff3_preprocess processes gff3 file from database}
\usage{
gff3_preprocess(path)
}
\arguments{
\item{path}{path: path to the directory containing the gff3 file.}
}
\value{
A list with 2 items:
\describe{
\item{data annotation:}{
\describe{
\item{region:}{String, the region from the gff file}
\item{start:}{Integer, the start of the annotation}
\item{end:}{Integer, the end of the annotation}
\item{strand:}{Boolean, the strand of the annotation}
\item{gene:}{String, the annotated gene name}
\item{locus_tag:}{String, the annotated locus tag}
\item{genome length:}{a numeric vector containing the length of the
genome}
}
}
}
}
\description{
gff3_preprocess processes the gff3 file extracting gene names and locus_tag
from all coding regions (CDS). UTRs/ncRNA/asRNA if available, are also
extracted. The resulting dataframe contains region, positions, strand, gene
and locus_tag.
}
\examples{
gff3_preprocess(
path = gzfile(system.file("extdata", "gff_synechocystis_6803.gff.gz", 
package = "rifiComparative"))
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/adjusting_HLToInt.r
\name{adjusting_HLToInt}
\alias{adjusting_HLToInt}
\title{adjusting_HLToInt Creates one table merging HL and intensity fragments
with genome annotation}
\usage{
adjusting_HLToInt(data, Strand = c("+", "-"), annotation)
}
\arguments{
\item{data}{data frame: data frame combined data by column}

\item{Strand}{string: either "+" or "-"}

\item{annotation}{data frame: data frame from processed gff3 file.}
}
\value{
The data frame with the corresponding columns:
\describe{
\item{position:}{Integer, position of the first fragment}
\item{region:}{String, region annotation covering the fragments}
\item{gene:}{String, gene annotation covering the fragments}
\item{locus_tag:}{String, locus_tag annotation covering the fragments}
\item{strand:}{Boolean. The bin/probe specific strand (+/-)}
\item{fragment_HL:}{String, HL fragments}
\item{fragment_int:}{String, intensity fragments}
\item{position_frg_int:}{Integer, position of the first fragment and
the last position of the last fragment}
\item{mean_HL_fragment:}{Integer, mean of the HL of the fragments
involved}
\item{mean_int_fragment:}{Integer, mean of the intensity of the
fragments involved}
\item{log2FC(decay_rate):}{Integer, log2FC(decay(condition1)/
decay(condition2))}
\item{log2FC(synthesis_rate):}{Integer, sum of log2FC(decay_rate) and
log2FC(intensity)}
\item{intensity_FC:}{Integer, log2FC(mean(intensity(condition1))/mean(
intensity(condition2)))}
\item{Log2FC(HL)+Log2FC(int):}{Integer, sum of log2FC(decay_rate) and
log2FC(intensity)}
\item{p_value:}{String, indicated by "*" means at least one fragment
either HL fragment or intensity fragment has a significant p_value}
}
}
\description{
'adjusting_HLToInt' merges HL and intensity segments adapting the positions
to each other and combining to the genome annotation.
To make HL and intensity segments comparable, log2FC(HL) is used to generate
the data frame instead of distance.
The fragments should have a significant p_value from t-test at least from one
segmentation, either HL or intensity.
}
\details{
The functions used are:
\enumerate{
\item p_value_function extracts and return the p_values of HL and intensity
segments respectively.
\item eliminate_outlier_hl eliminates outliers from HL fragments.
\item eliminate_outlier_int eliminates outliers from intensity fragments.
\item mean_length_int calculates the mean of the log2FC(intensity) fragments
adapted to HL_fragments and their lengths
\item mean_length_hl calculates the mean of log2FC(HL) fragments adapted to the
intensity fragments and their lengths.
\item calculating_rate calculates decay rate and log2FC(intensity). Both are
used to calculate synthesis rate.
}
}
\examples{
data(stats_df_comb_minimal)
data(annot_g)
df_mean_minimal <- adjusting_HLToInt(data = stats_df_comb_minimal,
annotation = annot_g[[1]])

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rifiComparative.r
\docType{package}
\name{rifiComparative}
\alias{rifiComparative}
\title{\subsection{=============================================================================
rifiComparative}{

rifiComparative a successor package of rifi. It compares 2 rifi outputs from
2 different conditions of the same organism.
}}
\description{
rifiComparative was developed to compare 2 rifi outputs from 2 conditions.
The rifi output may differ significantly from 2 conditions. The complexity of
the segments number, position, length and the events make the comparison
between 2 conditions nearly impossible. rifiComparative uses a simple strategy
to generate single segments for both conditions, extract the features and
make them comparable.
}
\details{
Five major steps ate described in rifiComparative:
\enumerate{
\item Joining data
\item penalties
\item fragmentation
\item statistics
\item visualization
}
}
\author{
Loubna Youssar \email{lyoussar@gmail.com}

Jens Georg \email{jens.georg@biologie.uni-freiburg.de}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{df_mean_minimal}
\alias{df_mean_minimal}
\title{The result of adjusting_HLToInt for stats_df_comb_minimal and annotation
example data
A data frame containing the output of adjusting_HLToInt as a data frame}
\format{
A data frame with 52 rows and 15 variables:
\describe{
\item{position:}{The bin/probe specific position}
\item{region:}{the region from the gff file}
\item{gene:}{the annotated gene name}
\item{locus_tag:}{the annotated locus tag}
\item{strand:}{The strand specific}
\item{fragment_HL:}{The half-life fragment the bin belongs}
\item{fragment_int:}{The intensity fragment the bin belongs}
\item{position_frg_int:}{The position of the first fragment and the last
position of the last fragment}
\item{mean_HL_fragment:}{The mean half-life value of the respective
half-life fragments}
\item{mean_int_fragment:}{The mean intensity value of the respective
intensity fragments}
\item{log2FC(decay_rate):}{log2FC(decay(condition1)/decay(condition2))}
\item{Log2FC(HL)-Log2FC(int):}{log2FC(decay_rate/intensity)}
\item{log2FC(synthesis_rate):}{log2FC(decay_rate) +
log2FC(intensity)}
\item{intensity_FC:}{log2FC(mean(intensity(condition1))/mean(
intensity(condition2)))}
\item{p_value:}{indicated by "*" means at least one fragment
either HL fragment or intensity fragment has a significant p_value}
}
}
\source{
\url{https://github.com/CyanolabFreiburg/rifiComparative}
}
\usage{
data(df_mean_minimal)
}
\description{
The result of adjusting_HLToInt for stats_df_comb_minimal and annotation
example data
A data frame containing the output of adjusting_HLToInt as a data frame
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{annot_g}
\alias{annot_g}
\title{The result of gff3_preprocessing of gff3 file
A list containing all necessary information from a gff file for
adjusting_HLToInt and visualization.}
\format{
A list with 2 items:
\describe{
\item{data annotation:}{a data frame with 5853 rows and 6 variables
\describe{
\item{region:}{the region from the gff file}
\item{start:}{the start of the annotation}
\item{end:}{the end of the annotation}
\item{strand:}{the strand of the annotation}
\item{gene:}{the annotated gene name}
\item{locus_tag:}{the annotated locus tag}
}
}
\item{genome length:}{a numeric vector containing the length of the genome}
}
}
\source{
\url{https://github.com/CyanolabFreiburg/rifiComparative}
}
\usage{
data(annot_g)
}
\description{
The result of gff3_preprocessing of gff3 file
A list containing all necessary information from a gff file for
adjusting_HLToInt and visualization.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/loading_fun.r
\name{loading_fun}
\alias{loading_fun}
\title{loading_fun loads the data of all conditions}
\usage{
loading_fun(data1, data2, data3)
}
\arguments{
\item{data1}{data frame from rifi_stats of one condition}

\item{data2}{data frame from rifi_stats of other condition}

\item{data3}{data frame from differential gene expression at time 0}
}
\value{
A list of two data frames with joined columns from differential
expression and output of rifi_stats with the corresponding columns: ID with
position, strand, intensity, probe_TI, flag, position_segment, delay,
half_life, TI_termination_factor, delay_fragment, velocity_fragment,
intercept, slope, HL_fragment, HL_mean_fragment, intensity_fragment,
intensity_mean_fragment, TU, TI_termination_fragment,
TI_mean_termination_factor, seg_ID, pausing_site, iTSS_I, ps_ts_fragment,
event_ps_itss_p_value_Ttest, p_value_slope, delay_frg_slope, velocity_ratio,
event_duration, event_position, FC_HL, FC_fragment_HL, p_value_HL,
FC_intensity, FC_fragment_intensity, p_value_intensity, FC_HL_intensity,
FC_HL_intensity_fragment, FC_HL_adapted, synthesis_ratio,
synthesis_ratio_event, p_value_Manova, p_value_TI, cdt (condition),
logFC_int (log2FC(intensity)), P.Value of log2FC(intensity).
}
\description{
loading_fun extract outputs from rifi_stats of all conditions and join
each data to the differential expression table. The differential gene
expression at time 0 needs to be run separately.
The columns log2FC, p_value adjusted, position and strand are extracted and
saved to a data frame. loading_fun joins the differential gene expression
table and the output from rifi statistics into one data frame.
}
\examples{
data(stats_se_cdt1)
data(stats_se_cdt2)
data(differential_expression)
inp_s <-
loading_fun(stats_se_cdt1, stats_se_cdt2, differential_expression)[[1]]
inp_f <-
loading_fun(stats_se_cdt1, stats_se_cdt2, differential_expression)[[2]]

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/penalties.r
\name{penalties}
\alias{penalties}
\title{penalties wraps conveniently all penalty steps}
\usage{
penalties(data, cores = 2)
}
\arguments{
\item{data}{data frame with the joined columns from differential
expression and output of rifi_stats.}

\item{cores}{integer: the number of assigned cores for the task. It needs to
be increased in case of big data.}
}
\value{
A list of data frame and penalties, The first element is data frame
with 2 more variables, second and third are HL and intensity penalties
respectively.
}
\description{
penalties finds the best set of penalties for half-life and intensity
fragmentation using dynamic programming. The segmentation of the HL uses the
difference between 2 conditions and the segmentation of the intensity uses
the log2FC.
}
\details{
The function uses 4 functions:

score_fun_ave.r

make_pen.r

fragment_HL_pen.r

fragment_inty_pen.r
}
\examples{
data(df_comb_minimal) 
penalties_df <- penalties(df_comb_minimal)[[1]]
pen_HL <- penalties(df_comb_minimal)[[2]]
pen_int <- penalties(df_comb_minimal)[[3]]
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{df_comb_minimal}
\alias{df_comb_minimal}
\title{The result of joining_by_column for data_combined_minimal example data
A data frame containing the output of joining_by_row as a data frame}
\format{
A data frame with 300 rows and 18 variables:
\describe{
\item{strand:}{The strand specific}
\item{position:}{The bin/probe specific position}
\item{ID:}{The bin/probe specific ID}
\item{intensity.cdt1:}{The relative intensity at time point 0 for
condition 1}
\item{position_segment:}{The position based segment}
\item{half_life.cdt1:}{The half-life of the bin/probe condition 1}
\item{TI_termination_factor.cdt1:}{The termination factor of the bin/probe
condition 1}
\item{HL_fragment.cdt1:}{The half-life fragment the bin belongs to
condition 1}
\item{intensity_fragment.cdt1:}{The intensity fragment the bin belongs to
condition 1}
\item{TI_termination_fragment.cdt1:}{The TI fragment the bin belongs to
condition 1}
\item{logFC_int:}{The bin/probe log2 fold change of intensity at time 0}
\item{P.Value:}{The bin/probe p_value adjusted }
\item{intensity.cdt2:}{The relative intensity at time point 0
condition 2}
\item{half_life.cdt2:}{The half-life of the bin/probe condition 2}
\item{TI_termination_factor.cdt2:}{The termination factor of the bin/probe
condition 2}
\item{HL_fragment.cdt2:}{The half-life fragment the bin belongs to
condition 2}
\item{intensity_fragment.cdt2:}{The intensity fragment the bin belongs to
condition 2}
\item{TI_termination_fragment.cdt2:}{The TI fragment the bin belongs to
condition 2}
}
}
\source{
\url{https://github.com/CyanolabFreiburg/rifiComparative}
}
\usage{
data(df_comb_minimal)
}
\description{
The result of joining_by_column for data_combined_minimal example data
A data frame containing the output of joining_by_row as a data frame
}
\keyword{datasets}
